;
; StarTropics music fix
; by Brad Smith 11/19/2014
; http://rainwarrior.ca
;
; This is a modified version of a StarTropics music disassembly,
; changed to fix the broken accompaniment music in track 1,
; and broken bassline in track 30.
;
; Search for FIX to find the modified information in this file.
; See st_music.s for more information about StarTropics.
;

; exports for nsf.s

.exportzp  var_next_track
.export    var_dmc_counter
.export    init
.export    play

; RAM labels

var_next_track  := $00A0
var_current_track:= $00A1
var_extra_A2    := $00A2                        ; not used by NSF
var_extra_A3    := $00A3                        ; not used by NSF
var_extra_A4    := $00A4                        ; not used by NSF
var_extra_A5    := $00A5                        ; not used by NSF
var_ptr_extra_table_low:= $00A6                 ; not used by NSF
var_ptr_extra_table_high:= $00A8                ; not used by NSF
var_ptr_fade    := $00AA
var_ptr_pattern := $00AC                        ; current pattern during reading
var_temp_F0     := $00F0
var_temp_F2     := $00F2
var_temp_F3     := $00F3
var_temp_F4     := $00F4
var_temp_F5     := $00F5
var_temp_F6     := $00F6
var_temp_pattern_pos:= $00F7
var_channel_mask:= $7160                        ; stores state of $4015
var_ch_freq_high:= $7161                        ; stores state of $4003+ch
var_play_fade_speed:= $7166                     ; 0 = fast, 1 = slow
var_play_fade   := $7168
var_play_fade_pos:= $7169
var_current_channel:= $716A                     ; the channel currently updating
var_extra_ch_2  := $716B                        ; not used by NSF
var_dmc_counter := $716C                        ; stores state of $4011
var_extra_ch_4  := $716D                        ; not used by NSF
var_ch_halt     := $7170                        ; $FF to halt channel
var_ch_pattern_ptr_low:= $7176
var_ch_pattern_ptr_high:= $717C
var_ch_pattern_pos:= $7182
var_ch_update_speed:= $7188
var_ch_update_timer:= $718E
var_ch_volume   := $7194                        ; volume/duty/lc/env state
var_ch_note_len := $719A
var_ch_sweep    := $71A0                        ; hardware sweep state
var_ch_slide    := $71A6                        ; software pitch slide
var_ch_repeat   := $71AC                        ; repeat counter for BX command
var_ch_envelope_select:= $71B2                  ; 0 = no envelope, 1-16 selects 8-entry envelope from ENVELOPE_TABLE
var_ch_envelope_len:= $71B8                     ; length of envelope * 16
var_dmc_target  := $71BD                        ; DMC slides to this -4/+4 per frame
var_ch_envelope_pos:= $71BE                     ; position in envelope
var_ch_volume_slide:= $71C4
var_ch_volume_slide_speed:= $71CA               ; frames per volume slide
var_ch_volume_slide_timer:= $71D0               ; countdown from speed until volume slide
var_ch_repeat_point:= $71D6                     ; repeat point set by FC command
var_ch_repeat_point_count:= $71DC               ; repeat counter for FC/FB commands
var_ch_octave   := $71E2
var_ch_pitch_low:= $71E8
var_ch_pitch_high:= $71EE
var_ch_detune   := $71F4                        ; set by F8 command

.segment "BANK08"
BANK_TAG_08:
TRACK_PTR_TABLE:
        .byte   $08, $00
        ; TRACK_PTR_TABLE is indexed starting at 1
        .addr   TRACK_01_ORDER
        .addr   TRACK_02_ORDER
        .addr   TRACK_03_ORDER
        .addr   TRACK_04_ORDER
        .addr   TRACK_05_ORDER
        .addr   TRACK_06_ORDER
        .addr   TRACK_07_ORDER
        .addr   TRACK_08_ORDER
        .addr   TRACK_09_ORDER
        .addr   TRACK_0A_ORDER
        .addr   TRACK_0B_ORDER
        .addr   TRACK_0C_ORDER
        .addr   TRACK_0D_ORDER
        .addr   TRACK_0E_ORDER
        .addr   TRACK_0F_ORDER
        .addr   TRACK_10_ORDER
        .addr   TRACK_11_ORDER
        .addr   TRACK_12_ORDER
        .addr   TRACK_13_ORDER
        .addr   TRACK_14_ORDER
        .addr   TRACK_15_ORDER
        .addr   TRACK_16_ORDER
        .addr   TRACK_17_ORDER
        .addr   TRACK_18_ORDER
        .addr   TRACK_19_ORDER
        .addr   TRACK_1A_ORDER
        .addr   TRACK_1B_ORDER
        .addr   TRACK_1C_ORDER
        .addr   TRACK_1D_ORDER
        .addr   TRACK_1E_ORDER
        .addr   TRACK_1F_ORDER
        .addr   TRACK_20_ORDER
        .addr   TRACK_21_ORDER
        .addr   TRACK_22_ORDER
        .addr   TRACK_23_ORDER
TRACK_01_ORDER:
        .byte   $03,$00
        .addr   TRACK_01_CH0_PATTERN
        .byte   $01
;
; FIX
;
; replaced pointer to old broken pattern with pointer to fixed version
        ;.addr   TRACK_01_CH1_PATTERN
        .addr   TRACK_01_CH1_PATTERN_FIXED
;
; END FIX
;
        .byte   $05
        .addr   TRACK_01_CH5_PATTERN
        .byte   $03
        .addr   TRACK_01_CH3_PATTERN
;
; FIX
;
; I have annotated channels 0/1 of the original tune just to show the structure of the music
; and the original state of the data. The fixed version appears below, inserted into a
; previously unused space.
TRACK_01_CH0_PATTERN: ; track 1 square 1
        .byte   $06,$02,$17,$00  ; speed 6, duty 2 (square), volume constant 7, no sweep
        .byte   $C3,$10 ; envelope 3
        .byte   $FC,$FE ; repeat point
        .byte   $37,$03,$32,$03,$2B,$02,$00,$03,$2B,$01,$30,$02,$32,$02                  ; 0  g--d--b-...bc-d-
        .byte   $30,$03,$32,$03,$34,$02,$00,$08                                          ; 1  c--d--e-........
        .byte   $36,$03,$32,$03,$29,$02,$00,$03,$29,$01,$2B,$02,$30,$02                  ; 2  F--d--a-...ab-c-
        .byte   $2B,$03,$30,$03,$32,$02,$00,$03,$32,$01,$34,$01,$32,$01,$31,$01,$32,$01  ; 3  b--c--d-...dedCd
        .byte   $37,$03,$32,$03,$2B,$02,$00,$03,$2B,$01,$30,$02,$32,$02                  ; 4  g--d--b-...bc-d-
        .byte   $30,$03,$32,$03,$34,$02,$00,$08                                          ; 5  c--d--e-........
        .byte   $36,$03,$32,$03,$29,$02,$00,$03,$29,$01,$2B,$02,$30,$02                  ; 6  F--d--a-...ab-c-
        .byte   $2B,$03,$29,$03,$27,$02,$00,$08                                          ; 7  b--a--g-........
        .byte   $30,$08,$32,$02,$30,$01,$2B,$02,$29,$03                                  ; 8  c-------d-cb-a--
        .byte   $2B,$02,$30,$01,$32,$02,$2B,$03,$27,$02,$29,$01,$2B,$02,$24,$03          ; 9  b-cd-b--g-ab-e--
        .byte   $30,$08,$32,$02,$30,$02,$2B,$02,$29,$02                                  ; 10 c-------d-c-b-a-
        .byte   $2B,$10                                                                  ; 11 b---------------
        .byte   $30,$08,$32,$02,$30,$01,$2B,$02,$29,$03                                  ; 12 c-------d-cb-a--
        .byte   $2B,$02,$30,$01,$32,$02,$2B,$03,$27,$02,$29,$01,$2B,$02,$24,$03          ; 13 b-cd-b--g-ab-e--
        .byte   $30,$08,$32,$04,$34,$02,$36,$02                                          ; 14 c-------d---e-F-
        .byte   $37,$08,$39,$08                                                          ; 15 g-------a-------
        .byte   $FB,$00 ; go to repeat point (always)
        .byte   $FF ; halt (not used)
TRACK_01_CH1_PATTERN: ; track 1 square 2
        .byte   $16,$01,$14,$00 ; speed 6, duty 1, volume constant 4, no sweep
        .byte   $C5,$10 ; envelope 5
        .byte   $FC,$FE ; repeat point
        .byte   $00,$02,$2B,$01,$2B,$01,$00,$02,$32,$01,$32,$01 ; 0  ..bb..dd
        .byte   $00,$02,$2B,$01,$2B,$01,$00,$02,$32,$01,$32,$01 ;    ..bb..dd
        .byte   $00,$02,$30,$01,$30,$01,$00,$02,$34,$01,$34,$01 ; 1  ..cc..ee
        .byte   $00,$02,$30,$01,$30,$01,$00,$02,$34,$01,$34,$01 ;    ..cc..ee
        .byte   $00,$02,$32,$01,$32,$01,$00,$02,$36,$01,$36,$01 ; 2  ..dd..FF
        .byte   $00,$02,$32,$01,$32,$01,$00,$02,$36,$01,$36,$01 ;    ..dd..FF
        .byte   $00,$02,$2B,$01,$2B,$01,$00,$02,$32,$01,$32,$01 ; 3  ..bb..dd
        .byte   $00,$02,$32,$01,$32,$01,$00,$02,$36,$01,$36,$01 ;    ..dd..FF
        .byte   $00,$02,$2B,$01,$2B,$01,$00,$02,$32,$01,$32,$01 ; 4  ..bb..dd
        .byte   $00,$02,$2B,$01,$2B,$01,$00,$02,$32,$01,$32,$01 ;    ..bb..dd
        .byte   $00,$02,$30,$01,$30,$01,$00,$02,$34,$01,$34,$01 ; 5  ..cc..ee
        .byte   $00,$02,$30,$01,$30,$01,$00,$02,$34,$01,$34,$01 ;    ..cc..ee
        .byte   $00,$02,$32,$01,$32,$01,$00,$02,$36,$01,$36,$01 ; 6  ..dd..FF
        .byte   $00,$02,$32,$01,$32,$01,$00,$02,$36,$01,$36,$01 ;    ..dd..FF
        .byte   $00,$02,$2B,$01,$2B,$01,$00,$02,$32,$01,$32,$01 ; 7  ..bb..dd
        .byte   $00,$02,$2B,$01,$2B,$01,$00,$02,$32,$01,$32,$01 ;    ..bb..dd
        .byte   $00,$02,$30,$01,$30,$01,$00,$02,$34,$01,$34,$01 ; 8  ..cc..ee
        .byte   $00,$02,$32,$01,$32,$01,$00,$02,$36,$01,$36,$01 ;    ..dd..FF
        .byte   $00,$02,$2B,$01,$2B,$01,$00,$02,$32,$01,$32,$01 ; 9  ..bb..dd
        .byte   $00,$02,$27,$01,$27,$01,$00,$02,$2B,$01,$2B,$01 ;    ..gg..bb
        .byte   $00,$02,$30,$01,$30,$01,$00,$02,$34,$01,$34,$01 ; 10 ..cc..ee
        ;                                       ^^
        ; This point right here exceeds the 256 byte limit.
        ; Instead of continuing with the tune, it will read the header as commands:
        ;     $16, $01 ; F (duration: 1)
        ;     $14, $00 ; e (duration: 256)
        ; It will then resume from the beginning of the track and repeat indefinitely.
        .byte   $00,$02,$32,$01,$32,$01,$00,$02,$36,$01,$36,$01 ;    ..dd..FF
        .byte   $00,$02,$2B,$01,$2B,$01,$00,$02,$32,$01,$32,$01 ; 11 ..bb..dd
        .byte   $00,$02,$27,$01,$27,$01,$00,$02,$2B,$01,$2B,$01 ;    ..gg..bb
        .byte   $00,$02,$30,$01,$30,$01,$00,$02,$34,$01,$34,$01 ; 12 ..cc..ee
        .byte   $00,$02,$32,$01,$32,$01,$00,$02,$36,$01,$36,$01 ;    ..dd..FF
        .byte   $00,$02,$2B,$01,$2B,$01,$00,$02,$32,$01,$32,$01 ; 13 ..bb..dd
        .byte   $00,$02,$27,$01,$27,$01,$00,$02,$2B,$01,$2B,$01 ;    ..gg..bb
        .byte   $00,$02,$29,$01,$29,$01,$00,$02,$30,$01,$30,$01 ; 14 ..aa..cc
        .byte   $00,$02,$2B,$01,$2B,$01,$00,$02,$32,$01,$32,$01 ;    ..bb..dd
        .byte   $00,$02,$30,$01,$30,$01,$00,$02,$34,$01,$34,$01 ; 15 ..cc..ee
        .byte   $00,$02,$32,$01,$32,$01,$00,$02,$36,$01,$36,$01 ;    ..dd..FF
        .byte   $FB,$00 ; go to repeat point (always)
        ; 394 bytes total (138 bytes too long!)
;
; END FIX
;
TRACK_01_CH5_PATTERN:
        .byte   $26,$28,$10,$00,$FC,$FE,$17,$03
        .byte   $22,$03,$27,$02,$17,$03,$22,$03
        .byte   $27,$02,$20,$03,$27,$03,$30,$02
        .byte   $20,$03,$27,$03,$30,$02,$22,$03
        .byte   $29,$03,$32,$02,$22,$03,$29,$03
        .byte   $32,$02,$17,$03,$22,$03,$27,$02
        .byte   $22,$03,$29,$03,$32,$02,$17,$03
        .byte   $22,$03,$27,$02,$17,$03,$22,$03
        .byte   $27,$02,$20,$03,$27,$03,$30,$02
        .byte   $20,$03,$27,$03,$30,$02,$22,$03
        .byte   $29,$03,$32,$02,$22,$03,$29,$03
        .byte   $32,$02,$17,$03,$22,$03,$27,$02
        .byte   $17,$03,$22,$03,$27,$02,$20,$03
        .byte   $27,$03,$30,$02,$22,$03,$29,$03
        .byte   $32,$02,$17,$03,$22,$03,$27,$02
        .byte   $14,$03,$19,$03,$24,$02,$20,$03
        .byte   $27,$03,$30,$02,$22,$03,$29,$03
        .byte   $32,$02,$17,$03,$22,$03,$27,$02
        .byte   $14,$03,$19,$03,$24,$02,$20,$03
        .byte   $27,$03,$30,$02,$22,$03,$29,$03
        .byte   $32,$02,$17,$03,$22,$03,$27,$02
        .byte   $14,$03,$19,$03,$24,$02,$19,$03
        .byte   $24,$03,$29,$02,$1B,$03,$26,$03
        .byte   $2B,$02,$20,$03,$27,$03,$30,$02
        .byte   $22,$03,$29,$03,$32,$02,$FB,$00
        .byte   $FF
TRACK_01_CH3_PATTERN:
        .byte   $36,$00,$15,$00,$C5,$10,$FC,$FE
        .byte   $07,$04,$03,$04,$07,$01,$03,$03
        .byte   $07,$02,$03,$02,$FB,$00,$FF
TRACK_02_ORDER:
        .byte   $03,$00
        .addr   TRACK_02_CH0_PATTERN
        .byte   $01
        .addr   TRACK_02_CH1_PATTERN
        .byte   $05
        .addr   TRACK_02_CH5_PATTERN
        .byte   $03
        .addr   TRACK_02_CH3_PATTERN
TRACK_02_CH0_PATTERN:
        .byte   $07,$00,$17,$00,$C1,$10,$FC,$FE
        .byte   $29,$02,$2B,$02,$00,$02,$31,$02
        .byte   $00,$02,$33,$02,$35,$14,$33,$02
        .byte   $35,$02,$00,$02,$33,$02,$00,$02
        .byte   $31,$02,$00,$02,$2B,$04,$29,$02
        .byte   $27,$0C,$FB,$02,$FC,$FE,$2A,$02
        .byte   $30,$02,$32,$02,$30,$02,$00,$04
        .byte   $2A,$02,$30,$02,$32,$02,$30,$02
        .byte   $00,$04,$2A,$01,$30,$01,$32,$02
        .byte   $30,$02,$00,$02,$FB,$02,$B0,$DB
        .byte   $FF
TRACK_02_CH1_PATTERN:
        .byte   $17,$00,$17,$00,$C1,$10,$FC,$FE
        .byte   $25,$02,$27,$02,$00,$02,$29,$02
        .byte   $00,$02,$2B,$02,$31,$14,$2B,$02
        .byte   $31,$02,$00,$02,$2B,$02,$00,$02
        .byte   $29,$02,$00,$02,$27,$04,$25,$02
        .byte   $23,$0C,$FB,$02,$FC,$FE,$26,$02
        .byte   $28,$02,$2A,$02,$28,$02,$00,$04
        .byte   $26,$02,$28,$02,$2A,$02,$28,$02
        .byte   $00,$04,$26,$01,$28,$01,$2A,$02
        .byte   $28,$02,$00,$02,$FB,$02,$B0,$DB
        .byte   $FF
TRACK_02_CH5_PATTERN:
        .byte   $27,$28,$20,$00,$FC,$FE,$15,$02
        .byte   $15,$04,$15,$04,$15,$02,$15,$04
        .byte   $15,$04,$15,$04,$15,$02,$15,$02
        .byte   $15,$04,$15,$02,$15,$04,$15,$04
        .byte   $15,$04,$15,$04,$15,$02,$15,$04
        .byte   $15,$02,$15,$02,$15,$04,$FB,$02
        .byte   $FC,$FE,$16,$02,$FB,$20,$B0,$E7
        .byte   $FF
TRACK_02_CH3_PATTERN:
        .byte   $37,$00,$17,$00,$C5,$10,$FC,$FE
        .byte   $03,$02,$03,$04,$02,$04,$03,$02
        .byte   $03,$04,$03,$04,$02,$04,$03,$02
        .byte   $03,$02,$03,$04,$02,$02,$03,$04
        .byte   $03,$04,$03,$04,$02,$04,$03,$02
        .byte   $03,$04,$03,$02,$02,$02,$03,$04
        .byte   $FB,$02,$FC,$FE,$03,$02,$FB,$20
        .byte   $B0,$E7,$FF
TRACK_03_ORDER:
        .byte   $03,$00
        .addr   TRACK_03_CH0_PATTERN
        .byte   $01
        .addr   TRACK_03_CH1_PATTERN
        .byte   $05
        .addr   TRACK_03_CH5_PATTERN
        .byte   $03
        .addr   TRACK_03_CH3_PATTERN
TRACK_03_CH0_PATTERN:
        .byte   $06,$02,$17,$00,$C5,$10,$FC,$FE
        .byte   $30,$03,$34,$03,$37,$02,$35,$03
        .byte   $39,$05,$3B,$03,$37,$03,$32,$02
        .byte   $35,$03,$39,$05,$FB,$02,$C3,$10
        .byte   $FC,$FE,$27,$03,$30,$15,$2B,$02
        .byte   $29,$01,$27,$03,$25,$02,$24,$02
        .byte   $25,$01,$27,$11,$27,$02,$27,$02
        .byte   $25,$02,$24,$01,$22,$03,$20,$02
        .byte   $FB,$02,$FC,$FE,$30,$08,$2B,$02
        .byte   $29,$02,$27,$02,$24,$02,$20,$08
        .byte   $22,$02,$24,$01,$22,$05,$FB,$02
        .byte   $B0,$D6,$FF
TRACK_03_CH1_PATTERN:
        .byte   $16,$01,$13,$00,$C5,$10,$FC,$FE
        .byte   $20,$01,$24,$01,$27,$01,$24,$01
        .byte   $30,$01,$27,$01,$24,$01,$27,$01
        .byte   $20,$01,$25,$01,$29,$01,$25,$01
        .byte   $30,$01,$29,$01,$25,$01,$29,$01
        .byte   $1B,$01,$22,$01,$27,$01,$22,$01
        .byte   $2B,$01,$27,$01,$22,$01,$27,$01
        .byte   $20,$01,$25,$01,$29,$01,$25,$01
        .byte   $30,$01,$29,$01,$25,$01,$29,$01
        .byte   $FB,$02,$FC,$FE,$00,$02,$27,$01
        .byte   $27,$01,$00,$02,$27,$01,$27,$01
        .byte   $00,$02,$29,$01,$29,$01,$00,$02
        .byte   $29,$01,$29,$01,$00,$02,$2B,$01
        .byte   $2B,$01,$00,$02,$2B,$01,$2B,$01
        .byte   $00,$02,$29,$01,$29,$01,$00,$02
        .byte   $29,$01,$29,$01,$FB,$04,$C7,$20
        .byte   $FC,$FE,$24,$08,$22,$08,$20,$08
        .byte   $22,$08,$FB,$02,$B0,$BC,$FF
TRACK_03_CH5_PATTERN:
        .byte   $26,$28,$10,$00,$FC,$FE,$20,$03
        .byte   $27,$03,$30,$02,$15,$03,$20,$03
        .byte   $25,$02,$17,$03,$22,$03,$27,$02
        .byte   $15,$03,$20,$03,$25,$02,$FB,$06
        .byte   $FC,$FE,$19,$03,$24,$03,$29,$02
        .byte   $17,$03,$22,$03,$27,$02,$15,$03
        .byte   $20,$03,$25,$02,$17,$03,$22,$03
        .byte   $27,$02,$FB,$02,$B0,$E4,$FF
TRACK_03_CH3_PATTERN:
        .byte   $36,$00,$15,$00,$C5,$10,$FC,$FE
        .byte   $07,$03,$07,$01,$03,$02,$07,$02
        .byte   $FB,$00,$FF
TRACK_04_ORDER:
        .byte   $03,$00
        .addr   TRACK_04_CH0_PATTERN
        .byte   $01
        .addr   TRACK_04_CH1_PATTERN
        .byte   $05
        .addr   TRACK_04_CH5_PATTERN
        .byte   $03
        .addr   TRACK_04_CH3_PATTERN
TRACK_04_CH0_PATTERN:
        .byte   $06,$02,$16,$00,$C3,$18,$FC,$FE
        .byte   $27,$02,$29,$01,$2A,$01,$00,$01
        .byte   $30,$01,$00,$01,$32,$03,$30,$02
        .byte   $32,$02,$35,$02,$37,$03,$37,$01
        .byte   $00,$04,$37,$03,$37,$01,$00,$04
        .byte   $27,$02,$29,$01,$2A,$01,$00,$01
        .byte   $30,$01,$00,$01,$32,$03,$30,$02
        .byte   $32,$02,$35,$02,$27,$03,$27,$01
        .byte   $00,$04,$27,$03,$27,$01,$00,$04
        .byte   $FB,$02,$32,$08,$30,$01,$2A,$01
        .byte   $00,$01,$29,$01,$00,$01,$2A,$01
        .byte   $00,$01,$27,$09,$00,$02,$29,$01
        .byte   $2A,$01,$00,$01,$29,$01,$00,$01
        .byte   $25,$01,$22,$20,$32,$08,$30,$01
        .byte   $2A,$01,$00,$01,$29,$01,$00,$01
        .byte   $2A,$01,$00,$01,$27,$09,$00,$02
        .byte   $29,$01,$2A,$01,$00,$01,$29,$01
        .byte   $00,$01,$25,$01,$27,$20,$FC,$FE
        .byte   $23,$03,$23,$01,$00,$01,$23,$01
        .byte   $27,$01,$2A,$01,$32,$03,$30,$03
        .byte   $29,$02,$27,$08,$00,$02,$29,$01
        .byte   $2A,$01,$00,$01,$29,$01,$00,$01
        .byte   $25,$01,$FB,$02,$27,$20,$B0,$A8
        .byte   $FF
TRACK_04_CH1_PATTERN:
        .byte   $16,$01,$15,$00,$C5,$18,$FC,$FE
        .byte   $27,$02,$2A,$01,$22,$02,$25,$02
        .byte   $27,$02,$2A,$01,$22,$02,$27,$02
        .byte   $25,$02,$24,$02,$27,$01,$1A,$02
        .byte   $20,$02,$24,$02,$27,$01,$1A,$02
        .byte   $20,$02,$24,$02,$FB,$04,$FC,$FE
        .byte   $27,$03,$22,$02,$27,$02,$25,$02
        .byte   $25,$01,$20,$02,$20,$02,$25,$02
        .byte   $23,$03,$1A,$02,$23,$02,$25,$02
        .byte   $25,$01,$20,$02,$20,$02,$25,$02
        .byte   $FB,$04,$FC,$FE,$23,$03,$20,$02
        .byte   $23,$02,$27,$01,$25,$03,$22,$02
        .byte   $25,$02,$29,$01,$27,$03,$23,$02
        .byte   $27,$02,$2A,$01,$25,$03,$22,$02
        .byte   $25,$02,$29,$01,$FB,$02,$FC,$FE
        .byte   $27,$03,$22,$02,$25,$02,$27,$02
        .byte   $27,$01,$22,$02,$22,$02,$25,$02
        .byte   $FB,$02,$B0,$BD,$FF
TRACK_04_CH5_PATTERN:
        .byte   $26,$38,$10,$00,$FC,$FE,$17,$03
        .byte   $22,$03,$27,$02,$17,$03,$22,$03
        .byte   $27,$02,$20,$03,$27,$03,$30,$02
        .byte   $20,$03,$27,$03,$30,$02,$FB,$04
        .byte   $FC,$FE,$17,$03,$22,$03,$27,$02
        .byte   $15,$03,$20,$03,$25,$02,$13,$03
        .byte   $1A,$03,$23,$02,$15,$03,$20,$03
        .byte   $25,$02,$FB,$04,$FC,$FE,$10,$03
        .byte   $17,$03,$20,$02,$12,$03,$19,$03
        .byte   $22,$02,$13,$03,$1A,$03,$23,$02
        .byte   $15,$03,$20,$03,$25,$02,$FB,$02
        .byte   $FC,$FE,$17,$03,$22,$03,$27,$02
        .byte   $FB,$04,$B0,$D1,$FF
TRACK_04_CH3_PATTERN:
        .byte   $36,$00,$15,$00,$C5,$10,$FC,$FE
        .byte   $07,$03,$07,$01,$03,$03,$07,$01
        .byte   $FB,$00,$FF
TRACK_05_ORDER:
        .byte   $03,$00
        .addr   TRACK_05_CH0_PATTERN
        .byte   $01
        .addr   TRACK_05_CH1_PATTERN
        .byte   $05
        .addr   TRACK_05_CH5_PATTERN
        .byte   $03
        .addr   TRACK_05_CH3_PATTERN
TRACK_05_CH0_PATTERN:
        .byte   $01,$00,$17,$00,$C1,$18,$FC,$FE
        .byte   $34,$03,$FB,$05,$00,$0F,$FC,$FE
        .byte   $34,$03,$FB,$04,$00,$06,$FC,$FE
        .byte   $34,$03,$FB,$05,$00,$0F,$FC,$FE
        .byte   $34,$03,$FB,$04,$00,$06,$C1,$18
        .byte   $FC,$FE,$2A,$09,$2A,$03,$00,$03
        .byte   $2A,$03,$00,$03,$2A,$03,$2A,$03
        .byte   $00,$03,$30,$03,$00,$03,$2A,$03
        .byte   $00,$03,$30,$03,$00,$03,$2A,$03
        .byte   $2A,$03,$00,$03,$2A,$03,$00,$03
        .byte   $2A,$03,$00,$03,$2A,$03,$2A,$03
        .byte   $00,$03,$30,$03,$00,$03,$2A,$03
        .byte   $00,$03,$30,$03,$00,$03,$2B,$09
        .byte   $2B,$03,$00,$03,$2B,$03,$00,$03
        .byte   $2B,$03,$2B,$03,$00,$03,$31,$03
        .byte   $00,$03,$2B,$03,$00,$03,$31,$03
        .byte   $00,$03,$2B,$03,$2B,$03,$00,$03
        .byte   $2B,$03,$00,$03,$2B,$03,$00,$03
        .byte   $2B,$03,$2B,$03,$00,$03,$31,$03
        .byte   $00,$03,$2B,$03,$00,$03,$31,$03
        .byte   $00,$03,$FB,$02,$35,$08,$33,$08
        .byte   $31,$08,$33,$08,$31,$08,$2B,$08
        .byte   $31,$08,$2B,$08,$29,$08,$2B,$08
        .byte   $29,$08,$27,$08,$B0,$B5,$FF
TRACK_05_CH1_PATTERN:
        .byte   $11,$00,$17,$00,$C1,$18,$FC,$FE
        .byte   $32,$03,$FB,$05,$00,$0F,$FC,$FE
        .byte   $32,$03,$FB,$04,$00,$06,$FC,$FE
        .byte   $32,$03,$FB,$05,$00,$0F,$FC,$FE
        .byte   $32,$03,$FB,$04,$00,$06,$C1,$18
        .byte   $FC,$FE,$26,$09,$26,$03,$00,$03
        .byte   $26,$03,$00,$03,$26,$03,$26,$03
        .byte   $00,$03,$28,$03,$00,$03,$26,$03
        .byte   $00,$03,$28,$03,$00,$03,$26,$03
        .byte   $26,$03,$00,$03,$26,$03,$00,$03
        .byte   $26,$03,$00,$03,$26,$03,$26,$03
        .byte   $00,$03,$28,$03,$00,$03,$26,$03
        .byte   $00,$03,$28,$03,$00,$03,$27,$09
        .byte   $27,$03,$00,$03,$27,$03,$00,$03
        .byte   $27,$03,$27,$03,$00,$03,$29,$03
        .byte   $00,$03,$27,$03,$00,$03,$29,$03
        .byte   $00,$03,$27,$03,$27,$03,$00,$03
        .byte   $27,$03,$00,$03,$27,$03,$00,$03
        .byte   $27,$03,$27,$03,$00,$03,$29,$03
        .byte   $00,$03,$27,$03,$00,$03,$29,$03
        .byte   $00,$03,$FB,$02,$31,$08,$2B,$08
        .byte   $29,$08,$2B,$08,$29,$08,$27,$08
        .byte   $29,$08,$27,$08,$25,$08,$27,$08
        .byte   $25,$08,$23,$08,$B0,$B5,$FF
TRACK_05_CH5_PATTERN:
        .byte   $21,$28,$10,$00,$FC,$FE,$2B,$03
        .byte   $FB,$05,$00,$0F,$FC,$FE,$2B,$03
        .byte   $FB,$04,$00,$06,$FC,$FE,$2B,$03
        .byte   $FB,$05,$00,$0F,$FC,$FE,$2B,$03
        .byte   $FB,$04,$00,$06,$FC,$FE,$16,$06
        .byte   $20,$03,$20,$03,$FB,$08,$FC,$FE
        .byte   $17,$06,$21,$03,$21,$03,$FB,$08
        .byte   $FC,$FE,$16,$06,$20,$03,$20,$03
        .byte   $FB,$08,$FC,$FE,$17,$06,$21,$03
        .byte   $21,$03,$FB,$08,$29,$08,$27,$08
        .byte   $25,$08,$27,$08,$25,$08,$23,$08
        .byte   $25,$08,$23,$08,$21,$08,$23,$08
        .byte   $21,$08,$1B,$08,$B0,$E0,$FF
TRACK_05_CH3_PATTERN:
        .byte   $31,$00,$17,$00,$C5,$10,$FC,$FE
        .byte   $03,$03,$FB,$05,$00,$0F,$FC,$FE
        .byte   $03,$03,$FB,$04,$00,$06,$FC,$FE
        .byte   $03,$03,$FB,$05,$00,$0F,$FC,$FE
        .byte   $03,$03,$FB,$04,$00,$06,$C5,$10
        .byte   $FC,$FE,$03,$09,$03,$06,$03,$06
        .byte   $03,$03,$03,$06,$03,$06,$03,$06
        .byte   $03,$06,$03,$03,$03,$06,$03,$06
        .byte   $03,$06,$03,$03,$03,$06,$03,$06
        .byte   $03,$06,$03,$06,$FB,$04,$FC,$FE
        .byte   $03,$08,$FB,$0C,$B0,$EA,$FF
TRACK_06_ORDER:
        .byte   $02,$00
        .addr   TRACK_06_CH0_PATTERN
        .byte   $01
        .addr   TRACK_06_CH1_PATTERN
        .byte   $05
        .addr   TRACK_06_CH5_PATTERN
TRACK_06_CH0_PATTERN:
        .byte   $0E,$01,$1A,$00,$C1,$10,$24,$01
        .byte   $27,$01,$30,$01,$32,$01,$34,$01
        .byte   $35,$01,$37,$01,$32,$01,$FC,$FE
        .byte   $30,$04,$32,$01,$30,$01,$32,$02
        .byte   $FB,$02,$34,$06,$FF
TRACK_06_CH1_PATTERN:
        .byte   $1E,$01,$1A,$00,$C1,$10,$20,$01
        .byte   $24,$01,$27,$01,$2B,$01,$30,$01
        .byte   $32,$01,$34,$01,$2B,$01,$29,$04
        .byte   $2B,$01,$29,$01,$2B,$02,$28,$04
        .byte   $2A,$01,$28,$01,$2A,$02,$27,$06
        .byte   $FF
TRACK_06_CH5_PATTERN:
        .byte   $2E,$28,$7F,$00,$FC,$FE,$30,$01
        .byte   $FB,$02,$FC,$FE,$2B,$01,$FB,$02
        .byte   $FC,$FE,$29,$01,$FB,$02,$FC,$FE
        .byte   $27,$01,$FB,$02,$FC,$FE,$25,$01
        .byte   $FB,$04,$FC,$FE,$27,$01,$FB,$04
        .byte   $FC,$FE,$28,$01,$FB,$04,$FC,$FE
        .byte   $2A,$01,$FB,$04,$FC,$FE,$30,$01
        .byte   $FB,$06,$FF
TRACK_07_ORDER:
        .byte   $03,$00
        .addr   TRACK_07_CH0_PATTERN
        .byte   $01
        .addr   TRACK_07_CH1_PATTERN
        .byte   $05
        .addr   TRACK_07_CH5_PATTERN
        .byte   $03
        .addr   TRACK_07_CH3_PATTERN
TRACK_07_CH0_PATTERN:
        .byte   $06,$00,$17,$00,$C1,$10,$FC,$FE
        .byte   $00,$02,$2A,$02,$28,$02,$27,$02
        .byte   $28,$02,$2A,$02,$28,$02,$27,$02
        .byte   $27,$02,$28,$02,$27,$02,$25,$02
        .byte   $24,$04,$25,$02,$00,$02,$FB,$02
        .byte   $FC,$FE,$00,$02,$31,$02,$32,$02
        .byte   $34,$02,$00,$02,$31,$02,$32,$02
        .byte   $34,$02,$00,$02,$31,$02,$32,$02
        .byte   $34,$02,$34,$01,$00,$01,$35,$01
        .byte   $00,$01,$34,$04,$FB,$02,$B0,$DB
        .byte   $FF
TRACK_07_CH1_PATTERN:
        .byte   $16,$00,$17,$00,$C1,$10,$FC,$FE
        .byte   $00,$02,$27,$02,$25,$02,$24,$02
        .byte   $25,$02,$27,$02,$25,$02,$24,$02
        .byte   $24,$02,$25,$02,$24,$02,$22,$02
        .byte   $21,$04,$22,$02,$00,$02,$FB,$02
        .byte   $FC,$FE,$00,$02,$2A,$02,$2B,$02
        .byte   $31,$02,$00,$02,$2A,$02,$2B,$02
        .byte   $31,$02,$00,$02,$2A,$02,$2B,$02
        .byte   $31,$02,$31,$01,$00,$01,$32,$01
        .byte   $00,$01,$31,$04,$FB,$02,$B0,$DB
        .byte   $FF
TRACK_07_CH5_PATTERN:
        .byte   $26,$28,$20,$00,$FC,$FE,$1A,$02
        .byte   $1B,$02,$22,$02,$21,$02,$FB,$00
        .byte   $FF
TRACK_07_CH3_PATTERN:
        .byte   $36,$00,$17,$00,$C5,$10,$FC,$FE
        .byte   $03,$02,$03,$02,$06,$02,$FB,$00
        .byte   $FF
TRACK_08_ORDER:
        .byte   $02,$00
        .addr   TRACK_08_CH0_PATTERN
        .byte   $01
        .addr   TRACK_08_CH1_PATTERN
        .byte   $05
        .addr   TRACK_08_CH5_PATTERN
TRACK_08_CH0_PATTERN:
        .byte   $07,$02,$14,$00,$FC,$FE,$00,$02
        .byte   $32,$02,$31,$02,$32,$02,$2A,$02
        .byte   $32,$02,$29,$02,$32,$02,$27,$02
        .byte   $32,$02,$25,$02,$32,$02,$27,$02
        .byte   $25,$02,$24,$02,$22,$02,$FB,$03
        .byte   $24,$02,$25,$02,$27,$02,$25,$02
        .byte   $24,$02,$22,$02,$21,$02,$22,$02
        .byte   $21,$02,$1A,$02,$19,$02,$1A,$02
        .byte   $19,$08,$1A,$0A,$21,$02,$22,$02
        .byte   $24,$02,$25,$0A,$24,$02,$25,$02
        .byte   $27,$02,$24,$20,$22,$0A,$21,$02
        .byte   $22,$02,$24,$02,$25,$0A,$24,$02
        .byte   $25,$02,$27,$02,$29,$20,$B0,$CF
        .byte   $FF
TRACK_08_CH1_PATTERN:
        .byte   $17,$02,$12,$00,$00,$01,$FC,$FE
        .byte   $00,$02,$32,$02,$31,$02,$32,$02
        .byte   $2A,$02,$32,$02,$29,$02,$32,$02
        .byte   $27,$02,$32,$02,$25,$02,$32,$02
        .byte   $27,$02,$25,$02,$24,$02,$22,$02
        .byte   $FB,$03,$24,$02,$25,$02,$27,$02
        .byte   $25,$02,$24,$02,$22,$02,$21,$02
        .byte   $22,$02,$21,$02,$1A,$02,$19,$02
        .byte   $1A,$02,$19,$08,$1A,$0A,$21,$02
        .byte   $22,$02,$24,$02,$25,$0A,$24,$02
        .byte   $25,$02,$27,$02,$24,$20,$22,$0A
        .byte   $21,$02,$22,$02,$24,$02,$25,$0A
        .byte   $24,$02,$25,$02,$27,$02,$29,$20
        .byte   $B0,$CF,$FF
TRACK_08_CH5_PATTERN:
        .byte   $27,$38,$7F,$00,$FC,$FE,$22,$01
        .byte   $FB,$20,$FC,$FE,$1A,$01,$FB,$20
        .byte   $FC,$FE,$17,$01,$FB,$20,$FC,$FE
        .byte   $19,$01,$FB,$20,$FC,$FE,$1A,$01
        .byte   $00,$01,$FB,$10,$FC,$FE,$19,$01
        .byte   $00,$01,$FB,$10,$FC,$FE,$1A,$01
        .byte   $00,$01,$FB,$10,$FC,$FE,$19,$01
        .byte   $00,$01,$FB,$10,$B0,$E4,$FF
TRACK_09_ORDER:
        .byte   $03,$00
        .addr   TRACK_09_CH0_PATTERN
        .byte   $01
        .addr   TRACK_09_CH1_PATTERN
        .byte   $05
        .addr   TRACK_09_CH5_PATTERN
        .byte   $03
        .addr   TRACK_09_CH3_PATTERN
TRACK_09_CH0_PATTERN:
        .byte   $07,$02,$17,$00,$C3,$10,$29,$01
        .byte   $00,$02,$24,$01,$00,$02,$29,$01
        .byte   $00,$01,$29,$01,$00,$02,$26,$01
        .byte   $00,$02,$29,$01,$00,$01,$2B,$01
        .byte   $00,$02,$28,$01,$00,$02,$2B,$01
        .byte   $00,$02,$29,$01,$00,$01,$29,$01
        .byte   $29,$01,$FF
TRACK_09_CH1_PATTERN:
        .byte   $17,$02,$17,$00,$C3,$10,$21,$01
        .byte   $00,$02,$19,$01,$00,$02,$21,$01
        .byte   $00,$01,$22,$01,$00,$02,$19,$01
        .byte   $00,$02,$22,$01,$00,$01,$24,$01
        .byte   $00,$02,$1B,$01,$00,$02,$24,$01
        .byte   $00,$02,$21,$01,$00,$01,$21,$01
        .byte   $21,$01,$FF
TRACK_09_CH5_PATTERN:
        .byte   $27,$28,$18,$00,$19,$03,$24,$03
        .byte   $29,$02,$22,$03,$29,$03,$32,$02
        .byte   $24,$03,$2B,$03,$34,$03,$19,$02
        .byte   $19,$01,$19,$01,$FF
TRACK_09_CH3_PATTERN:
        .byte   $37,$00,$16,$00,$C5,$10,$FC,$FE
        .byte   $06,$03,$06,$01,$03,$02,$06,$02
        .byte   $FB,$03,$00,$01,$03,$02,$03,$01
        .byte   $03,$01,$FF
TRACK_0A_ORDER:
        .byte   $03,$00
        .addr   TRACK_0A_CH0_PATTERN
        .byte   $01
        .addr   TRACK_0A_CH1_PATTERN
        .byte   $05
        .addr   TRACK_0A_CH5_PATTERN
        .byte   $03
        .addr   TRACK_0A_CH3_PATTERN
TRACK_0A_CH0_PATTERN:
        .byte   $06,$00,$17,$00,$C3,$10,$39,$01
        .byte   $36,$01,$33,$01,$30,$01,$36,$01
        .byte   $33,$01,$30,$01,$29,$01,$33,$01
        .byte   $30,$01,$29,$01,$26,$01,$30,$01
        .byte   $29,$01,$26,$01,$23,$01,$29,$01
        .byte   $26,$01,$23,$01,$20,$01,$26,$01
        .byte   $23,$01,$20,$01,$19,$01,$23,$01
        .byte   $20,$01,$19,$01,$16,$01,$20,$01
        .byte   $19,$01,$16,$01,$13,$01,$16,$0C
        .byte   $FF
TRACK_0A_CH1_PATTERN:
        .byte   $16,$00,$17,$00,$C3,$10,$36,$01
        .byte   $33,$01,$30,$01,$29,$01,$33,$01
        .byte   $30,$01,$29,$01,$26,$01,$30,$01
        .byte   $29,$01,$26,$01,$23,$01,$29,$01
        .byte   $26,$01,$23,$01,$20,$01,$26,$01
        .byte   $23,$01,$20,$01,$19,$01,$23,$01
        .byte   $20,$01,$19,$01,$16,$01,$20,$01
        .byte   $19,$01,$16,$01,$13,$01,$19,$01
        .byte   $16,$01,$13,$01,$10,$01,$13,$0C
        .byte   $FF
TRACK_0A_CH5_PATTERN:
        .byte   $26,$28,$10,$00,$FC,$FE,$20,$01
        .byte   $23,$01,$26,$01,$29,$01,$FB,$08
        .byte   $FD,$7F,$FC,$FE,$19,$01,$FB,$0C
        .byte   $FF
TRACK_0A_CH3_PATTERN:
        .byte   $36,$00,$16,$00,$C5,$10,$FC,$FE
        .byte   $03,$01,$FB,$21,$FF
TRACK_0B_ORDER:
        .byte   $03,$00
        .addr   TRACK_0B_CH0_PATTERN
        .byte   $01
        .addr   TRACK_0B_CH1_PATTERN
        .byte   $05
        .addr   TRACK_0B_CH5_PATTERN
        .byte   $03
        .addr   TRACK_0B_CH3_PATTERN
TRACK_0B_CH0_PATTERN:
        .byte   $07,$02,$1A,$00,$C3,$10,$FC,$FE
        .byte   $37,$03,$34,$03,$30,$02,$35,$03
        .byte   $32,$03,$2A,$02,$33,$03,$30,$03
        .byte   $28,$02,$35,$03,$32,$03,$2A,$02
        .byte   $FB,$02,$24,$02,$24,$01,$25,$01
        .byte   $00,$01,$27,$01,$00,$01,$30,$05
        .byte   $27,$02,$24,$02,$29,$03,$29,$01
        .byte   $00,$0C,$26,$02,$26,$01,$27,$01
        .byte   $00,$01,$29,$01,$00,$01,$32,$05
        .byte   $29,$02,$26,$02,$2B,$03,$2B,$01
        .byte   $00,$0C,$28,$02,$28,$01,$29,$01
        .byte   $00,$01,$2B,$01,$00,$01,$34,$05
        .byte   $2B,$02,$28,$02,$30,$03,$30,$01
        .byte   $00,$0A,$30,$01,$2B,$01,$29,$03
        .byte   $29,$01,$00,$01,$29,$01,$2B,$01
        .byte   $30,$01,$2B,$03,$2B,$01,$00,$01
        .byte   $2B,$01,$30,$01,$32,$01,$30,$01
        .byte   $00,$02,$2A,$01,$2A,$01,$00,$01
        .byte   $30,$01,$30,$01,$00,$01,$2A,$01
        .byte   $00,$01,$2A,$01,$30,$02,$2A,$02
        .byte   $2A,$01,$2A,$01,$00,$01,$2A,$01
        .byte   $00,$01,$2A,$01,$30,$02,$FF
TRACK_0B_CH1_PATTERN:
        .byte   $17,$02,$1A,$00,$C3,$10,$FC,$FE
        .byte   $34,$03,$30,$03,$27,$02,$32,$03
        .byte   $2A,$03,$25,$02,$30,$03,$28,$03
        .byte   $23,$02,$32,$03,$2A,$03,$25,$02
        .byte   $FB,$02,$20,$02,$20,$01,$22,$01
        .byte   $00,$01,$24,$01,$00,$01,$27,$05
        .byte   $24,$02,$20,$02,$25,$03,$25,$01
        .byte   $00,$0C,$22,$02,$22,$01,$24,$01
        .byte   $00,$01,$26,$01,$00,$01,$29,$05
        .byte   $26,$02,$22,$02,$27,$03,$27,$01
        .byte   $00,$0C,$24,$02,$24,$01,$26,$01
        .byte   $00,$01,$28,$01,$00,$01,$2B,$05
        .byte   $28,$02,$24,$02,$29,$03,$29,$01
        .byte   $00,$0A,$29,$01,$27,$01,$25,$03
        .byte   $25,$01,$00,$01,$25,$01,$27,$01
        .byte   $29,$01,$27,$03,$27,$01,$00,$01
        .byte   $27,$01,$29,$01,$2B,$01,$27,$01
        .byte   $00,$02,$25,$01,$25,$01,$00,$01
        .byte   $27,$01,$27,$01,$00,$01,$25,$01
        .byte   $00,$01,$25,$01,$27,$02,$25,$02
        .byte   $25,$01,$25,$01,$00,$01,$25,$01
        .byte   $00,$01,$25,$01,$27,$02,$FF
TRACK_0B_CH5_PATTERN:
        .byte   $27,$28,$20,$00,$FC,$FE,$20,$03
        .byte   $27,$03,$30,$02,$1A,$03,$25,$03
        .byte   $2A,$02,$18,$03,$23,$03,$28,$02
        .byte   $1A,$03,$25,$03,$2A,$02,$FB,$02
        .byte   $FC,$FE,$20,$03,$27,$03,$30,$02
        .byte   $FB,$02,$FC,$FE,$15,$03,$20,$03
        .byte   $25,$02,$FB,$02,$FC,$FE,$22,$03
        .byte   $29,$03,$32,$02,$FB,$02,$FC,$FE
        .byte   $17,$03,$22,$03,$27,$02,$FB,$02
        .byte   $FC,$FE,$24,$03,$2B,$03,$34,$02
        .byte   $FB,$02,$FC,$FE,$19,$03,$24,$03
        .byte   $29,$02,$FB,$02,$15,$03,$20,$03
        .byte   $25,$02,$17,$03,$22,$03,$27,$02
        .byte   $20,$01,$00,$02,$1A,$01,$1A,$01
        .byte   $00,$01,$20,$01,$20,$01,$00,$01
        .byte   $1A,$01,$00,$01,$1A,$01,$20,$02
        .byte   $1A,$02,$1A,$01,$1A,$01,$00,$01
        .byte   $1A,$01,$00,$01,$1A,$01,$20,$02
        .byte   $FF
TRACK_0B_CH3_PATTERN:
        .byte   $37,$00,$17,$00,$C5,$10,$FC,$FE
        .byte   $07,$03,$07,$01,$03,$02,$07,$02
        .byte   $FB,$16,$20,$01,$00,$02,$03,$01
        .byte   $03,$01,$00,$01,$03,$01,$03,$01
        .byte   $00,$01,$03,$01,$00,$01,$03,$01
        .byte   $03,$02,$03,$02,$03,$01,$03,$01
        .byte   $00,$01,$03,$01,$00,$01,$03,$01
        .byte   $03,$02,$FF
TRACK_0C_ORDER:
        .byte   $03,$00
        .addr   TRACK_0C_CH0_PATTERN
        .byte   $01
        .addr   TRACK_0C_CH1_PATTERN
        .byte   $05
        .addr   TRACK_0C_CH5_PATTERN
        .byte   $03
        .addr   TRACK_0C_CH3_PATTERN
TRACK_0C_CH0_PATTERN:
        .byte   $06,$02,$18,$00,$C3,$10,$FC,$FE
        .byte   $29,$08,$27,$01,$29,$01,$00,$01
        .byte   $2A,$01,$00,$01,$29,$01,$00,$01
        .byte   $27,$01,$25,$08,$24,$01,$25,$01
        .byte   $00,$01,$27,$01,$00,$01,$24,$01
        .byte   $00,$01,$20,$01,$22,$08,$20,$04
        .byte   $25,$04,$2A,$04,$29,$04,$25,$04
        .byte   $27,$04,$29,$0E,$27,$01,$29,$01
        .byte   $27,$02,$24,$01,$20,$0D,$29,$0C
        .byte   $27,$02,$29,$02,$30,$04,$2A,$04
        .byte   $29,$04,$27,$04,$FB,$02,$25,$03
        .byte   $25,$01,$00,$01,$25,$01,$00,$01
        .byte   $25,$01,$25,$08,$27,$03,$27,$01
        .byte   $00,$01,$27,$01,$00,$01,$27,$01
        .byte   $27,$08,$29,$20,$B0,$C9,$FF
TRACK_0C_CH1_PATTERN:
        .byte   $16,$02,$18,$00,$C3,$10,$FC,$FE
        .byte   $25,$08,$24,$01,$25,$01,$00,$01
        .byte   $27,$01,$00,$01,$25,$01,$00,$01
        .byte   $24,$01,$22,$08,$20,$01,$22,$01
        .byte   $00,$01,$24,$01,$00,$01,$20,$01
        .byte   $00,$01,$19,$01,$1A,$08,$19,$04
        .byte   $22,$04,$27,$04,$25,$04,$22,$04
        .byte   $24,$04,$25,$0E,$24,$01,$25,$01
        .byte   $24,$02,$20,$01,$19,$0D,$25,$0C
        .byte   $24,$02,$25,$02,$29,$04,$27,$04
        .byte   $25,$04,$24,$04,$FB,$02,$1A,$03
        .byte   $1A,$01,$00,$01,$1A,$01,$00,$01
        .byte   $1A,$01,$1A,$08,$23,$03,$23,$01
        .byte   $00,$01,$23,$01,$00,$01,$23,$01
        .byte   $23,$08,$25,$20,$B0,$C9,$FF
TRACK_0C_CH5_PATTERN:
        .byte   $26,$28,$12,$00,$FC,$FE,$25,$03
        .byte   $30,$03,$35,$02,$24,$03,$2B,$03
        .byte   $34,$02,$22,$03,$29,$03,$32,$02
        .byte   $20,$03,$27,$03,$30,$02,$1A,$03
        .byte   $25,$03,$2A,$02,$19,$03,$24,$03
        .byte   $29,$02,$17,$03,$22,$03,$27,$02
        .byte   $20,$03,$27,$03,$30,$02,$1A,$03
        .byte   $25,$03,$2A,$02,$1A,$03,$25,$03
        .byte   $2A,$02,$20,$03,$27,$03,$30,$02
        .byte   $20,$03,$27,$03,$30,$02,$1A,$03
        .byte   $25,$03,$2A,$02,$1A,$03,$25,$03
        .byte   $2A,$02,$20,$03,$27,$03,$30,$02
        .byte   $20,$03,$27,$03,$30,$02,$FB,$02
        .byte   $21,$03,$28,$03,$31,$02,$21,$03
        .byte   $28,$03,$31,$02,$23,$03,$2A,$03
        .byte   $33,$02,$23,$03,$2A,$03,$33,$02
        .byte   $FC,$FE,$25,$03,$30,$03,$35,$02
        .byte   $FB,$04,$B0,$BD,$FF
TRACK_0C_CH3_PATTERN:
        .byte   $36,$00,$16,$00,$C5,$10,$FC,$FE
        .byte   $07,$03,$07,$01,$03,$02,$07,$02
        .byte   $FB,$00,$FF
TRACK_0D_ORDER:
        .byte   $02,$00
        .addr   TRACK_0D_CH0_PATTERN
        .byte   $01
        .addr   TRACK_0D_CH1_PATTERN
        .byte   $05
        .addr   TRACK_0D_CH5_PATTERN
TRACK_0D_CH0_PATTERN:
        .byte   $06,$01,$19,$00,$C1,$18,$32,$02
        .byte   $31,$02,$2A,$02,$29,$02,$27,$02
        .byte   $25,$02,$24,$02,$22,$02,$21,$06
        .byte   $22,$02,$22,$04,$FF
TRACK_0D_CH1_PATTERN:
        .byte   $16,$01,$19,$00,$C1,$18,$2A,$02
        .byte   $29,$02,$27,$02,$25,$02,$24,$02
        .byte   $22,$02,$20,$02,$1A,$02,$19,$06
        .byte   $15,$02,$15,$04,$FF
TRACK_0D_CH5_PATTERN:
        .byte   $26,$28,$7F,$00,$FC,$FE,$27,$01
        .byte   $FB,$08,$FC,$FE,$2A,$01,$FB,$08
        .byte   $FC,$FE,$24,$01,$FB,$06,$FC,$FE
        .byte   $22,$01,$FB,$02,$FC,$FE,$22,$01
        .byte   $FB,$04,$FF
TRACK_0E_ORDER:
        .byte   $02,$00
        .addr   TRACK_0E_CH0_PATTERN
        .byte   $01
        .addr   TRACK_0E_CH1_PATTERN
        .byte   $05
        .addr   TRACK_0E_CH5_PATTERN
TRACK_0E_CH0_PATTERN:
        .byte   $06,$02,$17,$00,$C3,$28,$4B,$02
        .byte   $49,$02,$44,$02,$49,$02,$47,$02
        .byte   $42,$02,$47,$02,$45,$02,$40,$02
        .byte   $45,$02,$44,$02,$3B,$02,$FC,$FE
        .byte   $39,$02,$37,$02,$32,$02,$42,$02
        .byte   $39,$02,$37,$02,$FB,$04,$FC,$FE
        .byte   $37,$02,$35,$02,$30,$02,$40,$02
        .byte   $37,$02,$35,$02,$FB,$04,$FC,$FE
        .byte   $35,$02,$33,$02,$2A,$02,$3A,$02
        .byte   $35,$02,$33,$02,$FB,$04,$FC,$FE
        .byte   $33,$02,$31,$02,$28,$02,$38,$02
        .byte   $33,$02,$31,$02,$FB,$04,$FC,$FE
        .byte   $35,$02,$33,$02,$2A,$02,$3A,$02
        .byte   $35,$02,$33,$02,$FB,$04,$FC,$FE
        .byte   $37,$02,$35,$02,$30,$02,$40,$02
        .byte   $37,$02,$35,$02,$FB,$04,$B0,$D0
        .byte   $FF
TRACK_0E_CH1_PATTERN:
        .byte   $16,$02,$15,$00,$00,$01,$C3,$28
        .byte   $4B,$02,$49,$02,$44,$02,$49,$02
        .byte   $47,$02,$42,$02,$47,$02,$45,$02
        .byte   $40,$02,$45,$02,$44,$02,$3B,$02
        .byte   $FC,$FE,$39,$02,$37,$02,$32,$02
        .byte   $42,$02,$39,$02,$37,$02,$FB,$04
        .byte   $FC,$FE,$37,$02,$35,$02,$30,$02
        .byte   $40,$02,$37,$02,$35,$02,$FB,$04
        .byte   $FC,$FE,$35,$02,$33,$02,$2A,$02
        .byte   $3A,$02,$35,$02,$33,$02,$FB,$04
        .byte   $FC,$FE,$33,$02,$31,$02,$28,$02
        .byte   $38,$02,$33,$02,$31,$02,$FB,$04
        .byte   $FC,$FE,$35,$02,$33,$02,$2A,$02
        .byte   $3A,$02,$35,$02,$33,$02,$FB,$04
        .byte   $FC,$FE,$37,$02,$35,$02,$30,$02
        .byte   $40,$02,$37,$02,$35,$02,$FB,$04
        .byte   $B0,$D0,$FF
TRACK_0E_CH5_PATTERN:
        .byte   $26,$38,$7F,$00,$00,$18,$FC,$FE
        .byte   $22,$02,$29,$02,$32,$02,$32,$02
        .byte   $32,$02,$32,$02,$FB,$04,$FC,$FE
        .byte   $20,$02,$27,$02,$30,$02,$30,$02
        .byte   $30,$02,$30,$02,$FB,$04,$FC,$FE
        .byte   $1A,$02,$25,$02,$2A,$02,$2A,$02
        .byte   $2A,$02,$2A,$02,$FB,$04,$FC,$FE
        .byte   $18,$02,$23,$02,$28,$02,$28,$02
        .byte   $28,$02,$28,$02,$FB,$04,$FC,$FE
        .byte   $1A,$02,$25,$02,$2A,$02,$2A,$02
        .byte   $2A,$02,$2A,$02,$FB,$04,$FC,$FE
        .byte   $20,$02,$27,$02,$30,$02,$30,$02
        .byte   $30,$02,$30,$02,$FB,$04,$B0,$D0
        .byte   $FF
TRACK_0F_ORDER:
        .byte   $02,$00
        .addr   TRACK_0F_CH0_PATTERN
        .byte   $01
        .addr   TRACK_0F_CH1_PATTERN
        .byte   $05
        .addr   TRACK_0F_CH5_PATTERN
TRACK_0F_CH0_PATTERN:
        .byte   $0C,$02,$19,$00,$C1,$10,$32,$01
        .byte   $31,$01,$32,$01,$34,$01,$35,$01
        .byte   $34,$01,$35,$01,$37,$01,$39,$01
        .byte   $3A,$01,$39,$01,$37,$01,$35,$01
        .byte   $34,$01,$32,$01,$31,$01,$C2,$20
        .byte   $32,$04,$34,$04,$32,$06,$FF
TRACK_0F_CH1_PATTERN:
        .byte   $1C,$02,$19,$00,$C1,$10,$2A,$01
        .byte   $29,$01,$2A,$01,$31,$01,$32,$01
        .byte   $31,$01,$32,$01,$34,$01,$35,$01
        .byte   $37,$01,$35,$01,$34,$01,$32,$01
        .byte   $31,$01,$2A,$01,$29,$01,$C2,$20
        .byte   $2A,$04,$31,$04,$29,$06,$FF
TRACK_0F_CH5_PATTERN:
        .byte   $2C,$28,$7F,$00,$FC,$FE,$22,$01
        .byte   $FB,$10,$FC,$FE,$25,$01,$FB,$04
        .byte   $FC,$FE,$27,$01,$FB,$04,$FC,$FE
        .byte   $22,$01,$FB,$06,$FF
TRACK_10_ORDER:
        .byte   $03,$00
        .addr   TRACK_10_CH0_PATTERN
        .byte   $01
        .addr   TRACK_10_CH1_PATTERN
        .byte   $05
        .addr   TRACK_10_CH5_PATTERN
        .byte   $03
        .addr   TRACK_10_CH3_PATTERN
TRACK_10_CH0_PATTERN:
        .byte   $0A,$02,$1A,$00,$C1,$20,$27,$04
        .byte   $27,$04,$29,$04,$26,$06,$27,$02
        .byte   $29,$04,$2B,$04,$2B,$04,$30,$04
        .byte   $2B,$06,$29,$02,$27,$04,$29,$04
        .byte   $27,$04,$26,$04,$27,$04,$27,$02
        .byte   $29,$02,$2B,$02,$30,$02,$32,$04
        .byte   $32,$04,$32,$04,$32,$06,$30,$02
        .byte   $2B,$04,$30,$04,$30,$04,$30,$04
        .byte   $30,$06,$2B,$02,$29,$04,$2B,$04
        .byte   $30,$02,$2B,$02,$29,$02,$27,$02
        .byte   $2B,$06,$30,$02,$32,$04,$34,$02
        .byte   $30,$02,$2B,$04,$29,$04,$27,$08
        .byte   $FF
TRACK_10_CH1_PATTERN:
        .byte   $1A,$02,$1A,$00,$C1,$20,$22,$04
        .byte   $24,$04,$20,$04,$19,$06,$22,$02
        .byte   $26,$04,$27,$04,$24,$04,$20,$04
        .byte   $22,$06,$23,$02,$24,$04,$20,$04
        .byte   $22,$04,$22,$04,$17,$04,$1B,$02
        .byte   $22,$02,$27,$02,$29,$02,$27,$04
        .byte   $27,$04,$27,$04,$27,$06,$26,$02
        .byte   $27,$04,$27,$04,$27,$04,$27,$04
        .byte   $27,$06,$26,$02,$27,$04,$27,$04
        .byte   $29,$02,$27,$02,$26,$02,$24,$02
        .byte   $27,$06,$29,$02,$27,$04,$27,$02
        .byte   $24,$02,$22,$04,$22,$04,$22,$08
        .byte   $FF
TRACK_10_CH5_PATTERN:
        .byte   $2A,$38,$7F,$00,$FC,$FE,$00,$0C
        .byte   $FB,$06,$17,$04,$1B,$04,$22,$04
        .byte   $17,$06,$1B,$02,$22,$04,$12,$04
        .byte   $16,$04,$19,$04,$12,$06,$16,$02
        .byte   $19,$04,$17,$04,$19,$04,$22,$04
        .byte   $22,$02,$20,$02,$1B,$02,$19,$02
        .byte   $17,$04,$24,$04,$22,$04,$22,$04
        .byte   $17,$08,$FF
TRACK_10_CH3_PATTERN:
        .byte   $3A,$00,$18,$00,$C5,$20,$FC,$FE
        .byte   $00,$0C,$FB,$06,$FC,$FE,$03,$04
        .byte   $03,$04,$03,$04,$03,$0C,$FB,$04
        .byte   $FF
TRACK_11_ORDER:
        .byte   $03,$00
        .addr   TRACK_11_CH0_PATTERN
        .byte   $01
        .addr   TRACK_11_CH1_PATTERN
        .byte   $05
        .addr   TRACK_11_CH5_PATTERN
        .byte   $03
        .addr   TRACK_11_CH3_PATTERN
TRACK_11_CH0_PATTERN:
        .byte   $03,$02,$17,$00,$C3,$10,$23,$02
        .byte   $20,$02,$18,$02,$20,$02,$23,$02
        .byte   $27,$02,$25,$02,$22,$02,$1A,$02
        .byte   $22,$02,$25,$02,$2A,$02,$27,$06
        .byte   $24,$06,$27,$06,$30,$06,$23,$02
        .byte   $20,$02,$18,$02,$20,$02,$23,$02
        .byte   $27,$02,$25,$02,$22,$02,$1A,$02
        .byte   $22,$02,$25,$02,$2A,$02,$27,$06
        .byte   $30,$06,$34,$06,$37,$06,$FC,$FE
        .byte   $25,$06,$25,$02,$27,$02,$29,$02
        .byte   $2A,$03,$29,$03,$27,$03,$25,$03
        .byte   $30,$0C,$25,$0C,$2A,$0F,$29,$03
        .byte   $27,$03,$25,$03,$27,$18,$25,$06
        .byte   $25,$02,$27,$02,$29,$02,$2A,$03
        .byte   $29,$03,$27,$03,$25,$03,$30,$0C
        .byte   $25,$0C,$2A,$0C,$29,$03,$27,$03
        .byte   $25,$03,$27,$03,$25,$18,$25,$06
        .byte   $25,$02,$25,$02,$25,$02,$27,$06
        .byte   $27,$02,$25,$02,$27,$02,$29,$18
        .byte   $25,$06,$25,$02,$25,$02,$25,$02
        .byte   $27,$06,$27,$02,$25,$02,$27,$02
        .byte   $25,$18,$FB,$00,$FF
TRACK_11_CH1_PATTERN:
        .byte   $13,$02,$17,$00,$C3,$10,$20,$02
        .byte   $18,$02,$13,$02,$18,$02,$20,$02
        .byte   $23,$02,$22,$02,$1A,$02,$15,$02
        .byte   $1A,$02,$22,$02,$25,$02,$24,$06
        .byte   $20,$06,$24,$06,$27,$06,$20,$02
        .byte   $18,$02,$13,$02,$18,$02,$20,$02
        .byte   $23,$02,$22,$02,$1A,$02,$15,$02
        .byte   $1A,$02,$22,$02,$25,$02,$24,$06
        .byte   $27,$06,$30,$06,$34,$06,$FC,$FE
        .byte   $20,$06,$20,$02,$24,$02,$25,$02
        .byte   $27,$03,$25,$03,$24,$03,$22,$03
        .byte   $29,$0C,$22,$0C,$27,$0F,$25,$03
        .byte   $24,$03,$22,$03,$24,$18,$20,$06
        .byte   $20,$02,$24,$02,$25,$02,$27,$03
        .byte   $25,$03,$24,$03,$22,$03,$29,$0C
        .byte   $22,$0C,$27,$0C,$25,$03,$24,$03
        .byte   $22,$03,$24,$03,$20,$18,$21,$06
        .byte   $21,$02,$21,$02,$21,$02,$23,$06
        .byte   $23,$02,$21,$02,$23,$02,$25,$18
        .byte   $21,$06,$21,$02,$21,$02,$21,$02
        .byte   $23,$06,$23,$02,$21,$02,$23,$02
        .byte   $20,$18,$FB,$00,$FF
TRACK_11_CH5_PATTERN:
        .byte   $23,$28,$20,$00,$FC,$FE,$18,$06
        .byte   $18,$06,$1A,$06,$1A,$06,$20,$06
        .byte   $20,$06,$1A,$06,$1A,$06,$FB,$02
        .byte   $FC,$FE,$25,$06,$25,$06,$24,$06
        .byte   $24,$06,$22,$06,$22,$06,$20,$06
        .byte   $20,$06,$1A,$06,$1A,$06,$19,$06
        .byte   $19,$06,$17,$06,$17,$06,$20,$06
        .byte   $20,$06,$25,$06,$25,$06,$24,$06
        .byte   $24,$06,$22,$06,$22,$06,$20,$06
        .byte   $20,$06,$1A,$06,$1A,$06,$20,$06
        .byte   $20,$06,$25,$06,$25,$06,$25,$06
        .byte   $25,$06,$21,$06,$21,$06,$23,$06
        .byte   $23,$06,$25,$06,$25,$06,$23,$06
        .byte   $23,$06,$21,$06,$21,$06,$23,$06
        .byte   $23,$06,$25,$06,$25,$06,$25,$06
        .byte   $25,$06,$FB,$00,$FF
TRACK_11_CH3_PATTERN:
        .byte   $33,$00,$18,$00,$C5,$10,$FC,$FE
        .byte   $03,$06,$03,$02,$03,$02,$03,$02
        .byte   $FB,$00,$FF
TRACK_12_ORDER:
        .byte   $03,$00
        .addr   TRACK_12_CH0_PATTERN
        .byte   $01
        .addr   TRACK_12_CH1_PATTERN
        .byte   $05
        .addr   TRACK_12_CH5_PATTERN
        .byte   $03
        .addr   TRACK_12_CH3_PATTERN
TRACK_12_CH0_PATTERN:
        .byte   $06,$02,$1A,$00,$C3,$10,$FC,$FE
        .byte   $29,$03,$25,$03,$22,$02,$25,$04
        .byte   $27,$04,$29,$03,$2A,$03,$30,$02
        .byte   $29,$04,$25,$04,$25,$03,$25,$03
        .byte   $27,$02,$25,$04,$27,$04,$29,$03
        .byte   $25,$03,$22,$02,$20,$04,$00,$04
        .byte   $FB,$02,$25,$03,$25,$03,$27,$02
        .byte   $25,$04,$27,$04,$29,$03,$2A,$03
        .byte   $30,$02,$29,$04,$25,$04,$27,$03
        .byte   $27,$03,$29,$02,$27,$04,$29,$04
        .byte   $FC,$FE,$30,$02,$FB,$05,$00,$06
        .byte   $B0,$D6,$FF
TRACK_12_CH1_PATTERN:
        .byte   $16,$02,$1A,$00,$C3,$10,$FC,$FE
        .byte   $25,$03,$22,$03,$1A,$02,$22,$04
        .byte   $24,$04,$25,$03,$27,$03,$29,$02
        .byte   $25,$04,$22,$04,$22,$03,$22,$03
        .byte   $24,$02,$22,$04,$24,$04,$25,$03
        .byte   $22,$03,$1A,$02,$19,$04,$00,$04
        .byte   $FB,$02,$22,$03,$22,$03,$24,$02
        .byte   $22,$04,$24,$04,$25,$03,$27,$03
        .byte   $29,$02,$25,$04,$22,$04,$24,$03
        .byte   $24,$03,$25,$02,$24,$04,$25,$04
        .byte   $FC,$FE,$24,$02,$FB,$05,$00,$06
        .byte   $B0,$D6,$FF
TRACK_12_CH5_PATTERN:
        .byte   $26,$28,$18,$00,$FC,$FE,$25,$03
        .byte   $25,$03,$25,$02,$25,$08,$2A,$03
        .byte   $2A,$03,$2A,$02,$2A,$08,$20,$03
        .byte   $20,$03,$20,$02,$20,$08,$25,$03
        .byte   $25,$03,$25,$02,$25,$08,$FB,$02
        .byte   $2A,$03,$2A,$03,$2A,$02,$2A,$08
        .byte   $25,$03,$25,$03,$25,$02,$25,$08
        .byte   $27,$03,$27,$03,$27,$02,$27,$08
        .byte   $FC,$FE,$30,$02,$FB,$05,$00,$06
        .byte   $B0,$DE,$FF
TRACK_12_CH3_PATTERN:
        .byte   $36,$00,$17,$00,$C5,$10,$FC,$FE
        .byte   $07,$03,$07,$01,$03,$02,$07,$02
        .byte   $07,$04,$03,$04,$FB,$0B,$FC,$FE
        .byte   $03,$02,$FB,$04,$FC,$FE,$03,$02
        .byte   $07,$02,$FB,$02,$B0,$F0,$FF
TRACK_13_ORDER:
        .byte   $03,$00
        .addr   TRACK_13_CH0_PATTERN
        .byte   $01
        .addr   TRACK_13_CH1_PATTERN
        .byte   $05
        .addr   TRACK_13_CH5_PATTERN
        .byte   $03
        .addr   TRACK_13_CH3_PATTERN
TRACK_13_CH0_PATTERN:
        .byte   $08,$02,$1A,$00,$C5,$30,$29,$02
        .byte   $30,$01,$27,$01,$00,$01,$30,$01
        .byte   $00,$01,$25,$01,$00,$01,$30,$01
        .byte   $00,$01,$27,$01,$27,$02,$30,$02
        .byte   $29,$06,$00,$04,$F3,$01
TRACK_13_CH1_PATTERN:
        .byte   $18,$02,$19,$00,$C5,$30,$25,$02
        .byte   $20,$01,$24,$01,$00,$01,$20,$01
        .byte   $00,$01,$22,$01,$00,$01,$20,$01
        .byte   $00,$01,$24,$01,$24,$02,$20,$02
        .byte   $25,$06,$FF
TRACK_13_CH5_PATTERN:
        .byte   $28,$38,$7F,$00,$FC,$FE,$25,$01
        .byte   $FB,$04,$FC,$FE,$24,$01,$FB,$04
        .byte   $FC,$FE,$22,$01,$FB,$04,$FC,$FE
        .byte   $24,$01,$FB,$04,$FC,$FE,$25,$01
        .byte   $FB,$06,$FF
TRACK_13_CH3_PATTERN:
        .byte   $38,$00,$18,$00,$C5,$10,$03,$02
        .byte   $03,$01,$03,$02,$03,$02,$03,$02
        .byte   $03,$02,$03,$01,$03,$02,$03,$02
        .byte   $03,$06,$FF
TRACK_14_ORDER:
        .byte   $02,$00
        .addr   TRACK_14_CH0_PATTERN
        .byte   $01
        .addr   TRACK_14_CH1_PATTERN
        .byte   $05
        .addr   TRACK_14_CH5_PATTERN
TRACK_14_CH0_PATTERN:
        .byte   $06,$02,$1A,$00,$C3,$40,$25,$06
        .byte   $25,$02,$27,$02,$29,$02,$2A,$06
        .byte   $2A,$02,$29,$02,$25,$02,$27,$06
        .byte   $27,$02,$29,$02,$2A,$02,$30,$06
        .byte   $30,$02,$2A,$02,$27,$02,$29,$06
        .byte   $29,$02,$27,$02,$25,$02,$24,$02
        .byte   $25,$02,$24,$02,$22,$04,$20,$02
        .byte   $22,$02,$24,$02,$25,$02,$27,$02
        .byte   $29,$02,$27,$02,$25,$0C,$FF
TRACK_14_CH1_PATTERN:
        .byte   $16,$02,$18,$00,$C3,$40,$00,$01
        .byte   $25,$06,$25,$02,$27,$02,$29,$02
        .byte   $2A,$06,$2A,$02,$29,$02,$25,$02
        .byte   $27,$06,$27,$02,$29,$02,$2A,$02
        .byte   $30,$06,$30,$02,$2A,$02,$27,$02
        .byte   $29,$06,$29,$02,$27,$02,$25,$02
        .byte   $24,$02,$25,$02,$24,$02,$22,$04
        .byte   $20,$02,$22,$02,$24,$02,$25,$02
        .byte   $27,$02,$29,$02,$27,$02,$25,$0C
        .byte   $FF
TRACK_14_CH5_PATTERN:
        .byte   $26,$28,$7F,$00,$FC,$FE,$25,$01
        .byte   $FB,$06,$FC,$FE,$25,$01,$FB,$06
        .byte   $FC,$FE,$2A,$01,$FB,$06,$FC,$FE
        .byte   $2A,$01,$FB,$06,$FC,$FE,$27,$01
        .byte   $FB,$06,$FC,$FE,$27,$01,$FB,$06
        .byte   $FC,$FE,$30,$01,$FB,$06,$FC,$FE
        .byte   $30,$01,$FB,$06,$FC,$FE,$29,$01
        .byte   $FB,$06,$FC,$FE,$29,$01,$FB,$06
        .byte   $FC,$FE,$32,$01,$FB,$06,$FC,$FE
        .byte   $32,$01,$FB,$06,$FC,$FE,$27,$01
        .byte   $FB,$06,$FC,$FE,$30,$01,$FB,$06
        .byte   $FC,$FE,$25,$01,$FB,$0C,$FF
TRACK_15_ORDER:
        .byte   $03,$00
        .addr   TRACK_15_CH0_PATTERN
        .byte   $01
        .addr   TRACK_15_CH1_PATTERN
        .byte   $05
        .addr   TRACK_15_CH5_PATTERN
        .byte   $03
        .addr   TRACK_15_CH3_PATTERN
TRACK_15_CH0_PATTERN:
        .byte   $06,$02,$19,$00,$C3,$10,$FC,$FE
        .byte   $00,$02,$25,$02,$29,$02,$30,$02
        .byte   $34,$03,$35,$03,$34,$02,$30,$06
        .byte   $29,$02,$30,$04,$32,$02,$30,$02
        .byte   $00,$02,$2A,$04,$2A,$02,$29,$04
        .byte   $25,$04,$27,$04,$29,$02,$27,$0A
        .byte   $FB,$02,$FC,$FE,$27,$04,$27,$04
        .byte   $27,$02,$28,$02,$2A,$02,$27,$04
        .byte   $23,$04,$25,$0A,$25,$04,$25,$04
        .byte   $25,$02,$26,$02,$28,$02,$25,$04
        .byte   $21,$04,$23,$0A,$FB,$02,$B0,$D8
        .byte   $FF
TRACK_15_CH1_PATTERN:
        .byte   $16,$02,$19,$00,$C3,$10,$FC,$FE
        .byte   $00,$02,$20,$02,$25,$02,$29,$02
        .byte   $30,$03,$32,$03,$30,$02,$29,$06
        .byte   $25,$02,$29,$04,$2A,$02,$29,$02
        .byte   $00,$02,$27,$04,$27,$02,$25,$04
        .byte   $22,$04,$24,$04,$25,$02,$24,$0A
        .byte   $FB,$02,$FC,$FE,$23,$04,$23,$04
        .byte   $23,$02,$25,$02,$27,$02,$23,$04
        .byte   $20,$04,$22,$0A,$21,$04,$21,$04
        .byte   $21,$02,$23,$02,$25,$02,$21,$04
        .byte   $1A,$04,$20,$0A,$FB,$02,$B0,$D8
        .byte   $FF
TRACK_15_CH5_PATTERN:
        .byte   $26,$38,$12,$00,$FC,$FE,$25,$06
        .byte   $25,$02,$24,$06,$24,$02,$22,$06
        .byte   $22,$02,$20,$06,$20,$02,$1A,$06
        .byte   $1A,$02,$19,$06,$19,$02,$17,$06
        .byte   $17,$02,$20,$06,$20,$02,$FB,$02
        .byte   $FC,$FE,$23,$06,$23,$02,$FB,$02
        .byte   $FC,$FE,$1A,$06,$1A,$02,$FB,$02
        .byte   $FC,$FE,$21,$06,$21,$02,$FB,$02
        .byte   $FC,$FE,$18,$06,$18,$02,$FB,$02
        .byte   $FC,$FE,$23,$06,$23,$02,$FB,$02
        .byte   $FC,$FE,$1A,$06,$1A,$02,$FB,$02
        .byte   $FC,$FE,$21,$06,$21,$02,$FB,$02
        .byte   $FC,$FE,$18,$06,$18,$02,$FB,$02
        .byte   $B0,$CE,$FF
TRACK_15_CH3_PATTERN:
        .byte   $36,$00,$16,$00,$C5,$10,$FC,$FE
        .byte   $06,$04,$03,$02,$06,$02,$06,$04
        .byte   $03,$04,$FB,$00,$FF
TRACK_16_ORDER:
        .byte   $03,$00
        .addr   TRACK_16_CH0_PATTERN
        .byte   $01
        .addr   TRACK_16_CH1_PATTERN
        .byte   $05
        .addr   TRACK_16_CH5_PATTERN
        .byte   $03
        .addr   TRACK_16_CH3_PATTERN
TRACK_16_CH0_PATTERN:
        .byte   $0A,$01,$1B,$00,$C1,$10,$23,$01
        .byte   $24,$01,$25,$01,$26,$01,$27,$01
        .byte   $28,$01,$29,$01,$2A,$01,$2B,$01
        .byte   $30,$01,$31,$01,$32,$01,$33,$01
        .byte   $34,$01,$35,$01,$36,$01,$FC,$FE
        .byte   $23,$01,$24,$01,$00,$02,$26,$01
        .byte   $27,$01,$00,$02,$29,$01,$2A,$01
        .byte   $00,$01,$30,$05,$FB,$02,$FC,$FE
        .byte   $00,$01,$30,$01,$2A,$01,$28,$01
        .byte   $00,$01,$2A,$01,$00,$01,$28,$01
        .byte   $00,$01,$26,$01,$00,$01,$24,$01
        .byte   $26,$02,$28,$01,$00,$01,$FB,$02
        .byte   $B0,$E3,$FF
TRACK_16_CH1_PATTERN:
        .byte   $1A,$01,$1B,$00,$C1,$10,$20,$01
        .byte   $21,$01,$22,$01,$23,$01,$24,$01
        .byte   $25,$01,$26,$01,$27,$01,$28,$01
        .byte   $29,$01,$2A,$01,$2B,$01,$30,$01
        .byte   $31,$01,$32,$01,$33,$01,$FC,$FE
        .byte   $20,$01,$21,$01,$00,$02,$23,$01
        .byte   $24,$01,$00,$02,$26,$01,$27,$01
        .byte   $00,$01,$29,$05,$FB,$02,$FC,$FE
        .byte   $00,$01,$28,$01,$26,$01,$24,$01
        .byte   $00,$01,$26,$01,$00,$01,$24,$01
        .byte   $00,$01,$22,$01,$00,$01,$20,$01
        .byte   $22,$02,$24,$01,$00,$01,$FB,$02
        .byte   $B0,$E3,$FF
TRACK_16_CH5_PATTERN:
        .byte   $2A,$28,$10,$00,$FC,$FE,$22,$01
        .byte   $FB,$10,$FC,$FE,$17,$01,$FB,$20
        .byte   $FC,$FE,$20,$01,$FB,$20,$B0,$FA
        .byte   $FF
TRACK_16_CH3_PATTERN:
        .byte   $3A,$00,$16,$00,$C5,$10,$FC,$FE
        .byte   $03,$01,$FB,$10,$FC,$FE,$06,$01
        .byte   $06,$01,$03,$01,$06,$01,$FB,$00
        .byte   $FF
TRACK_17_ORDER:
        .byte   $02,$00
        .addr   TRACK_17_CH0_PATTERN
        .byte   $01
        .addr   TRACK_17_CH1_PATTERN
        .byte   $05
        .addr   TRACK_17_CH5_PATTERN
TRACK_17_CH0_PATTERN:
        .byte   $0A,$02,$1A,$00,$C2,$20,$20,$03
        .byte   $20,$01,$22,$01,$23,$01,$22,$03
        .byte   $2A,$03,$27,$0C,$27,$03,$27,$01
        .byte   $25,$01,$23,$01,$25,$03,$2A,$03
        .byte   $30,$09,$00,$08,$F3,$08
TRACK_17_CH1_PATTERN:
        .byte   $1A,$02,$1A,$00,$C2,$20,$18,$03
        .byte   $18,$01,$1A,$01,$20,$01,$1A,$03
        .byte   $27,$03,$24,$0C,$23,$03,$23,$01
        .byte   $22,$01,$20,$01,$22,$03,$27,$03
        .byte   $27,$09,$FF
TRACK_17_CH5_PATTERN:
        .byte   $2A,$38,$40,$00,$18,$03,$18,$03
        .byte   $1A,$03,$1A,$03,$20,$03,$20,$03
        .byte   $1A,$03,$1A,$03,$18,$03,$18,$03
        .byte   $1A,$03,$1A,$03,$20,$03,$20,$03
        .byte   $20,$03,$FF
TRACK_18_ORDER:
        .byte   $03,$00
        .addr   TRACK_18_CH0_PATTERN
        .byte   $01
        .addr   TRACK_18_CH1_PATTERN
        .byte   $05
        .addr   TRACK_18_CH5_PATTERN
        .byte   $03
        .addr   TRACK_18_CH3_PATTERN
TRACK_18_CH0_PATTERN:
        .byte   $06,$01,$19,$00,$C3,$10,$FC,$FE
        .byte   $29,$02,$2B,$01,$30,$01,$00,$01
        .byte   $29,$01,$00,$01,$32,$03,$30,$02
        .byte   $2B,$02,$29,$02,$2B,$03,$27,$03
        .byte   $24,$0A,$29,$02,$2B,$01,$30,$01
        .byte   $00,$01,$29,$01,$00,$01,$32,$03
        .byte   $30,$02,$2B,$02,$29,$02,$2B,$03
        .byte   $27,$03,$34,$0A,$29,$02,$2B,$01
        .byte   $30,$01,$00,$01,$29,$01,$00,$01
        .byte   $32,$03,$30,$02,$2B,$02,$29,$02
        .byte   $2B,$03,$27,$03,$24,$08,$29,$01
        .byte   $2B,$01,$30,$02,$32,$02,$2B,$02
        .byte   $27,$02,$29,$03,$29,$01,$00,$02
        .byte   $39,$01,$3B,$01,$40,$02,$3B,$02
        .byte   $39,$02,$37,$02,$39,$03,$39,$01
        .byte   $00,$04,$FB,$02,$34,$0C,$34,$01
        .byte   $32,$01,$30,$02,$32,$08,$37,$08
        .byte   $34,$20,$34,$0C,$34,$01,$32,$01
        .byte   $30,$02,$32,$08,$37,$08,$39,$20
        .byte   $B0,$B6,$FF
TRACK_18_CH1_PATTERN:
        .byte   $16,$01,$17,$00,$F8,$02,$C3,$10
        .byte   $FC,$FE,$29,$02,$2B,$01,$30,$01
        .byte   $00,$01,$29,$01,$00,$01,$32,$03
        .byte   $30,$02,$2B,$02,$29,$02,$2B,$03
        .byte   $27,$03,$24,$0A,$29,$02,$2B,$01
        .byte   $30,$01,$00,$01,$29,$01,$00,$01
        .byte   $32,$03,$30,$02,$2B,$02,$29,$02
        .byte   $2B,$03,$27,$03,$34,$0A,$29,$02
        .byte   $2B,$01,$30,$01,$00,$01,$29,$01
        .byte   $00,$01,$32,$03,$30,$02,$2B,$02
        .byte   $29,$02,$2B,$03,$27,$03,$24,$08
        .byte   $29,$01,$2B,$01,$30,$02,$32,$02
        .byte   $2B,$02,$27,$02,$29,$03,$29,$01
        .byte   $00,$02,$39,$01,$3B,$01,$40,$02
        .byte   $3B,$02,$39,$02,$37,$02,$39,$03
        .byte   $39,$01,$00,$04,$FB,$02,$34,$0C
        .byte   $34,$01,$32,$01,$30,$02,$32,$08
        .byte   $37,$08,$34,$20,$34,$0C,$34,$01
        .byte   $32,$01,$30,$02,$32,$08,$37,$08
        .byte   $39,$20,$B0,$B6,$FF
TRACK_18_CH5_PATTERN:
        .byte   $26,$38,$10,$00,$FC,$FE,$19,$03
        .byte   $24,$03,$29,$02,$19,$03,$24,$03
        .byte   $29,$02,$17,$03,$22,$03,$27,$02
        .byte   $17,$03,$22,$03,$27,$02,$19,$03
        .byte   $24,$03,$29,$02,$19,$03,$24,$03
        .byte   $29,$02,$17,$03,$22,$03,$27,$02
        .byte   $17,$03,$22,$03,$27,$02,$19,$03
        .byte   $24,$03,$29,$02,$19,$03,$24,$03
        .byte   $29,$02,$17,$03,$22,$03,$27,$02
        .byte   $17,$03,$22,$03,$27,$02,$15,$04
        .byte   $17,$04,$19,$03,$19,$01,$00,$04
        .byte   $25,$04,$27,$04,$29,$03,$29,$01
        .byte   $00,$04,$FB,$02,$FC,$FE,$15,$03
        .byte   $20,$03,$25,$02,$15,$03,$20,$03
        .byte   $25,$02,$17,$03,$22,$03,$27,$02
        .byte   $17,$03,$22,$03,$27,$02,$19,$03
        .byte   $24,$03,$29,$02,$19,$03,$24,$03
        .byte   $29,$02,$17,$03,$22,$03,$27,$02
        .byte   $17,$03,$22,$03,$27,$02,$FB,$02
        .byte   $B0,$B6,$FF
TRACK_18_CH3_PATTERN:
        .byte   $36,$00,$18,$00,$C5,$10,$FC,$FE
        .byte   $07,$03,$07,$01,$03,$02,$07,$02
        .byte   $FB,$0C,$FC,$FE,$03,$02,$07,$02
        .byte   $03,$02,$07,$02,$03,$03,$03,$01
        .byte   $00,$04,$FB,$02,$FC,$FE,$07,$03
        .byte   $07,$01,$03,$02,$07,$02,$FB,$0C
        .byte   $FC,$FE,$03,$02,$07,$02,$03,$02
        .byte   $07,$02,$03,$03,$03,$01,$00,$04
        .byte   $FB,$02,$FC,$FE,$07,$03,$07,$01
        .byte   $03,$02,$07,$02,$FB,$10,$B0,$DB
        .byte   $FF
TRACK_19_ORDER:
        .byte   $03,$00
        .addr   TRACK_19_CH0_PATTERN
        .byte   $01
        .addr   TRACK_19_CH1_PATTERN
        .byte   $05
        .addr   TRACK_19_CH5_PATTERN
        .byte   $03
        .addr   TRACK_19_CH3_PATTERN
TRACK_19_CH0_PATTERN:
        .byte   $0A,$02,$1A,$00,$C3,$18,$FC,$FE
        .byte   $26,$03,$29,$03,$34,$02,$32,$03
        .byte   $31,$03,$29,$02,$2B,$03,$26,$05
        .byte   $26,$02,$24,$01,$22,$01,$00,$01
        .byte   $22,$01,$24,$02,$FB,$02,$22,$0B
        .byte   $1B,$01,$22,$01,$24,$03,$26,$03
        .byte   $24,$0D,$22,$0B,$1B,$01,$22,$01
        .byte   $24,$03,$26,$03,$24,$04,$29,$03
        .byte   $27,$02,$26,$02,$24,$02,$B0,$DF
        .byte   $FF
TRACK_19_CH1_PATTERN:
        .byte   $1A,$02,$17,$00,$00,$01,$C3,$10
        .byte   $FC,$FE,$26,$03,$29,$03,$34,$02
        .byte   $32,$03,$31,$03,$29,$02,$2B,$03
        .byte   $26,$05,$26,$02,$24,$01,$22,$01
        .byte   $00,$01,$22,$01,$24,$02,$FB,$02
        .byte   $22,$0B,$1B,$01,$22,$01,$24,$03
        .byte   $26,$03,$24,$0D,$22,$0B,$1B,$01
        .byte   $22,$01,$24,$03,$26,$03,$24,$04
        .byte   $29,$03,$27,$02,$26,$02,$24,$02
        .byte   $B0,$DF,$FF
TRACK_19_CH5_PATTERN:
        .byte   $2A,$30,$10,$00,$FC,$FE,$22,$01
        .byte   $FB,$08,$FC,$FE,$21,$01,$FB,$08
        .byte   $FC,$FE,$1B,$01,$FB,$08,$FC,$FE
        .byte   $19,$01,$FB,$08,$FC,$FE,$22,$01
        .byte   $FB,$08,$FC,$FE,$21,$01,$FB,$08
        .byte   $FC,$FE,$1B,$01,$FB,$08,$FC,$FE
        .byte   $19,$01,$FB,$08,$FC,$FE,$17,$01
        .byte   $FB,$10,$FC,$FE,$19,$01,$FB,$10
        .byte   $FC,$FE,$17,$01,$FB,$10,$FC,$FE
        .byte   $19,$01,$FB,$10,$B0,$DC,$FF
TRACK_19_CH3_PATTERN:
        .byte   $3A,$00,$16,$00,$C5,$10,$FC,$FE
        .byte   $06,$01,$06,$01,$03,$01,$06,$01
        .byte   $FB,$00,$FF,$F0
PADDING_BFE9:
        .byte   $FE,$D0,$FE,$F0,$FE,$D0,$FE,$F0
        .byte   $FE,$D0,$FE,$F0,$FE,$D0,$FE,$F0
        .byte   $FE,$D0,$FE,$F0,$FE,$D0
        .byte   $FE

.segment "BANK09"
BANK_TAG_09:
        .byte   $09,$00
TRACK_1A_ORDER:
        .byte   $02,$00
        .addr   TRACK_1A_CH0_PATTERN
        .byte   $01
        .addr   TRACK_1A_CH1_PATTERN
        .byte   $05
        .addr   TRACK_1A_CH5_PATTERN
TRACK_1A_CH0_PATTERN:
        .byte   $02,$02,$1C,$00,$C2,$10,$29,$0C
        .byte   $29,$04,$32,$04,$36,$04,$37,$0C
        .byte   $37,$04,$36,$04,$34,$04,$39,$18
        .byte   $32,$0C,$32,$04,$34,$04,$36,$04
        .byte   $37,$0C,$37,$04,$36,$04,$34,$04
        .byte   $36,$0C,$32,$0C,$34,$30,$29,$0C
        .byte   $29,$04,$32,$04,$36,$04,$37,$0C
        .byte   $37,$04,$36,$04,$34,$04,$39,$18
        .byte   $32,$0C,$32,$04,$34,$04,$36,$04
        .byte   $37,$0C,$37,$04,$36,$04,$34,$04
        .byte   $36,$0C,$34,$0C,$32,$18,$31,$06
        .byte   $32,$06,$31,$06,$29,$06,$2B,$18
        .byte   $31,$06,$2B,$06,$31,$0C,$32,$18
        .byte   $36,$06,$34,$06,$32,$06,$34,$06
        .byte   $32,$12,$31,$03,$2B,$03,$29,$18
        .byte   $B7,$C6,$29,$0C,$29,$04,$32,$04
        .byte   $36,$04,$37,$0C,$37,$04,$36,$04
        .byte   $34,$04,$39,$18,$32,$0C,$32,$04
        .byte   $34,$04,$36,$04,$37,$0C,$37,$04
        .byte   $36,$04,$34,$04,$36,$0C,$32,$0C
        .byte   $C2,$05,$F9,$13,$34,$18,$34,$06
        .byte   $32,$06,$31,$06,$2B,$06,$C2,$0A
        .byte   $F9,$1C,$29,$0C,$29,$04,$32,$04
        .byte   $36,$04,$37,$0C,$37,$04,$36,$04
        .byte   $34,$04,$39,$18,$32,$0E,$31,$0E
        .byte   $2B,$0E,$37,$0A,$34,$0A,$32,$17
        .byte   $31,$17,$00,$02,$32,$3F,$FF
TRACK_1A_CH1_PATTERN:
        .byte   $12,$02,$15,$00,$C2,$40,$22,$18
        .byte   $21,$18,$1B,$18,$19,$18,$17,$18
        .byte   $16,$18,$14,$18,$19,$18,$22,$18
        .byte   $21,$18,$1B,$18,$19,$18,$17,$18
        .byte   $16,$18,$1B,$18,$19,$18,$17,$18
        .byte   $19,$18,$1B,$18,$19,$18,$17,$18
        .byte   $19,$18,$B7,$EA,$22,$18,$21,$18
        .byte   $1B,$18,$19,$18,$F9,$17,$C2,$05
        .byte   $17,$04,$19,$04,$1B,$04,$22,$0C
        .byte   $14,$04,$16,$04,$19,$04,$21,$0C
        .byte   $29,$0C,$21,$04,$24,$04,$29,$04
        .byte   $29,$06,$27,$06,$26,$06,$24,$06
        .byte   $C2,$40,$F9,$15,$22,$18,$21,$18
        .byte   $1B,$18,$12,$0E,$11,$0E,$22,$22
        .byte   $14,$2E,$00,$02,$F9,$12,$29,$0F
        .byte   $26,$0F,$22,$21,$FF
TRACK_1A_CH5_PATTERN:
        .byte   $22,$38,$7F,$00,$22,$0C,$22,$0C
        .byte   $21,$0C,$21,$0C,$1B,$0C,$1B,$0C
        .byte   $19,$0C,$19,$0C,$17,$0C,$17,$0C
        .byte   $16,$0C,$16,$0C,$14,$0C,$14,$0C
        .byte   $19,$0C,$19,$0C,$22,$0C,$22,$0C
        .byte   $21,$0C,$21,$0C,$1B,$0C,$1B,$0C
        .byte   $19,$0C,$19,$0C,$17,$0C,$17,$0C
        .byte   $19,$0C,$19,$0C,$FC,$FE,$1B,$0C
        .byte   $1B,$0C,$19,$0C,$19,$0C,$17,$0C
        .byte   $17,$0C,$19,$0C,$19,$0C,$FB,$02
        .byte   $B7,$DA,$22,$0C,$22,$0C,$21,$0C
        .byte   $21,$0C,$1B,$0C,$1B,$0C,$19,$0C
        .byte   $19,$0C,$17,$0C,$17,$0C,$16,$0C
        .byte   $16,$0C,$14,$0C,$14,$0C,$19,$0C
        .byte   $19,$0C,$22,$0C,$22,$0C,$21,$0C
        .byte   $21,$0C,$1B,$0C,$1B,$0C,$22,$0E
        .byte   $21,$0E,$17,$0E,$1B,$0A,$22,$0A
        .byte   $19,$17,$19,$17,$00,$02,$FC,$FE
        .byte   $22,$01,$FB,$3F,$FF
TRACK_1B_ORDER:
        .byte   $03,$00
        .addr   TRACK_1B_CH0_PATTERN
        .byte   $01
        .addr   TRACK_1B_CH1_PATTERN
        .byte   $05
        .addr   TRACK_1B_CH5_PATTERN
        .byte   $03
        .addr   TRACK_1B_CH3_PATTERN
TRACK_1B_CH0_PATTERN:
        .byte   $0C,$02,$1A,$00,$C3,$10,$FC,$FE
        .byte   $2A,$01,$27,$01,$23,$01,$24,$01
        .byte   $26,$01,$27,$01,$00,$01,$24,$01
        .byte   $26,$01,$27,$01,$00,$01,$23,$01
        .byte   $24,$02,$00,$02,$FB,$02,$FC,$FE
        .byte   $22,$01,$23,$01,$22,$01,$20,$01
        .byte   $1B,$02,$20,$01,$00,$01,$00,$02
        .byte   $22,$01,$00,$01,$20,$01,$00,$03
        .byte   $FB,$02,$B0,$E1,$FF
TRACK_1B_CH1_PATTERN:
        .byte   $1C,$02,$17,$00,$F8,$04,$C3,$10
        .byte   $FC,$FE,$2A,$01,$27,$01,$23,$01
        .byte   $24,$01,$26,$01,$27,$01,$00,$01
        .byte   $24,$01,$26,$01,$27,$01,$00,$01
        .byte   $23,$01,$24,$02,$00,$02,$FB,$02
        .byte   $FC,$FE,$22,$01,$23,$01,$22,$01
        .byte   $20,$01,$1B,$02,$20,$01,$00,$01
        .byte   $00,$02,$22,$01,$00,$01,$20,$01
        .byte   $00,$03,$FB,$02,$B0,$E2,$FF
TRACK_1B_CH5_PATTERN:
        .byte   $2C,$38,$10,$00,$FC,$FE,$17,$02
        .byte   $22,$01,$22,$01,$17,$02,$22,$02
        .byte   $FB,$04,$FC,$FE,$15,$02,$20,$01
        .byte   $20,$01,$15,$02,$20,$02,$FB,$04
        .byte   $B0,$F2,$FF
TRACK_1B_CH3_PATTERN:
        .byte   $3C,$00,$19,$00,$C5,$10,$FC,$FE
        .byte   $06,$02,$03,$01,$03,$01,$06,$02
        .byte   $03,$02,$FB,$00,$FF
TRACK_1C_ORDER:
        .byte   $03,$00
        .addr   TRACK_1C_CH0_PATTERN
        .byte   $01
        .addr   TRACK_1C_CH1_PATTERN
        .byte   $05
        .addr   TRACK_1C_CH5_PATTERN
        .byte   $03
        .addr   TRACK_1C_CH3_PATTERN
TRACK_1C_CH0_PATTERN:
        .byte   $05,$01,$1A,$00,$C3,$10,$FC,$FE
        .byte   $29,$02,$33,$02,$32,$02,$30,$02
        .byte   $32,$02,$29,$02,$00,$02,$30,$02
        .byte   $00,$02,$29,$02,$00,$0C,$29,$02
        .byte   $33,$02,$32,$02,$30,$02,$37,$02
        .byte   $30,$02,$00,$02,$33,$02,$00,$02
        .byte   $30,$02,$00,$0C,$FB,$02,$34,$08
        .byte   $32,$04,$37,$04,$30,$0A,$2B,$02
        .byte   $29,$02,$27,$02,$29,$0C,$2B,$02
        .byte   $30,$02,$32,$04,$2B,$04,$29,$04
        .byte   $27,$04,$B0,$D9,$FF
TRACK_1C_CH1_PATTERN:
        .byte   $15,$01,$16,$00,$00,$01,$C3,$10
        .byte   $FC,$FE,$29,$02,$33,$02,$32,$02
        .byte   $30,$02,$32,$02,$29,$02,$00,$02
        .byte   $30,$02,$00,$02,$29,$02,$00,$0C
        .byte   $29,$02,$33,$02,$32,$02,$30,$02
        .byte   $37,$02,$30,$02,$00,$02,$33,$02
        .byte   $00,$02,$30,$02,$00,$0C,$FB,$02
        .byte   $34,$08,$32,$04,$37,$04,$30,$0A
        .byte   $2B,$02,$29,$02,$27,$02,$29,$0C
        .byte   $2B,$02,$30,$02,$32,$04,$2B,$04
        .byte   $29,$04,$27,$04,$B0,$D9,$FF
TRACK_1C_CH5_PATTERN:
        .byte   $25,$38,$10,$00,$FC,$FE,$19,$02
        .byte   $FB,$0E,$FC,$FE,$17,$02,$FB,$02
        .byte   $FC,$FE,$15,$02,$FB,$0E,$FC,$FE
        .byte   $17,$02,$FB,$02,$FC,$FE,$19,$02
        .byte   $FB,$0E,$FC,$FE,$17,$02,$FB,$02
        .byte   $FC,$FE,$15,$02,$FB,$0E,$FC,$FE
        .byte   $17,$02,$FB,$02,$FC,$FE,$20,$02
        .byte   $FB,$04,$FC,$FE,$1B,$02,$FB,$04
        .byte   $FC,$FE,$19,$02,$FB,$04,$FC,$FE
        .byte   $17,$02,$FB,$04,$FC,$FE,$15,$02
        .byte   $FB,$08,$FC,$FE,$17,$02,$FB,$08
        .byte   $B0,$D6,$FF
TRACK_1C_CH3_PATTERN:
        .byte   $35,$00,$19,$00,$C5,$10,$FC,$FE
        .byte   $05,$02,$05,$02,$02,$02,$05,$02
        .byte   $FB,$00,$FF
TRACK_1D_ORDER:
        .byte   $03,$00
        .addr   TRACK_1D_CH0_PATTERN
        .byte   $01
        .addr   TRACK_1D_CH1_PATTERN
        .byte   $05
        .addr   TRACK_1D_CH5_PATTERN
        .byte   $03
        .addr   TRACK_1D_CH3_PATTERN
TRACK_1D_CH0_PATTERN:
        .byte   $07,$01,$19,$00,$C3,$10,$FC,$FE
        .byte   $27,$02,$2A,$02,$31,$14,$31,$01
        .byte   $2A,$01,$27,$01,$24,$01,$21,$02
        .byte   $00,$02,$FB,$02,$FC,$FE,$00,$02
        .byte   $1B,$02,$25,$02,$22,$02,$28,$02
        .byte   $22,$02,$25,$02,$22,$02,$FB,$02
        .byte   $FC,$FE,$00,$02,$20,$02,$26,$02
        .byte   $23,$02,$29,$02,$23,$02,$26,$02
        .byte   $23,$02,$FB,$02,$B0,$E0,$FF
TRACK_1D_CH1_PATTERN:
        .byte   $07,$01,$16,$00,$00,$01,$C3,$10
        .byte   $FC,$FE,$27,$02,$2A,$02,$31,$14
        .byte   $31,$01,$2A,$01,$27,$01,$24,$01
        .byte   $21,$02,$00,$02,$FB,$02,$FC,$FE
        .byte   $00,$02,$1B,$02,$25,$02,$22,$02
        .byte   $28,$02,$22,$02,$25,$02,$22,$02
        .byte   $FB,$02,$FC,$FE,$00,$02,$20,$02
        .byte   $26,$02,$23,$02,$29,$02,$23,$02
        .byte   $26,$02,$23,$02,$FB,$02,$B0,$E0
        .byte   $FF
TRACK_1D_CH5_PATTERN:
        .byte   $27,$38,$10,$00,$FC,$FE,$17,$02
        .byte   $FB,$20,$FC,$FE,$15,$02,$FB,$10
        .byte   $FC,$FE,$16,$02,$FB,$10,$B0,$F7
        .byte   $FF
TRACK_1D_CH3_PATTERN:
        .byte   $37,$00,$19,$00,$C5,$10,$FC,$FE
        .byte   $03,$02,$03,$02,$03,$01,$03,$01
        .byte   $03,$01,$03,$01,$03,$02,$03,$06
        .byte   $FB,$04,$FC,$FE,$03,$02,$FB,$20
        .byte   $B0,$F2,$FF
TRACK_1E_ORDER:
        .byte   $02,$00
        .addr   TRACK_1E_CH0_PATTERN
        .byte   $01
        .addr   TRACK_1E_CH1_PATTERN
        .byte   $05
        .addr   TRACK_1E_CH5_PATTERN
TRACK_1E_CH0_PATTERN:
        .byte   $08,$02,$1C,$00,$C3,$18,$FC,$FE
        .byte   $00,$02,$2B,$02,$34,$02,$36,$02
        .byte   $37,$02,$39,$02,$36,$02,$32,$02
        .byte   $34,$0E,$36,$01,$37,$01,$36,$02
        .byte   $32,$02,$2B,$0A,$29,$02,$2B,$10
        .byte   $00,$02,$2B,$02,$34,$02,$36,$02
        .byte   $37,$02,$39,$02,$36,$02,$32,$02
        .byte   $34,$08,$3B,$02,$39,$02,$37,$02
        .byte   $39,$0A,$36,$04,$32,$04,$34,$10
        .byte   $34,$08,$32,$06,$30,$02,$2B,$0E
        .byte   $2B,$02,$29,$10,$2B,$10,$FB,$00
        .byte   $FF
TRACK_1E_CH1_PATTERN:
        .byte   $18,$02,$18,$00,$C1,$10,$FC,$FE
        .byte   $14,$02,$1B,$02,$24,$02,$1B,$02
        .byte   $26,$02,$1B,$02,$27,$02,$1B,$02
        .byte   $10,$02,$17,$02,$20,$02,$17,$02
        .byte   $22,$02,$17,$02,$24,$02,$17,$02
        .byte   $12,$02,$19,$02,$22,$02,$19,$02
        .byte   $24,$02,$19,$02,$26,$02,$19,$02
        .byte   $14,$02,$1B,$02,$24,$02,$1B,$02
        .byte   $26,$02,$1B,$02,$27,$02,$1B,$02
        .byte   $FB,$02,$10,$02,$17,$02,$20,$02
        .byte   $17,$02,$12,$02,$19,$02,$22,$02
        .byte   $19,$02,$17,$02,$22,$02,$27,$02
        .byte   $22,$02,$29,$02,$22,$02,$2B,$02
        .byte   $22,$02,$15,$02,$20,$02,$25,$02
        .byte   $20,$02,$27,$02,$20,$02,$29,$02
        .byte   $20,$02,$1B,$02,$26,$02,$2B,$02
        .byte   $26,$02,$2B,$08,$B0,$C0,$FF
TRACK_1E_CH5_PATTERN:
;
; FIX
;
        .byte   $28,$38,$7F,$00
        ;.byte   $00
        ;         ^^
        ; This extra 0 byte in the original pattern broke the triangle
        ; channel for this track, turning the command parameters into
        ; commands and vice-versa. In particular the FX commands tend
        ; to generate very long rests or notes.
        .byte   $FC,$FE,$14,$01,$FB,$10,$FC,$FE
        .byte   $10,$01,$FB,$10,$FC,$FE,$12,$01
        .byte   $FB,$10,$FC,$FE,$14,$01,$FB,$10
        .byte   $FC,$FE,$14,$01,$FB,$10,$FC,$FE
        .byte   $20,$01,$FB,$10,$FC,$FE,$12,$01
        .byte   $FB,$10,$FC,$FE,$14,$01,$FB,$10
        .byte   $FC,$FE,$10,$01,$FB,$08,$FC,$FE
        .byte   $12,$01,$FB,$08,$FC,$FE,$17,$01
        .byte   $FB,$10,$FC,$FE,$15,$01,$FB,$10
        .byte   $FC,$FE,$1B,$01,$FB,$10,$B0,$D9
        .byte   $FF
        ; extra byte added to pad to original size
        .byte   $FF
;
; END FIX
;
TRACK_1F_ORDER:
        .byte   $03,$00
        .addr   TRACK_1F_CH0_PATTERN
        .byte   $01
        .addr   TRACK_1F_CH1_PATTERN
        .byte   $05
        .addr   TRACK_1F_CH5_PATTERN
        .byte   $03
        .addr   TRACK_1F_CH3_PATTERN
TRACK_1F_CH0_PATTERN:
        .byte   $05,$01,$1C,$00,$C3,$10,$FC,$FE
        .byte   $29,$02,$27,$02,$32,$02,$27,$02
        .byte   $FB,$04,$FC,$FE,$27,$02,$25,$02
        .byte   $30,$02,$25,$02,$FB,$04,$C3,$10
        .byte   $29,$06,$29,$02,$32,$02,$34,$02
        .byte   $36,$02,$37,$06,$36,$04,$34,$04
        .byte   $32,$04,$34,$06,$30,$16,$00,$04
        .byte   $29,$06,$29,$02,$32,$02,$34,$02
        .byte   $36,$02,$37,$06,$36,$04,$34,$04
        .byte   $32,$04,$39,$06,$34,$16,$00,$04
        .byte   $FC,$FE,$39,$06,$37,$06,$32,$04
        .byte   $FB,$02,$36,$04,$37,$02,$39,$16
        .byte   $00,$04,$FC,$FE,$39,$06,$37,$06
        .byte   $32,$04,$FB,$02,$36,$04,$37,$02
        .byte   $42,$16,$00,$04,$32,$06,$32,$02
        .byte   $32,$02,$34,$02,$35,$02,$34,$0E
        .byte   $00,$04,$35,$06,$35,$02,$35,$02
        .byte   $37,$02,$39,$02,$37,$0A,$34,$04
        .byte   $30,$04,$32,$1C,$FF
TRACK_1F_CH1_PATTERN:
        .byte   $15,$01,$19,$00,$C3,$10,$00,$01
        .byte   $FC,$FE,$29,$02,$27,$02,$32,$02
        .byte   $27,$02,$FB,$04,$FC,$FE,$27,$02
        .byte   $25,$02,$30,$02,$25,$02,$FB,$04
        .byte   $C3,$10,$29,$06,$29,$02,$32,$02
        .byte   $34,$02,$36,$02,$37,$06,$36,$04
        .byte   $34,$04,$32,$04,$34,$06,$30,$16
        .byte   $00,$04,$29,$06,$29,$02,$32,$02
        .byte   $34,$02,$36,$02,$37,$06,$36,$04
        .byte   $34,$04,$32,$04,$39,$06,$34,$16
        .byte   $00,$04,$FC,$FE,$39,$06,$37,$06
        .byte   $32,$04,$FB,$02,$36,$04,$37,$02
        .byte   $39,$16,$00,$04,$FC,$FE,$39,$06
        .byte   $37,$06,$32,$04,$FB,$02,$36,$04
        .byte   $37,$02,$42,$16,$00,$03,$2A,$06
        .byte   $2A,$02,$2A,$02,$30,$02,$32,$02
        .byte   $30,$0E,$00,$04,$32,$06,$32,$02
        .byte   $32,$02,$34,$02,$35,$02,$34,$0A
        .byte   $30,$04,$29,$04,$27,$0C,$29,$04
        .byte   $26,$0C,$FF
TRACK_1F_CH5_PATTERN:
        .byte   $25,$38,$18,$00,$FC,$FE,$22,$02
        .byte   $32,$02,$FB,$08,$FC,$FE,$20,$02
        .byte   $30,$02,$FB,$08,$FC,$FE,$22,$02
        .byte   $32,$02,$FB,$08,$FC,$FE,$20,$02
        .byte   $30,$02,$FB,$08,$FC,$FE,$22,$02
        .byte   $32,$02,$FB,$08,$FC,$FE,$20,$02
        .byte   $30,$02,$FB,$08,$FC,$FE,$1A,$02
        .byte   $2A,$02,$FB,$04,$FC,$FE,$20,$02
        .byte   $30,$02,$FB,$04,$FC,$FE,$22,$02
        .byte   $32,$02,$FB,$06,$FC,$FE,$20,$02
        .byte   $30,$02,$FB,$02,$FC,$FE,$1A,$02
        .byte   $2A,$02,$FB,$04,$FC,$FE,$20,$02
        .byte   $30,$02,$FB,$04,$FC,$FE,$22,$02
        .byte   $32,$02,$FB,$08,$FC,$FE,$1A,$02
        .byte   $2A,$02,$FB,$04,$FC,$FE,$20,$02
        .byte   $30,$02,$FB,$04,$FC,$FE,$1A,$02
        .byte   $2A,$02,$FB,$04,$FC,$FE,$20,$02
        .byte   $30,$02,$FB,$04,$FC,$FE,$22,$02
        .byte   $32,$02,$FB,$04,$FC,$FE,$22,$01
        .byte   $FB,$0C,$FF
TRACK_1F_CH3_PATTERN:
        .byte   $35,$00,$1A,$00,$C5,$10,$FC,$FE
        .byte   $06,$02,$06,$02,$03,$02,$06,$02
        .byte   $FB,$32,$FF
TRACK_20_ORDER:
        .byte   $03,$00
        .addr   TRACK_20_CH0_PATTERN
        .byte   $01
        .addr   TRACK_20_CH1_PATTERN
        .byte   $05
        .addr   TRACK_20_CH5_PATTERN
        .byte   $03
        .addr   TRACK_20_CH3_PATTERN
TRACK_20_CH0_PATTERN:
        .byte   $07,$02,$1A,$00,$C3,$20,$FC,$FE
        .byte   $2B,$02,$30,$01,$2B,$01,$29,$02
        .byte   $2B,$02,$30,$04,$2B,$02,$29,$02
        .byte   $27,$06,$27,$02,$29,$02,$27,$04
        .byte   $29,$02,$27,$06,$27,$02,$29,$02
        .byte   $27,$04,$29,$02,$2B,$0C,$00,$04
        .byte   $2B,$02,$30,$01,$2B,$01,$29,$02
        .byte   $2B,$02,$30,$04,$2B,$02,$29,$02
        .byte   $27,$06,$27,$02,$29,$02,$27,$04
        .byte   $29,$02,$27,$06,$27,$02,$29,$02
        .byte   $27,$04,$29,$02,$27,$0C,$00,$04
        .byte   $2B,$04,$26,$02,$29,$02,$27,$06
        .byte   $26,$02,$24,$02,$26,$02,$27,$02
        .byte   $24,$02,$22,$06,$00,$02,$2B,$04
        .byte   $26,$02,$29,$02,$27,$06,$26,$02
        .byte   $24,$02,$26,$02,$27,$02,$29,$02
        .byte   $29,$06,$00,$02,$FB,$00,$FF
TRACK_20_CH1_PATTERN:
        .byte   $17,$02,$18,$00,$00,$01,$C3,$10
        .byte   $FC,$FE,$2B,$02,$30,$01,$2B,$01
        .byte   $29,$02,$2B,$02,$30,$04,$2B,$02
        .byte   $29,$02,$27,$06,$27,$02,$29,$02
        .byte   $27,$04,$29,$02,$27,$06,$27,$02
        .byte   $29,$02,$27,$04,$29,$02,$2B,$0C
        .byte   $00,$04,$2B,$02,$30,$01,$2B,$01
        .byte   $29,$02,$2B,$02,$30,$04,$2B,$02
        .byte   $29,$02,$27,$06,$27,$02,$29,$02
        .byte   $27,$04,$29,$02,$27,$06,$27,$02
        .byte   $29,$02,$27,$04,$29,$02,$27,$0C
        .byte   $00,$04,$2B,$04,$26,$02,$29,$02
        .byte   $27,$06,$26,$02,$24,$02,$26,$02
        .byte   $27,$02,$24,$02,$22,$06,$00,$02
        .byte   $2B,$04,$26,$02,$29,$02,$27,$06
        .byte   $26,$02,$24,$02,$26,$02,$27,$02
        .byte   $29,$02,$29,$06,$00,$02,$FB,$00
        .byte   $FF
TRACK_20_CH5_PATTERN:
        .byte   $27,$38,$7F,$00,$FC,$FE,$27,$06
        .byte   $27,$02,$26,$06,$26,$02,$25,$06
        .byte   $25,$02,$24,$06,$24,$02,$20,$06
        .byte   $20,$02,$22,$06,$22,$02,$27,$06
        .byte   $27,$02,$22,$06,$22,$02,$27,$06
        .byte   $27,$02,$26,$06,$26,$02,$25,$06
        .byte   $25,$02,$24,$06,$24,$02,$20,$06
        .byte   $20,$02,$22,$06,$22,$02,$27,$06
        .byte   $27,$02,$27,$06,$27,$02,$23,$06
        .byte   $23,$02,$24,$06,$24,$02,$20,$06
        .byte   $20,$02,$27,$06,$27,$02,$23,$06
        .byte   $23,$02,$24,$06,$24,$02,$20,$06
        .byte   $20,$02,$22,$06,$22,$02,$FB,$00
        .byte   $FF
TRACK_20_CH3_PATTERN:
        .byte   $37,$00,$16,$00,$C5,$10,$FC,$FE
        .byte   $03,$02,$03,$02,$03,$01,$03,$01
        .byte   $03,$01,$03,$01,$03,$02,$03,$06
        .byte   $FB,$00,$FF
TRACK_21_ORDER:
        .byte   $00,$03
        .addr   TRACK_21_CH3_PATTERN
TRACK_21_CH3_PATTERN:
        .byte   $30,$00,$10,$00,$00,$78,$F9,$1F
        .byte   $C9,$20,$FC,$FE,$0D,$10,$FB,$10
        .byte   $EF,$18,$FC,$FE,$0E,$10,$FB,$16
        .byte   $FF,$FF
TRACK_22_ORDER:
        .byte   $01,$01
        .addr   TRACK_22_CH1_PATTERN
        .byte   $03
        .addr   TRACK_22_CH3_PATTERN
TRACK_22_CH1_PATTERN:
        .byte   $10,$02,$10,$8E,$DF,$3C,$C9,$20
        .byte   $FC,$FE,$10,$10,$11,$10,$12,$10
        .byte   $13,$10,$FB,$00,$FF,$FF
TRACK_22_CH3_PATTERN:
        .byte   $30,$00,$1F,$00,$EF,$0A,$0F,$30
        .byte   $F9,$1F,$FC,$FE,$0F,$10,$FB,$00
        .byte   $FF,$FF
TRACK_23_ORDER:
        .byte   $01,$01
        .addr   TRACK_23_CH1_PATTERN
        .byte   $03
        .addr   TRACK_23_CH3_PATTERN
TRACK_23_CH1_PATTERN:
        .byte   $10,$02,$18,$8D,$FC,$FE,$50,$04
        .byte   $51,$04,$52,$04,$51,$04,$FB,$00
        .byte   $FF,$FF
TRACK_23_CH3_PATTERN:
        .byte   $30,$00,$15,$00,$FC,$FE,$0C,$10
        .byte   $FB,$00,$FF,$FF
;
; FIX
;
; a fixed version of TRACK_01_CH1_PATTERN inserted into unused space here.
;
.feature force_range ; required to allow negative byte data in ca65
TRACK_01_CH1_PATTERN_FIXED:
        .byte   $16,$01,$14,$00 ; speed 6, duty 1, volume constant 4, no sweep
        .byte   $C5,$10 ; envelope 5
        .byte   $FC,$FE ; repeat point
        ;
        ; it was very easy to save space here with the BX command for phrase repeats
        ;
        .byte   $00,$02,$2B,$01,$2B,$01,$00,$02,$32,$01,$32,$01 ; 0  ..bb..dd
        .byte   $B2, -6                                         ;    ..bb..dd
        .byte   $00,$02,$30,$01,$30,$01,$00,$02,$34,$01,$34,$01 ; 1  ..cc..ee
        .byte   $B2, -6                                         ;    ..cc..ee
        .byte   $00,$02,$32,$01,$32,$01,$00,$02,$36,$01,$36,$01 ; 2  ..dd..FF
        .byte   $B2, -6                                         ;    ..dd..FF
        .byte   $00,$02,$2B,$01,$2B,$01,$00,$02,$32,$01,$32,$01 ; 3  ..bb..dd
        .byte   $00,$02,$32,$01,$32,$01,$00,$02,$36,$01,$36,$01 ;    ..dd..FF
        .byte   $00,$02,$2B,$01,$2B,$01,$00,$02,$32,$01,$32,$01 ; 4  ..bb..dd
        .byte   $B2, -6                                         ;    ..bb..dd
        .byte   $00,$02,$30,$01,$30,$01,$00,$02,$34,$01,$34,$01 ; 5  ..cc..ee
        .byte   $B2, -6                                         ;    ..cc..ee
        .byte   $00,$02,$32,$01,$32,$01,$00,$02,$36,$01,$36,$01 ; 6  ..dd..FF
        .byte   $B2, -6                                         ;    ..dd..FF
        .byte   $00,$02,$2B,$01,$2B,$01,$00,$02,$32,$01,$32,$01 ; 7  ..bb..dd
        .byte   $B2, -6                                         ;    ..bb..dd
        .byte   $00,$02,$30,$01,$30,$01,$00,$02,$34,$01,$34,$01 ; 8  ..cc..ee
        .byte   $00,$02,$32,$01,$32,$01,$00,$02,$36,$01,$36,$01 ;    ..dd..FF
        .byte   $00,$02,$2B,$01,$2B,$01,$00,$02,$32,$01,$32,$01 ; 9  ..bb..dd
        .byte   $00,$02,$27,$01,$27,$01,$00,$02,$2B,$01,$2B,$01 ;    ..gg..bb
        .byte   $B3, -24                                        ; 10 ..cc..ee
                                                                ;    ..dd..FF
                                                                ; 11 ..bb..dd
                                                                ;    ..gg..bb
                                                                ; 12 ..cc..ee
                                                                ;    ..dd..FF
                                                                ; 13 ..bb..dd
                                                                ;    ..gg..bb
        .byte   $00,$02,$29,$01,$29,$01,$00,$02,$30,$01,$30,$01 ; 14 ..aa..cc
        .byte   $00,$02,$2B,$01,$2B,$01,$00,$02,$32,$01,$32,$01 ;    ..bb..dd
        .byte   $00,$02,$30,$01,$30,$01,$00,$02,$34,$01,$34,$01 ; 15 ..cc..ee
        .byte   $00,$02,$32,$01,$32,$01,$00,$02,$36,$01,$36,$01 ;    ..dd..FF
        .byte   $FB,$00 ; go to repeat point (always)

.segment "BANK09_FIX"
PADDING_CA04:
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;       .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
;
; END FIX
;
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE
UNKNOWN_D000:
        .byte   $20,$60,$A0,$E0,$20,$60,$20,$20
        .byte   $D0,$D0,$D0,$D0,$D1,$D1,$D0,$D0
        .byte   $40,$80,$C0,$00,$40,$80,$40,$40
        .byte   $D0,$D0,$D0,$D1,$D1,$D1,$D0,$D0
        .byte   $C0,$CF,$4E,$DE,$DF,$43,$C0,$98
        .byte   $68,$5E,$73,$AB,$D1,$EC,$07,$22
        .byte   $4F,$E8,$5E,$CF,$B5,$C0,$00,$DE
        .byte   $A0,$A0,$A0,$A0,$E8,$A3,$0A,$BC
        .byte   $D4,$D4,$D4,$D4,$D2,$D3,$D2,$D2
        .byte   $D3,$D2,$D2,$D2,$D1,$D1,$D2,$D2
        .byte   $D2,$D3,$D5,$D5,$D1,$D1,$D7,$D5
        .byte   $D1,$D1,$D1,$D1,$D3,$D3,$D4,$D5
        .byte   $D3,$A0,$A0,$A0,$A0,$A0,$A0,$A0
        .byte   $A0,$5E,$73,$A0,$A0,$A0,$A0,$A0
        .byte   $A0,$E8,$A0,$AB,$06,$68,$98,$A0
        .byte   $A0,$A0,$A0,$A0,$29,$10,$F7,$DE
        .byte   $D3,$D1,$D1,$D1,$D1,$D1,$D1,$D1
        .byte   $D1,$D2,$D2,$D1,$D1,$D1,$D1,$D1
        .byte   $D1,$D3,$D1,$D2,$D6,$D3,$D2,$D1
        .byte   $D1,$D1,$D1,$D1,$D8,$D8,$D7,$D7
        .byte   $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0
        .byte   $A0,$5B,$73,$DE,$DE,$AB,$DF,$20
        .byte   $C0,$AF,$5E,$C0,$10,$35,$3B,$E8
        .byte   $A0,$A0,$A0,$A0,$ED,$B8,$A3,$94
        .byte   $D1,$D1,$D1,$D1,$D1,$D1,$D1,$D1
        .byte   $D1,$D7,$D2,$D4,$D5,$D2,$D2,$D7
        .byte   $D4,$D5,$D5,$D1,$D5,$D5,$D6,$D3
        .byte   $D1,$D1,$D1,$D1,$D4,$D3,$D3,$D3
        .byte   $A5,$B2,$BF,$CC,$D9,$E6,$F3,$A0
        .byte   $A0,$5B,$A0,$A0,$A0,$AB,$A0,$A0
        .byte   $A0,$A0,$A0,$A0,$A0,$35,$A0,$E8
        .byte   $A0,$A0,$A0,$0B,$ED,$B8,$A0,$94
        .byte   $D6,$D6,$D6,$D6,$D6,$D6,$D6,$D1
        .byte   $D1,$D7,$D1,$D1,$D1,$D2,$D1,$D1
        .byte   $D1,$D1,$D1,$D1,$D1,$D5,$D1,$D3
        .byte   $D1,$D1,$D1,$D7,$D4,$D3,$D1,$D3
        .byte   $C0,$CF,$4E,$DE,$DF,$43,$C0,$98
        .byte   $68,$5E,$73,$AB,$D1,$EC,$07,$95
        .byte   $A0,$E8,$A0,$CF,$B5,$C0,$00,$DE
        .byte   $A0,$A0,$A0,$A0,$E8,$A0,$A0,$BC
        .byte   $D4,$D4,$D4,$D4,$D2,$D3,$D2,$D2
        .byte   $D3,$D2,$D2,$D2,$D1,$D1,$D2,$D7
        .byte   $D1,$D3,$D1,$D5,$D1,$D1,$D7,$D5
        .byte   $D1,$D1,$D1,$D1,$D3,$D1,$D1,$D5
        .byte   $C0,$CF,$4E,$DE,$DF,$43,$C0,$98
        .byte   $68,$5E,$73,$AB,$D1,$EC,$3E,$22
        .byte   $4F,$E8,$5E,$CF,$B5,$C0,$00,$DE
        .byte   $A0,$A0,$A0,$A0,$E8,$7E,$0A,$BC
        .byte   $D4,$D4,$D4,$D4,$D2,$D3,$D2,$D2
        .byte   $D3,$D2,$D2,$D2,$D1,$D1,$D7,$D2
        .byte   $D2,$D3,$D5,$D5,$D1,$D1,$D7,$D5
        .byte   $D1,$D1,$D1,$D1,$D3,$D7,$D4,$D5
        .byte   $01,$02,$A7,$D1,$04,$AE,$D1,$10
        .byte   $02,$10,$8C,$04,$03,$FF,$30,$00
        .byte   $10,$00,$06,$03,$FF,$00,$02,$B9
        .byte   $D1,$10,$02,$13,$8C,$29,$08,$FF
        .byte   $00,$04,$C4,$D1,$30,$00,$16,$00
        .byte   $C5,$10,$0A,$04,$00,$02,$08,$02
        .byte   $FF,$01,$02,$D8,$D1,$04,$E3,$D1
        .byte   $10,$02,$17,$8C,$24,$03,$F6,$84
        .byte   $30,$06,$FF,$30,$00,$14,$00,$06
        .byte   $02,$03,$03,$FF,$01,$02,$F3,$D1
        .byte   $04,$FE,$D1,$10,$02,$19,$8C,$24
        .byte   $04,$F6,$84,$30,$07,$FF,$30,$00
        .byte   $16,$00,$06,$03,$03,$03,$FF,$01
        .byte   $02,$0E,$D2,$04,$19,$D2,$10,$02
        .byte   $19,$00,$39,$07,$F6,$94,$40,$0A
        .byte   $FF,$30,$00,$15,$00,$03,$04,$01
        .byte   $04,$FF,$01,$02,$29,$D2,$04,$34
        .byte   $D2,$10,$02,$19,$8E,$09,$10,$F6
        .byte   $85,$17,$10,$FF,$31,$00,$14,$00
        .byte   $06,$01,$05,$01,$04,$01,$03,$01
        .byte   $02,$01,$01,$01,$04,$01,$03,$01
        .byte   $02,$01,$01,$01,$06,$01,$FF,$00
        .byte   $02,$53,$D2,$10,$02,$19,$8B,$09
        .byte   $08,$C5,$10,$60,$04,$FF,$00,$04
        .byte   $62,$D2,$30,$00,$1A,$00,$FC,$FE
        .byte   $08,$02,$00,$01,$FB,$04,$EF,$02
        .byte   $0A,$30,$FF,$01,$02,$7A,$D2,$04
        .byte   $81,$D2,$10,$01,$14,$8B,$20,$08
        .byte   $FF,$30,$00,$1A,$00,$09,$01,$08
        .byte   $01,$07,$01,$06,$01,$05,$01,$04
        .byte   $01,$03,$01,$02,$01,$01,$01,$FF
        .byte   $00,$02,$9C,$D2,$10,$02,$1F,$8B
        .byte   $09,$04,$F6,$00,$49,$01,$F6,$82
        .byte   $29,$08,$FF,$00,$02,$AF,$D2,$11
        .byte   $02,$1A,$00,$C5,$30,$30,$01,$34
        .byte   $01,$37,$01,$3B,$01,$42,$01,$FF
        .byte   $01,$02,$C7,$D2,$04,$D4,$D2,$10
        .byte   $02,$1D,$8D,$C5,$30,$30,$04,$00
        .byte   $02,$39,$04,$FF,$30,$00,$18,$00
        .byte   $06,$04,$00,$02,$03,$04,$FF,$01
        .byte   $02,$E6,$D2,$04,$F7,$D2,$13,$02
        .byte   $1A,$84,$29,$01,$2A,$01,$2B,$01
        .byte   $30,$01,$31,$01,$32,$02,$FF,$32
        .byte   $00,$1C,$00,$EF,$01,$09,$10,$FF
        .byte   $01,$02,$07,$D3,$04,$2C,$D3,$11
        .byte   $02,$1F,$95,$F9,$12,$DF,$01,$19
        .byte   $01,$20,$01,$21,$01,$22,$01,$23
        .byte   $01,$24,$01,$25,$01,$26,$01,$27
        .byte   $01,$28,$01,$29,$01,$2A,$01,$2B
        .byte   $01,$30,$01,$FF,$32,$00,$19,$00
        .byte   $C1,$10,$08,$01,$07,$01,$06,$01
        .byte   $05,$01,$04,$01,$03,$01,$02,$01
        .byte   $01,$01,$FF,$01,$02,$4A,$D3,$04
        .byte   $51,$D3,$10,$02,$14,$95,$30,$0D
        .byte   $FF,$30,$00,$1F,$00,$C5,$10,$0B
        .byte   $01,$0C,$01,$0D,$06,$00,$06,$01
        .byte   $01,$05,$01,$C5,$10,$07,$10,$FF
        .byte   $01,$02,$6F,$D3,$04,$7A,$D3,$10
        .byte   $02,$17,$8D,$30,$03,$F6,$84,$30
        .byte   $05,$FF,$30,$00,$15,$00,$04,$05
        .byte   $F9,$18,$03,$05,$FF,$00,$02,$89
        .byte   $D3,$11,$00,$1A,$00,$C8,$40,$F7
        .byte   $30,$60,$80,$FF,$00,$02,$98,$D3
        .byte   $12,$02,$1B,$00,$C1,$10,$29,$01
        .byte   $2C,$01,$FF,$00,$02,$A7,$D3,$00
        .byte   $00,$1D,$00,$39,$01,$3A,$01,$3B
        .byte   $01,$40,$01,$41,$01,$00,$08,$FF
        .byte   $01,$02,$BF,$D3,$04,$CA,$D3,$12
        .byte   $02,$19,$00,$C1,$10,$44,$01,$41
        .byte   $01,$FF,$30,$00,$14,$00,$C5,$10
        .byte   $03,$01,$FF,$00,$02,$D7,$D3,$10
        .byte   $02,$03,$00,$FC,$FE,$40,$04,$37
        .byte   $04,$FB,$03,$40,$04,$37,$10,$FF
        .byte   $00,$02,$EC,$D3,$10,$02,$17,$00
        .byte   $C5,$10,$30,$01,$37,$01,$42,$01
        .byte   $FF,$00,$02,$FD,$D3,$10,$02,$16
        .byte   $00,$C5,$10,$57,$01,$58,$01,$59
        .byte   $10,$FF,$00,$04,$0E,$D4,$30,$00
        .byte   $19,$00,$08,$30,$FF,$01,$02,$1C
        .byte   $D4,$04,$37,$D4,$10,$00,$19,$84
        .byte   $19,$01,$1A,$01,$1B,$01,$20,$01
        .byte   $21,$01,$22,$01,$21,$01,$20,$01
        .byte   $1B,$01,$1A,$01,$19,$01,$FF,$30
        .byte   $00,$15,$00,$0E,$01,$0F,$01,$0E
        .byte   $01,$0D,$01,$0C,$01,$0B,$01,$0D
        .byte   $01,$0E,$01,$0F,$01,$FF,$01,$02
        .byte   $55,$D4,$04,$70,$D4,$11,$00,$19
        .byte   $84,$49,$01,$4A,$01,$4B,$01,$50
        .byte   $01,$51,$01,$52,$01,$51,$01,$50
        .byte   $01,$4B,$01,$4A,$01,$49,$01,$FF
        .byte   $31,$00,$18,$00,$05,$01,$06,$01
        .byte   $05,$01,$04,$01,$03,$01,$02,$01
        .byte   $03,$01,$05,$01,$06,$01,$FF,$01
        .byte   $02,$8E,$D4,$04,$A9,$D4,$10,$00
        .byte   $19,$84,$09,$01,$0A,$01,$0B,$01
        .byte   $10,$01,$11,$01,$12,$01,$11,$01
        .byte   $10,$01,$0B,$02,$0A,$02,$09,$04
        .byte   $FF,$30,$00,$15,$00,$0E,$01,$0F
        .byte   $01,$0E,$01,$0D,$01,$0C,$01,$0B
        .byte   $01,$0D,$01,$0E,$01,$0F,$01,$FF
        .byte   $00,$04,$C4,$D4,$30,$01,$1F,$00
        .byte   $EF,$05,$18,$08,$1B,$80,$FF,$00
        .byte   $04,$D3,$D4,$30,$00,$1F,$00,$EF
        .byte   $03,$19,$08,$1C,$60,$FF,$00,$04
        .byte   $E2,$D4,$30,$01,$1F,$00,$EF,$03
        .byte   $1A,$08,$1E,$40,$FF,$00,$02,$F1
        .byte   $D4,$10,$02,$19,$00,$F6,$C0,$29
        .byte   $01,$38,$01,$43,$01,$35,$01,$50
        .byte   $01,$23,$01,$3A,$01,$36,$01,$5A
        .byte   $01,$3A,$01,$36,$01,$5A,$01,$FF
        .byte   $00,$02,$14,$D5,$10,$02,$1D,$85
        .byte   $10,$01,$11,$01,$00,$01,$12,$01
        .byte   $13,$01,$00,$01,$14,$01,$15,$01
        .byte   $00,$01,$16,$01,$17,$01,$00,$01
        .byte   $18,$01,$19,$01,$FF,$01,$02,$3C
        .byte   $D5,$04,$55,$D5,$10,$02,$1A,$8C
        .byte   $C9,$18,$EF,$05,$17,$06,$16,$06
        .byte   $15,$06,$14,$06,$13,$06,$12,$06
        .byte   $11,$06,$10,$06,$FF,$30,$00,$19
        .byte   $00,$EF,$05,$03,$30,$FF,$01,$02
        .byte   $65,$D5,$04,$6E,$D5,$10,$02,$1D
        .byte   $8E,$C8,$40,$10,$40,$FF,$34,$00
        .byte   $1C,$00,$C8,$40,$07,$01,$08,$01
        .byte   $07,$01,$06,$01,$05,$01,$04,$01
        .byte   $03,$01,$02,$01,$FF,$00,$02,$89
        .byte   $D5,$10,$02,$1F,$8C,$C1,$10,$19
        .byte   $0C,$20,$14,$FF,$00,$02,$98,$D5
        .byte   $11,$02,$1A,$86,$C3,$28,$10,$08
        .byte   $F6,$8F,$FC,$FE,$10,$02,$11,$04
        .byte   $FB,$03,$F6,$86,$10,$08,$FF,$00
        .byte   $02,$B3,$D5,$10,$02,$1F,$94,$C8
        .byte   $40,$60,$50,$FF,$00,$02,$C0,$D5
        .byte   $11,$02,$16,$00,$C1,$10,$57,$01
        .byte   $58,$01,$59,$10,$00,$18,$FF,$00
        .byte   $02,$D3,$D5,$10,$01,$1A,$00,$C8
        .byte   $0A,$F7,$40,$30,$0A,$FF,$00,$02
        .byte   $E2,$D5,$10,$02,$1B,$8C,$C3,$18
        .byte   $09,$08,$10,$10,$FF,$00,$04,$F1
        .byte   $D5,$30,$00,$1F,$00,$CA,$1A,$EF
        .byte   $07,$0A,$18,$0B,$18,$0C,$14,$0D
        .byte   $10,$0E,$0A,$0F,$08,$FF,$01,$02
        .byte   $0D,$D6,$04,$1C,$D6,$10,$02,$1A
        .byte   $8D,$33,$48,$00,$08,$C9,$1A,$70
        .byte   $18,$70,$04,$FF,$30,$00,$1F,$00
        .byte   $06,$08,$05,$08,$04,$08,$03,$08
        .byte   $02,$08,$01,$08,$01,$08,$01,$08
        .byte   $01,$08,$00,$08,$C9,$18,$03,$18
        .byte   $03,$06,$FF,$01,$02,$42,$D6,$04
        .byte   $4D,$D6,$10,$00,$19,$8C,$20,$08
        .byte   $F6,$84,$40,$20,$FF,$30,$00,$1F
        .byte   $00,$EF,$03,$09,$04,$06,$04,$03
        .byte   $04,$04,$04,$05,$04,$06,$04,$07
        .byte   $04,$08,$04,$09,$04,$0A,$04,$0B
        .byte   $04,$0C,$04,$FF,$00,$04,$70,$D6
        .byte   $33,$00,$1F,$00,$09,$01,$08,$01
        .byte   $07,$01,$06,$01,$08,$01,$07,$01
        .byte   $06,$01,$05,$01,$07,$01,$06,$01
        .byte   $05,$01,$04,$01,$06,$01,$05,$01
        .byte   $04,$01,$03,$01,$05,$01,$04,$01
        .byte   $03,$01,$02,$01,$04,$01,$03,$01
        .byte   $02,$01,$01,$01,$FF,$00,$02,$A9
        .byte   $D6,$12,$02,$1F,$00,$C2,$28,$20
        .byte   $18,$FF,$00,$02,$B6,$D6,$12,$02
        .byte   $1F,$00,$C2,$28,$22,$18,$FF,$00
        .byte   $02,$C3,$D6,$12,$02,$1F,$00,$C2
        .byte   $28,$24,$18,$FF,$00,$02,$D0,$D6
        .byte   $12,$02,$1F,$00,$C2,$28,$25,$18
        .byte   $FF,$00,$02,$DD,$D6,$12,$02,$1F
        .byte   $00,$C2,$28,$27,$18,$FF,$00,$02
        .byte   $EA,$D6,$12,$02,$1F,$00,$C2,$28
        .byte   $29,$18,$FF,$00,$02,$F7,$D6,$12
        .byte   $02,$1F,$00,$C2,$28,$2B,$18,$FF
        .byte   $00,$02,$04,$D7,$10,$02,$16,$8C
        .byte   $29,$10,$FF,$00,$02,$0F,$D7,$10
        .byte   $00,$1F,$C5,$C6,$18,$27,$03,$28
        .byte   $03,$27,$03,$2A,$03,$00,$03,$FF
        .byte   $00,$02,$24,$D7,$10,$02,$1F,$CD
        .byte   $C8,$40,$40,$50,$FF,$00,$04,$31
        .byte   $D7,$30,$00,$1F,$00,$EF,$04,$1E
        .byte   $08,$00,$02,$1E,$02,$FF,$00,$04
        .byte   $42,$D7,$30,$00,$1F,$00,$0E,$01
        .byte   $00,$01,$0D,$01,$00,$01,$0C,$01
        .byte   $00,$01,$0B,$01,$00,$01,$0A,$01
        .byte   $00,$16,$FF,$00,$02,$5F,$D7,$12
        .byte   $02,$1F,$00,$C5,$10,$50,$01,$50
        .byte   $01,$54,$01,$54,$01,$57,$01,$57
        .byte   $01,$54,$01,$54,$01,$57,$01,$57
        .byte   $01,$C5,$30,$60,$04,$FF,$00,$04
        .byte   $82,$D7,$30,$00,$1F,$00,$C5,$10
        .byte   $0B,$04,$00,$10,$0A,$14,$0A,$04
        .byte   $00,$10,$09,$14,$FF,$00,$02,$99
        .byte   $D7,$10,$01,$1F,$83,$40,$08,$41
        .byte   $01,$42,$01,$43,$01,$44,$01,$43
        .byte   $01,$3A,$01,$39,$01,$38,$01,$37
        .byte   $01,$36,$01,$36,$01,$36,$01,$36
        .byte   $01,$36,$01,$36,$01,$35,$01,$35
        .byte   $01,$35,$01,$35,$01,$35,$01,$35
        .byte   $01,$35,$01,$35,$01,$34,$01,$34
        .byte   $01,$34,$01,$35,$01,$34,$01,$34
        .byte   $01,$34,$01,$35,$01,$FF,$01,$02
        .byte   $E5,$D7,$04,$EE,$D7,$10,$00,$1F
        .byte   $00,$C9,$20,$0C,$10,$FF,$30,$00
        .byte   $1F,$00,$C9,$20,$0A,$10,$FF,$01
        .byte   $02,$FE,$D7,$04,$07,$D8,$10,$00
        .byte   $1B,$00,$C9,$20,$0B,$10,$FF,$30
        .byte   $00,$1B,$00,$C9,$20,$0B,$10,$FF
        .byte   $01,$02,$17,$D8,$04,$20,$D8,$10
        .byte   $00,$17,$00,$C9,$20,$0A,$10,$FF
        .byte   $30,$00,$17,$00,$C9,$20,$0C,$10
        .byte   $FF,$01,$02,$30,$D8,$04,$39,$D8
        .byte   $10,$00,$13,$00,$C9,$20,$09,$10
        .byte   $FF,$30,$00,$13,$00,$C9,$20,$0D
        .byte   $10,$FF
PADDING_D842:
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0
        .byte   $FE

.segment "BANK1F"
BANK_TAG_1F:
        .byte   $1F,$00
UNKNOWN_E002:
        .byte   $04,$06,$00,$01,$02,$03
        .byte   $1D,$00,$53,$54,$41,$52,$54,$52
        .byte   $4F,$50,$49,$43,$53,$20,$20,$52
        .byte   $44,$33,$A9,$08,$8D,$00,$20,$A9
        .byte   $06,$8D,$01,$20,$AD,$02,$20,$10
        .byte   $F1,$AD,$02,$20,$10,$FB,$A9,$08
        .byte   $8D,$00,$20,$A9,$06,$8D,$01,$20
        .byte   $A9,$00,$8D,$10,$40,$8D,$11,$40
        .byte   $A9,$40,$8D,$17,$40,$A9,$0F,$8D
        .byte   $15,$40,$A2,$08,$A0,$00,$98,$09
        .byte   $60,$8D,$00,$80,$B9,$02,$E0,$8D
        .byte   $01,$80,$C8,$CA,$D0,$F0,$A9,$00
        .byte   $8D,$00,$A0,$A9,$30,$8D,$01,$A0
        .byte   $8D,$00,$E0,$A2,$00,$A0,$0F,$B9
        .byte   $00,$01,$D9,$0A,$E0,$D0,$24,$88
        .byte   $10,$F5,$30,$1F,$A2,$01,$A0,$D0
        .byte   $A9,$00,$85,$E0,$86,$E1,$91,$E0
        .byte   $C8,$D0,$FB,$E8,$E0,$08,$D0,$F4
        .byte   $A2,$00,$86,$E1,$91,$E0,$C8,$D0
        .byte   $FB,$F0,$1C,$A2,$07,$A0,$00,$98
        .byte   $85,$E0,$86,$E1,$91,$E0,$C8,$D0
        .byte   $FB,$CA,$10,$F6,$A0,$0F,$B9,$0A
        .byte   $E0,$99,$00,$01,$88,$10,$F7,$A2
        .byte   $71,$A0,$00,$98,$85,$E0,$86,$E1
        .byte   $91,$E0,$C8,$D0,$FB,$CA,$E0,$6F
        .byte   $D0,$F4,$A2,$0F,$A9,$01,$9D,$90
        .byte   $07,$CA,$10,$FA,$A9,$28,$8D,$00
        .byte   $20,$85,$10,$A9,$06,$8D,$01,$20
        .byte   $85,$11,$20,$F3,$FE,$A9,$60,$85
        .byte   $0E,$A9,$01,$85,$20,$85,$21,$AD
        .byte   $02,$20,$A5,$10,$09,$80,$85,$10
        .byte   $8D,$00,$20,$A9,$8F,$A0,$20,$99
        .byte   $A0,$01,$88,$10,$FA,$A9,$00,$85
        .byte   $21,$A9,$02,$20,$BA,$E5,$A9,$01
        .byte   $85,$21,$AD,$01,$80,$F0,$3E,$A9
        .byte   $81,$8D,$92,$01,$A5,$DB,$10,$12
        .byte   $29,$7F,$85,$DB,$A5,$D9,$10,$18
        .byte   $29,$7F,$85,$D9,$20,$50,$93,$4C
        .byte   $97,$E1,$A5,$D9,$10,$1F,$29,$7F
        .byte   $85,$D9,$20,$3D,$93,$4C,$97,$E1
        .byte   $A9,$08,$85,$01,$85,$05,$A9,$97
        .byte   $85,$02,$A9,$81,$85,$00,$A9,$00
        .byte   $8D,$92,$01,$F0,$42,$A9,$81,$8D
        .byte   $67,$71,$20,$C6,$94,$F0,$05,$20
        .byte   $01,$94,$D0,$F1,$20,$8D,$94,$AD
        .byte   $94,$01,$D0,$0F,$A9,$01,$85,$21
        .byte   $20,$0E,$B0,$A2,$00,$86,$21,$E8
        .byte   $8E,$94,$01,$A9,$80,$8D,$67,$71
        .byte   $A9,$81,$8D,$00,$03,$20,$00,$E6
        .byte   $AD,$00,$03,$C9,$80,$D0,$F6,$A9
        .byte   $1D,$20,$D3,$E5,$20,$9A,$E5,$A9
        .byte   $1D,$20,$D3,$E5,$AD,$90,$01,$C9
        .byte   $83,$D0,$08,$20,$C9,$E4,$A9,$1D
        .byte   $20,$D3,$E5,$A9,$00,$20,$C1,$E5
        .byte   $A9,$01,$85,$20,$85,$21,$A5,$01
        .byte   $30,$03,$4C,$85,$E2,$29,$7F,$85
        .byte   $01,$85,$05,$A2,$81,$86,$02,$A9
        .byte   $00,$8D,$34,$01,$8D,$35,$01,$20
        .byte   $1D,$98,$AD,$0A,$C0,$85,$E6,$AD
        .byte   $0B,$C0,$85,$E7,$A4,$01,$88,$98
        .byte   $20,$F4,$E5,$A8,$B1,$E6,$85,$A0
        .byte   $C8,$B1,$E6,$C8,$B1,$E6,$85,$E4
        .byte   $C8,$C8,$C8,$C8,$C8,$B1,$E6,$8D
        .byte   $9B,$01,$8D,$67,$71,$20,$E5,$E5
        .byte   $A9,$80,$85,$2A,$A9,$00,$85,$21
        .byte   $A9,$40,$85,$E5,$20,$B8,$E5,$C6
        .byte   $E5,$D0,$F9,$C6,$E4,$D0,$F1,$20
        .byte   $9A,$E5,$A9,$01,$85,$21,$A9,$00
        .byte   $A2,$0F,$9D,$20,$01,$CA,$10,$FA
        .byte   $98,$29,$F0,$09,$0E,$A8,$20,$A3
        .byte   $9A,$A0,$00,$B1,$E4,$99,$10,$01
        .byte   $C8,$C0,$04,$D0,$F6,$B1,$E4,$8D
        .byte   $20,$01,$C8,$B1,$E4,$8D,$28,$01
        .byte   $C8,$B1,$E4,$85,$0B,$C8,$A9,$00
        .byte   $8D,$1A,$01,$8D,$1B,$01,$A9,$03
        .byte   $8D,$17,$01,$A9,$01,$8D,$9D,$01
        .byte   $D0,$23,$A9,$1D,$20,$D3,$E5,$A9
        .byte   $00,$85,$A5,$20,$5E,$E5,$AD,$90
        .byte   $01,$20,$C9,$E4,$A9,$1D,$20,$D3
        .byte   $E5,$A5,$00,$09,$80,$85,$00,$A5
        .byte   $02,$09,$80,$85,$02,$A9,$00,$20
        .byte   $C1,$E5,$A9,$01,$85,$21,$AD,$0C
        .byte   $C0,$85,$E6,$AD,$0D,$C0,$85,$E7
        .byte   $A5,$01,$20,$96,$9A,$A5,$02,$20
        .byte   $96,$9A,$A5,$00,$C9,$83,$F0,$26
        .byte   $A0,$01,$20,$A3,$9A,$A0,$00,$A2
        .byte   $00,$A9,$08,$85,$E3,$A9,$03,$85
        .byte   $E2,$A9,$8F,$9D,$A0,$01,$E8,$B1
        .byte   $E4,$9D,$A0,$01,$E8,$C8,$C6,$E2
        .byte   $D0,$F5,$C6,$E3,$D0,$E7,$A5,$00
        .byte   $29,$7F,$85,$00,$C9,$02,$90,$20
        .byte   $F0,$11,$20,$25,$95,$AD,$90,$01
        .byte   $C9,$82,$F0,$04,$A2,$01,$D0,$38
        .byte   $4C,$62,$E2,$A5,$02,$29,$7F,$85
        .byte   $02,$20,$44,$97,$A2,$00,$F0,$28
        .byte   $20,$A1,$98,$A9,$80,$85,$50,$85
        .byte   $51,$20,$BA,$92,$A5,$17,$85,$13
        .byte   $A5,$18,$85,$14,$A5,$1B,$85,$15
        .byte   $A5,$1C,$85,$16,$A5,$36,$09,$84
        .byte   $85,$40,$A9,$80,$85,$2A,$A2,$00
        .byte   $BD,$9B,$01,$8D,$67,$71,$A9,$01
        .byte   $8D,$4D,$01,$A9,$FF,$85,$21,$AD
        .byte   $98,$01,$85,$A0,$AD,$9D,$01,$20
        .byte   $BA,$E5,$20,$0A,$E5,$A9,$00,$8D
        .byte   $79,$01,$A9,$01,$85,$26,$58,$A9
        .byte   $81,$8D,$C0,$01,$20,$1C,$E5,$A9
        .byte   $00,$85,$20,$85,$21,$A5,$00,$C9
        .byte   $03,$F0,$03,$20,$B8,$E5,$20,$E5
        .byte   $E5,$20,$B8,$E5,$A5,$00,$10,$F9
        .byte   $A2,$20,$8E,$9D,$01,$A2,$01,$86
        .byte   $20,$C9,$83,$90,$0B,$D0,$0C,$A5
        .byte   $02,$10,$51,$A9,$FF,$8D,$81,$07
        .byte   $20,$87,$E5,$20,$9A,$E5,$78,$8D
        .byte   $00,$E0,$A9,$00,$85,$26,$8D,$4D
        .byte   $01,$85,$A5,$85,$41,$8D,$70,$01
        .byte   $A5,$00,$C9,$84,$F0,$20,$B0,$24
        .byte   $A5,$01,$10,$0A,$AD,$92,$01,$D0
        .byte   $18,$A9,$83,$8D,$90,$01,$A5,$A0
        .byte   $29,$7F,$C9,$1F,$D0,$05,$A9,$01
        .byte   $8D,$9D,$01,$4C,$97,$E1,$4C,$6F
        .byte   $E4,$4C,$55,$E1,$AD,$92,$01,$D0
        .byte   $F8,$4C,$92,$93,$AD,$49,$01,$30
        .byte   $3C,$09,$10,$8D,$49,$01,$C9,$50
        .byte   $90,$08,$29,$03,$AA,$BD,$5C,$01
        .byte   $B0,$15,$4A,$AE,$52,$01,$BD,$40
        .byte   $07,$09,$80,$9D,$40,$07,$A9,$40
        .byte   $B0,$02,$A9,$C0,$18,$65,$08,$85
        .byte   $08,$A9,$10,$8D,$9D,$01,$AC,$76
        .byte   $01,$20,$7D,$E5,$8C,$76,$01,$20
        .byte   $73,$E5,$4C,$83,$E3,$29,$7F,$D0
        .byte   $11,$AE,$01,$80,$F0,$0C,$AE,$80
        .byte   $07,$E8,$F0,$06,$A6,$DA,$F0,$02
        .byte   $A9,$01,$AA,$C9,$01,$D0,$1A,$AD
        .byte   $80,$07,$8D,$97,$01,$A9,$FF,$8D
        .byte   $80,$07,$A9,$03,$8D,$17,$01,$AD
        .byte   $92,$01,$D0,$05,$A9,$81,$8D,$90
        .byte   $01,$A9,$00,$8D,$49,$01,$A0,$82
        .byte   $BD,$3C,$01,$30,$03,$88,$09,$80
        .byte   $85,$02,$84,$00,$AD,$11,$01,$0A
        .byte   $CD,$12,$01,$B0,$03,$8D,$12,$01
        .byte   $20,$7D,$E5,$20,$27,$E5,$20,$73
        .byte   $E5,$20,$5E,$E5,$4C,$83,$E3,$20
        .byte   $7B,$98,$20,$38,$E5,$A9,$06,$8D
        .byte   $0F,$05,$20,$46,$84,$20,$73,$E5
        .byte   $CE,$17,$01,$F0,$26,$A5,$99,$85
        .byte   $32,$85,$50,$A5,$9A,$85,$33,$A5
        .byte   $9B,$85,$34,$85,$51,$A5,$9C,$85
        .byte   $35,$A5,$9D,$85,$36,$85,$38,$A9
        .byte   $83,$85,$00,$AD,$4A,$01,$85,$08
        .byte   $4C,$97,$E1,$20,$7D,$E5,$20,$2E
        .byte   $E5,$A5,$02,$09,$80,$85,$06,$A9
        .byte   $01,$85,$01,$A9,$8A,$85,$02,$A9
        .byte   $82,$85,$00,$20,$5E,$E5,$4C,$97
        .byte   $E1,$29,$7F,$8D,$90,$01,$A9,$00
        .byte   $85,$21,$A9,$18,$20,$BA,$E5,$A9
        .byte   $03,$8D,$34,$01,$A9,$02,$8D,$35
        .byte   $01,$20,$5B,$94,$A9,$08,$85,$13
        .byte   $20,$E5,$E5,$A9,$80,$85,$2A,$85
        .byte   $A0,$A9,$00,$85,$21,$A9,$80,$20
        .byte   $BA,$E5,$A9,$17,$20,$D3,$E5,$20
        .byte   $11,$B0,$20,$9A,$E5,$A9,$01,$85
        .byte   $21,$60,$AD,$02,$20,$A9,$10,$AA
        .byte   $8D,$06,$20,$8D,$06,$20,$49,$10
        .byte   $CA,$D0,$F5,$60,$A2,$00,$8A,$95
        .byte   $D0,$E8,$E0,$0C,$D0,$F9,$60,$A9
        .byte   $00,$8D,$1C,$01,$F0,$22,$A9,$00
        .byte   $8D,$1C,$01,$A9,$03,$8D,$17,$01
        .byte   $A9,$06,$8D,$12,$01,$D0,$11,$A2
        .byte   $03,$BD,$20,$01,$9D,$88,$07,$BD
        .byte   $28,$01,$9D,$8C,$07,$CA,$10,$F1
        .byte   $A2,$06,$A9,$00,$9D,$21,$01,$9D
        .byte   $29,$01,$CA,$10,$F7,$60,$20,$50
        .byte   $E5,$A2,$03,$BD,$88,$07,$9D,$20
        .byte   $01,$BD,$8C,$07,$9D,$28,$01,$CA
        .byte   $10,$F1,$60,$AE,$30,$01,$AD,$80
        .byte   $07,$9D,$90,$07,$60,$A9,$00,$A2
        .byte   $3F,$9D,$50,$01,$CA,$10,$FA,$A9
        .byte   $00,$85,$90,$85,$96,$85,$9C,$85
        .byte   $4F,$85,$03,$8D,$50,$01,$8D,$51
        .byte   $01,$60,$A9,$40,$8D,$C1,$01,$A9
        .byte   $01,$85,$27,$20,$B8,$E5,$AD,$C1
        .byte   $01,$D0,$F4,$A9,$08,$20,$BA,$E5
        .byte   $A9,$80,$85,$25,$A9,$08,$D0,$02
        .byte   $A9,$01,$85,$24,$A5,$24,$D0,$FC
        .byte   $60,$85,$0D,$A2,$66,$86,$0E,$8E
        .byte   $00,$80,$8D,$01,$80,$CD,$00,$C0
        .byte   $D0,$FE,$60,$85,$0C,$A2,$67,$86
        .byte   $0E,$8E,$00,$80,$8D,$01,$80,$CD
        .byte   $00,$A0,$D0,$FE,$60,$A9,$81,$85
        .byte   $25,$60,$A9,$80,$85,$25,$60,$4A
        .byte   $4A,$4A,$4A,$60,$0A,$0A,$0A,$0A
        .byte   $60,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $A9,$81,$8D,$67,$71,$20,$EA,$E5
        .byte   $20,$B8,$E5,$A9,$01,$85,$20,$85
        .byte   $21,$20,$62,$9A,$20,$66,$9A,$20
        .byte   $EB,$99,$A2,$1F,$BD,$BB,$EB,$9D
        .byte   $A0,$01,$CA,$10,$F7,$20,$0F,$9A
        .byte   $A9,$0C,$8D,$40,$01,$A9,$1A,$8D
        .byte   $41,$01,$A9,$00,$8D,$42,$01,$A9
        .byte   $FC,$8D,$43,$01,$A9,$F3,$8D,$44
        .byte   $01,$A9,$1B,$8D,$45,$01,$20,$39
        .byte   $9A,$20,$35,$ED,$AD,$27,$72,$8D
        .byte   $89,$03,$8D,$8A,$03,$AD,$77,$72
        .byte   $8D,$99,$03,$8D,$9A,$03,$AD,$C7
        .byte   $72,$8D,$A9,$03,$8D,$AA,$03,$A9
        .byte   $30,$8D,$01,$A0,$A9,$04,$20,$C1
        .byte   $E5,$AD,$00,$03,$29,$7F,$8D,$00
        .byte   $03,$20,$22,$93,$00,$00,$86,$E6
        .byte   $35,$E7,$CF,$E7,$59,$E8,$A0,$08
        .byte   $20,$A5,$E8,$A0,$00,$20,$B3,$E8
        .byte   $20,$53,$EC,$20,$15,$EC,$20,$5E
        .byte   $EB,$20,$3D,$EB,$A0,$00,$A9,$00
        .byte   $20,$1E,$EB,$20,$06,$EB,$20,$CA
        .byte   $E8,$20,$D7,$E8,$30,$06,$20,$E7
        .byte   $EA,$4C,$A9,$E6,$29,$7F,$85,$D9
        .byte   $AD,$11,$03,$C9,$03,$90,$08,$E9
        .byte   $01,$09,$80,$8D,$00,$03,$60,$A8
        .byte   $B9,$32,$E7,$8D,$91,$01,$A8,$A9
        .byte   $00,$8D,$92,$01,$A2,$B0,$8E,$01
        .byte   $A0,$B9,$04,$72,$D0,$2B,$B9,$27
        .byte   $72,$D0,$17,$A2,$F0,$8E,$01,$A0
        .byte   $A9,$01,$99,$27,$72,$A9,$01,$8D
        .byte   $90,$01,$20,$14,$B0,$20,$1D,$B0
        .byte   $A9,$01,$85,$01,$20,$1A,$B0,$A5
        .byte   $01,$09,$80,$85,$01,$A9,$00,$F0
        .byte   $B8,$20,$17,$B0,$AE,$18,$01,$86
        .byte   $01,$86,$05,$AD,$19,$01,$30,$0A
        .byte   $C9,$01,$F0,$E3,$A2,$81,$A0,$80
        .byte   $D0,$04,$A2,$82,$A0,$82,$09,$80
        .byte   $85,$02,$86,$00,$84,$2A,$A9,$00
        .byte   $F0,$8F,$00,$50,$A0,$A0,$0A,$20
        .byte   $A5,$E8,$A0,$02,$20,$B3,$E8,$20
        .byte   $E1,$E8,$20,$C1,$E8,$A0,$00,$A9
        .byte   $01,$20,$1E,$EB,$20,$D1,$E9,$20
        .byte   $CA,$E8,$20,$D7,$E8,$30,$2B,$20
        .byte   $B7,$E9,$20,$E6,$E9,$20,$2A,$EA
        .byte   $A2,$71,$A5,$23,$29,$0F,$F0,$06
        .byte   $C9,$07,$D0,$E6,$A2,$FF,$AD,$20
        .byte   $03,$F0,$03,$8E,$1D,$02,$AD,$30
        .byte   $03,$C9,$03,$D0,$D5,$8E,$21,$02
        .byte   $F0,$D0,$29,$7F,$85,$D9,$AD,$11
        .byte   $03,$C9,$03,$D0,$CA,$A9,$F0,$8D
        .byte   $01,$A0,$20,$31,$ED,$A9,$30,$8D
        .byte   $01,$A0,$A9,$00,$8D,$91,$01,$A8
        .byte   $A9,$F0,$8D,$01,$A0,$B9,$47,$72
        .byte   $10,$10,$29,$01,$99,$47,$72,$A9
        .byte   $01,$8D,$90,$01,$20,$14,$B0,$20
        .byte   $1D,$B0,$A9,$30,$8D,$01,$A0,$18
        .byte   $AD,$91,$01,$69,$50,$C9,$F0,$D0
        .byte   $D3,$A9,$81,$8D,$00,$03,$60,$A0
        .byte   $0C,$20,$A5,$E8,$A0,$04,$20,$B3
        .byte   $E8,$20,$C1,$E8,$20,$06,$EB,$A9
        .byte   $08,$8D,$31,$05,$A9,$FF,$A2,$07
        .byte   $9D,$32,$05,$CA,$10,$FA,$A9,$00
        .byte   $8D,$3A,$05,$20,$CA,$E8,$20,$D7
        .byte   $E8,$30,$06,$20,$E7,$EA,$4C,$F6
        .byte   $E7,$29,$7F,$85,$D9,$AD,$11,$03
        .byte   $C9,$03,$F0,$1C,$0A,$A8,$0A,$0A
        .byte   $0A,$AA,$B9,$00,$ED,$8D,$2F,$05
        .byte   $B9,$01,$ED,$8D,$30,$05,$A9,$81
        .byte   $8D,$0E,$05,$9D,$80,$03,$D0,$CE
        .byte   $A9,$F0,$8D,$01,$A0,$A2,$00,$A0
        .byte   $00,$BD,$80,$03,$10,$08,$A9,$4E
        .byte   $99,$00,$72,$99,$00,$73,$98,$18
        .byte   $69,$50,$A8,$8A,$69,$10,$AA,$C9
        .byte   $30,$D0,$E6,$A9,$30,$8D,$01,$A0
        .byte   $20,$0E,$B0,$A9,$81,$8D,$00,$03
        .byte   $60,$A0,$0C,$20,$A5,$E8,$A0,$06
        .byte   $20,$B3,$E8,$20,$C1,$E8,$A0,$09
        .byte   $A9,$00,$20,$1E,$EB,$20,$1B,$EC
        .byte   $20,$64,$E9,$20,$CA,$E8,$20,$D7
        .byte   $E8,$30,$09,$20,$4A,$E9,$20,$7B
        .byte   $E9,$4C,$76,$E8,$29,$7F,$85,$D9
        .byte   $AD,$11,$03,$C9,$03,$D0,$06,$A9
        .byte   $81,$8D,$00,$03,$60,$A8,$B9,$32
        .byte   $E7,$8D,$91,$01,$AD,$42,$03,$8D
        .byte   $92,$01,$4C,$FA,$E6,$20,$AC,$ED
        .byte   $20,$89,$ED,$20,$CC,$83,$A5,$E2
        .byte   $D0,$F6,$60,$20,$AC,$ED,$20,$71
        .byte   $ED,$20,$CC,$83,$A5,$E2,$D0,$F6
        .byte   $60,$20,$59,$EC,$20,$62,$EB,$4C
        .byte   $39,$EB,$20,$E5,$E5,$A9,$81,$8D
        .byte   $C0,$01,$A9,$00,$85,$21,$60,$A9
        .byte   $81,$85,$27,$20,$B8,$E5,$A5,$D9
        .byte   $60,$A9,$22,$8D,$2F,$05,$A9,$65
        .byte   $8D,$30,$05,$A9,$16,$8D,$31,$05
        .byte   $85,$E2,$A9,$03,$A2,$0B,$20,$04
        .byte   $E9,$A9,$14,$8D,$31,$05,$85,$E2
        .byte   $A9,$01,$A2,$01,$85,$E0,$86,$E1
        .byte   $A0,$00,$A6,$E1,$8A,$99,$32,$05
        .byte   $E8,$C8,$A9,$FF,$99,$32,$05,$C8
        .byte   $C4,$E2,$D0,$F0,$A9,$00,$99,$32
        .byte   $05,$86,$E1,$20,$CC,$83,$A9,$40
        .byte   $20,$97,$EC,$C6,$E0,$D0,$D9,$60
        .byte   $AC,$34,$03,$AD,$32,$03,$C0,$03
        .byte   $D0,$07,$C9,$0A,$D0,$03,$A9,$FF
        .byte   $60,$18,$79,$46,$E9,$60,$0B,$16
        .byte   $21,$01,$AD,$10,$03,$F0,$27,$A5
        .byte   $DB,$10,$23,$29,$7F,$85,$DB,$20
        .byte   $FF,$EA,$AD,$11,$03,$C9,$03,$F0
        .byte   $03,$20,$DB,$EB,$20,$06,$EB,$AD
        .byte   $11,$03,$C9,$03,$F0,$09,$20,$E6
        .byte   $EB,$A9,$01,$8D,$40,$03,$60,$A9
        .byte   $00,$F0,$F8,$AD,$40,$03,$F0,$36
        .byte   $A5,$D3,$10,$32,$29,$7F,$85,$D3
        .byte   $AE,$42,$03,$A5,$D2,$29,$0C,$F0
        .byte   $25,$C9,$08,$F0,$08,$CA,$D0,$0F
        .byte   $AE,$41,$03,$D0,$0A,$E8,$EC,$41
        .byte   $03,$90,$04,$F0,$02,$A2,$01,$8E
        .byte   $42,$03,$E8,$8E,$32,$05,$A9,$81
        .byte   $8D,$0E,$05,$20,$FF,$EA,$60,$AD
        .byte   $10,$03,$F0,$25,$A5,$DB,$10,$21
        .byte   $29,$7F,$85,$DB,$20,$FF,$EA,$AD
        .byte   $11,$03,$C9,$03,$F0,$03,$20,$06
        .byte   $ED,$20,$06,$EB,$AD,$11,$03,$C9
        .byte   $03,$F0,$07,$20,$E1,$EC,$20,$B8
        .byte   $EC,$60,$20,$A7,$EC,$60,$AD,$20
        .byte   $03,$F0,$3E,$A5,$D5,$10,$09,$29
        .byte   $7F,$85,$D5,$20,$FB,$EA,$D0,$0D
        .byte   $A5,$D7,$10,$2D,$29,$7F,$85,$D7
        .byte   $20,$FF,$EA,$D0,$0E,$20,$30,$E9
        .byte   $AC,$21,$03,$99,$32,$05,$A9,$81
        .byte   $8D,$0E,$05,$AC,$21,$03,$C8,$C0
        .byte   $08,$D0,$02,$A0,$00,$8C,$21,$03
        .byte   $98,$0A,$0A,$0A,$69,$60,$8D,$1F
        .byte   $02,$60,$A4,$D2,$AD,$30,$03,$D0
        .byte   $01,$60,$C9,$02,$90,$4C,$F0,$1C
        .byte   $A5,$D3,$10,$F5,$29,$7F,$85,$D3
        .byte   $A2,$10,$B9,$D7,$EA,$8D,$30,$03
        .byte   $C9,$02,$90,$42,$F0,$12,$D0,$E1
        .byte   $A9,$03,$D0,$F1,$D9,$D7,$EA,$D0
        .byte   $F7,$CE,$33,$03,$D0,$D3,$A2,$06
        .byte   $8E,$33,$03,$C0,$08,$AE,$32,$03
        .byte   $AC,$34,$03,$90,$06,$20,$B1,$EA
        .byte   $4C,$76,$EA,$20,$B7,$EA,$8E,$32
        .byte   $03,$8C,$34,$03,$20,$FF,$EA,$4C
        .byte   $BF,$EA,$D9,$D7,$EA,$D0,$C9,$CE
        .byte   $31,$03,$D0,$A5,$A2,$06,$8E,$31
        .byte   $03,$C0,$02,$AE,$32,$03,$AC,$34
        .byte   $03,$90,$0A,$CA,$10,$D8,$20,$B1
        .byte   $EA,$A2,$0A,$D0,$D1,$E8,$E0,$0B
        .byte   $90,$CC,$20,$B7,$EA,$A2,$00,$F0
        .byte   $C5,$88,$10,$02,$A0,$03,$60,$C8
        .byte   $C0,$04,$90,$02,$A0,$00,$60,$98
        .byte   $20,$F4,$E5,$69,$97,$8D,$20,$02
        .byte   $8A,$20,$F4,$E5,$69,$28,$8D,$23
        .byte   $02,$A9,$71,$8D,$21,$02,$60,$03
        .byte   $01,$01,$03,$02,$03,$03,$03,$02
        .byte   $03,$03,$03,$03,$03,$03,$03,$AD
        .byte   $10,$03,$F0,$0E,$A5,$DB,$10,$0A
        .byte   $29,$7F,$85,$DB,$20,$FF,$EA,$20
        .byte   $06,$EB,$60,$A9,$10,$D0,$02,$A9
        .byte   $40,$05,$A4,$85,$A4,$60,$AC,$11
        .byte   $03,$C8,$B9,$12,$03,$F0,$FA,$C9
        .byte   $FF,$F0,$07,$8C,$11,$03,$8D,$00
        .byte   $02,$60,$A0,$00,$F0,$EC,$85,$E7
        .byte   $A2,$00,$B9,$80,$03,$C5,$E7,$D0
        .byte   $05,$A9,$00,$9D,$12,$03,$98,$18
        .byte   $69,$10,$A8,$E8,$E0,$03,$D0,$EA
        .byte   $60,$A0,$09,$D0,$02,$A0,$00,$A2
        .byte   $00,$B9,$4E,$EB,$9D,$10,$03,$C8
        .byte   $E8,$C9,$FF,$D0,$F4,$60,$01,$05
        .byte   $47,$5F,$77,$8F,$9F,$AF,$FF,$01
        .byte   $03,$2F,$47,$5F,$77,$FF,$A0,$00
        .byte   $F0,$02,$A0,$24,$A2,$00,$B9,$73
        .byte   $EB,$9D,$00,$02,$C8,$E8,$E0,$24
        .byte   $D0,$F4,$60,$3F,$BF,$02,$24,$43
        .byte   $01,$03,$30,$43,$03,$03,$38,$5B
        .byte   $01,$03,$30,$5B,$03,$03,$38,$73
        .byte   $01,$03,$30,$73,$03,$03,$38,$F1
        .byte   $FF,$00,$00,$F1,$FF,$00,$00,$2F
        .byte   $BF,$02,$34,$2B,$01,$03,$40,$2B
        .byte   $03,$03,$48,$43,$01,$03,$40,$43
        .byte   $03,$03,$48,$5B,$01,$03,$40,$5B
        .byte   $03,$03,$48,$F1,$71,$21,$60,$F1
        .byte   $71,$21,$28,$8F,$8F,$8F,$8F,$8F
        .byte   $8F,$8F,$8F,$8F,$8F,$8F,$8F,$8F
        .byte   $22,$26,$30,$8F,$8F,$8F,$8F,$8F
        .byte   $16,$16,$16,$8F,$16,$26,$30,$8F
        .byte   $07,$36,$21,$20,$F4,$E5,$AA,$AD
        .byte   $42,$03,$9D,$8A,$03,$60,$0A,$A8
        .byte   $0A,$0A,$0A,$AA,$B9,$0F,$EC,$8D
        .byte   $2F,$05,$B9,$10,$EC,$8D,$30,$05
        .byte   $A9,$01,$8D,$31,$05,$A9,$00,$8D
        .byte   $33,$05,$BD,$89,$03,$8D,$41,$03
        .byte   $BD,$8A,$03,$8D,$42,$03,$60,$20
        .byte   $D8,$21,$38,$21,$98,$A2,$21,$A0
        .byte   $32,$D0,$04,$A2,$20,$A0,$D5,$8E
        .byte   $2F,$05,$8C,$30,$05,$A0,$00,$A2
        .byte   $06,$B9,$4D,$EC,$99,$31,$05,$C8
        .byte   $CA,$D0,$F6,$86,$E0,$20,$41,$EC
        .byte   $20,$CC,$83,$20,$8A,$EC,$D0,$F3
        .byte   $60,$BD,$89,$03,$29,$0F,$18,$69
        .byte   $01,$8D,$35,$05,$60,$04,$4D,$FF
        .byte   $2D,$01,$00,$A2,$21,$A0,$29,$D0
        .byte   $04,$A2,$20,$A0,$CC,$8E,$2F,$05
        .byte   $8C,$30,$05,$A9,$08,$8D,$31,$05
        .byte   $A2,$00,$8E,$3A,$05,$86,$E0,$20
        .byte   $7B,$EC,$20,$CC,$83,$20,$8A,$EC
        .byte   $D0,$F3,$60,$A0,$00,$BD,$81,$03
        .byte   $99,$32,$05,$E8,$C8,$C0,$08,$D0
        .byte   $F4,$60,$A9,$60,$20,$97,$EC,$A5
        .byte   $E0,$69,$10,$AA,$C9,$30,$60,$18
        .byte   $6D,$30,$05,$8D,$30,$05,$AD,$2F
        .byte   $05,$69,$00,$8D,$2F,$05,$60,$A2
        .byte   $00,$8E,$20,$03,$8E,$30,$03,$A2
        .byte   $F1,$8E,$1C,$02,$8E,$20,$02,$60
        .byte   $A0,$40,$A2,$1C,$20,$66,$EB,$A2
        .byte   $01,$8E,$20,$03,$CA,$8E,$21,$03
        .byte   $AE,$00,$02,$8E,$1C,$02,$A2,$03
        .byte   $8E,$30,$03,$A2,$00,$8E,$32,$03
        .byte   $8E,$34,$03,$A2,$97,$8E,$20,$02
        .byte   $60,$0A,$A8,$0A,$0A,$0A,$AA,$B9
        .byte   $00,$ED,$8D,$2F,$05,$B9,$01,$ED
        .byte   $8D,$30,$05,$A9,$08,$8D,$31,$05
        .byte   $A9,$00,$8D,$3A,$05,$4C,$7B,$EC
        .byte   $20,$CC,$21,$2C,$21,$8C,$20,$F4
        .byte   $E5,$A8,$A2,$00,$86,$E0,$BD,$32
        .byte   $05,$99,$81,$03,$C9,$FF,$F0,$02
        .byte   $E6,$E0,$C8,$E8,$E0,$08,$D0,$EE
        .byte   $A2,$00,$A5,$E0,$F0,$02,$A2,$81
        .byte   $98,$29,$F0,$A8,$8A,$99,$80,$03
        .byte   $60,$A0,$06,$D0,$07,$A0,$00,$A9
        .byte   $B0,$8D,$01,$A0,$A2,$00,$B9,$65
        .byte   $ED,$95,$E0,$C8,$E8,$E0,$06,$D0
        .byte   $F5,$A2,$03,$A0,$08,$B1,$E2,$91
        .byte   $E0,$88,$10,$F9,$18,$A5,$E0,$65
        .byte   $E4,$85,$E0,$A5,$E2,$65,$E5,$85
        .byte   $E2,$CA,$D0,$E7,$60,$80,$03,$47
        .byte   $72,$10,$50,$47,$72,$80,$03,$50
        .byte   $10,$A4,$E2,$A2,$00,$B1,$E0,$9D
        .byte   $2F,$05,$F0,$04,$C8,$E8,$D0,$F5
        .byte   $C8,$B1,$E0,$D0,$01,$A8,$84,$E2
        .byte   $60,$A4,$E2,$A2,$00,$B1,$E0,$9D
        .byte   $2F,$05,$C8,$E8,$E0,$03,$D0,$F5
        .byte   $B1,$E0,$F0,$DB,$85,$E3,$C8,$B1
        .byte   $E0,$C8,$9D,$2F,$05,$E8,$C6,$E3
        .byte   $D0,$F8,$F0,$EC,$AD,$0E,$C0,$85
        .byte   $E1,$AD,$0F,$C0,$85,$E2,$B1,$E1
        .byte   $85,$E0,$C8,$B1,$E1,$85,$E1,$A0
        .byte   $00,$84,$E2,$60
PADDING_EDC4:
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $F0,$FE,$D0,$FE

; 16 selectable envelopes, each 16 nibbles long.
ENVELOPE_TABLE:
        .byte   $8F,$85,$36,$54,$32,$22,$22,$22 ; 1
        .byte   $13,$57,$9C,$EF,$FE,$DA,$97,$64 ; 2
        .byte   $CF,$EC,$97,$53,$33,$33,$33,$33 ; 3
        .byte   $AF,$86,$53,$33,$45,$67,$9A,$CF ; 4
        .byte   $F8,$41,$00,$00,$00,$00,$00,$00 ; 5
        .byte   $AF,$A9,$86,$55,$55,$55,$55,$55 ; 6
        .byte   $01,$23,$45,$67,$89,$AB,$CD,$EF ; 7
        .byte   $FE,$DC,$BA,$98,$76,$54,$32,$10 ; 8
        .byte   $F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0 ; 9
        .byte   $F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8 ; 10
        .byte   $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF ; 11
        .byte   $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF ; 12
        .byte   $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF ; 13
        .byte   $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF ; 14
        .byte   $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF ; 15
        .byte   $AE,$67,$71,$BD,$00,$D0,$85,$A6 ; 16
        .byte   $BD,$08,$D0,$85,$A7,$BD,$10,$D0 ; 17
        .byte   $85,$A8,$BD,$18,$D0,$85,$A9,$60 ; 18

init:   lda     #$FF
        sta     var_ch_halt
        sta     var_ch_halt+1
        sta     var_ch_halt+2
        sta     var_ch_halt+3
        sta     var_ch_halt+4
        sta     var_ch_halt+5
        sta     var_extra_ch_2
        sta     var_extra_ch_4
        ldx     #$00
        stx     var_next_track
        stx     var_current_track
        stx     var_extra_A2
        stx     var_extra_A3
        stx     var_extra_A4
        stx     var_extra_A5
        stx     var_play_fade
        stx     $4015
        stx     var_channel_mask
        stx     var_ch_freq_high
        stx     var_ch_freq_high+1
        stx     var_ch_freq_high+2
        stx     var_ch_freq_high+3
        lda     #$50
        sta     var_dmc_counter
        sta     $4011
        rts

; X = var_play_fade
play_fade:
        cpx     #$80
        bne     play_fade_countdown
        ldy     var_play_fade_pos
        lda     (var_ptr_fade),y
        iny
        cmp     #$10
        bcc     fade_set_volumes
        cmp     #$90
        bcc     play_fade_continue
        lda     #$00
        sta     var_play_fade
        lda     #$FF
        sta     var_ch_halt
        sta     var_ch_halt+1
        sta     var_ch_halt+2
        sta     var_ch_halt+3
        sta     var_ch_halt+4
        sta     var_ch_halt+5
        lda     var_next_track
        bmi     track_load
        lda     var_current_track
        beq     track_loaded
track_load:
        asl     a
        tax
        lda     TRACK_PTR_TABLE,x
        sta     var_temp_F0
        lda     TRACK_PTR_TABLE+1,x
        sta     var_temp_F0+1
        ldy     #$00
        lda     (var_temp_F0),y
        sta     var_temp_F2
        iny
@load_channel:
        lda     (var_temp_F0),y
        iny
        tax
        lda     (var_temp_F0),y
        iny
        sta     var_ch_pattern_ptr_low,x
        lda     (var_temp_F0),y
        iny
        sta     var_ch_pattern_ptr_high,x
        lda     #$00
        sta     var_ch_halt,x
        dec     var_temp_F2
        bpl     @load_channel
track_loaded:
        rts

play_fade_countdown:
        dex
        stx     var_play_fade
        jmp     update_ch_0

play_fade_continue:
        and     #$0F
        ora     #$80
        sta     var_play_fade
        sty     var_play_fade_pos
        jmp     update_ch_0

; A = volume to fade to
fade_set_volumes:
        sta     var_temp_F0
        tax
        lda     var_ch_volume
        and     #$0F
        cmp     var_temp_F0
        bcc     @fade_0_done
        lda     var_ch_volume
        and     #$C0
        ora     var_temp_F0
        ora     #$10
        sta     var_ch_volume
@fade_0_done:
        lda     var_ch_volume+1
        and     #$0F
        cmp     var_temp_F0
        bcc     @fade_1_done
        lda     var_ch_volume+1
        and     #$C0
        ora     var_temp_F0
        ora     #$10
        sta     var_ch_volume+1
@fade_1_done:
        lda     var_ch_volume+2
        and     #$0F
        cmp     var_temp_F0
        bcc     @fade_2_done
        lda     var_ch_volume+2
        and     #$C0
        ora     var_temp_F0
        ora     #$10
        sta     var_ch_volume+2
@fade_2_done:
        lda     var_ch_volume+3
        and     #$0F
        cmp     var_temp_F0
        bcc     @fade_3_done
        lda     var_ch_volume+3
        and     #$C0
        ora     var_temp_F0
        ora     #$10
        sta     var_ch_volume+3
@fade_3_done:
        lda     var_ch_volume+4
        and     #$0F
        cmp     var_temp_F0
        bcc     @fade_4_done
        lda     var_ch_volume+4
        and     #$C0
        ora     var_temp_F0
        ora     #$10
        sta     var_ch_volume+4
@fade_4_done:
        lda     DMC_FADE,x
        cmp     var_dmc_target
        bcc     @fade_dmc_done
        sta     var_dmc_target
@fade_dmc_done:
        sty     var_play_fade_pos
        jmp     update_ch_0

track_none:
        lda     var_extra_A2
        bne     update_extra_A2
        lda     var_extra_A3
        bne     update_extra_A3
        lda     var_extra_A4
        bne     update_extra_A4
        lda     var_extra_A5
        bne     update_extra_A5
        lda     var_ch_halt+2
        and     var_ch_halt+4
        cmp     #$FF
        beq     channel_update_skip
channel_update_begin:
        jmp     update_ch_0

channel_update_skip:
        rts

skip_channel_extra:
        iny
        iny
        dec     var_temp_F2
        bpl     update_channel_extra
        jmp     update_ch_0

update_extra_A5:
        ldy     #$17
@loop:  iny
        asl     a
        bcc     @loop
        lda     var_ch_halt+2
        cmp     #$FF
        beq     @skip_ch_2
        cpy     var_extra_ch_2
        beq     channel_update_begin
@skip_ch_2:
        lda     var_ch_halt+4
        cmp     #$FF
        beq     load_extra
        cpy     var_extra_ch_4
        beq     channel_update_begin
        jmp     load_extra

update_extra_A2:
        ldy     #$FF
@loop:  iny
        asl     a
        bcc     @loop
        bcs     load_extra
update_extra_A3:
        ldy     #$07
@loop:  iny
        asl     a
        bcc     @loop
        bcs     load_extra
update_extra_A4:
        ldy     #$0F
@loop:  iny
        asl     a
        bcc     @loop
load_extra:
        lda     (var_ptr_extra_table_low),y
        sta     var_ptr_pattern
        lda     (var_ptr_extra_table_high),y
        sta     var_ptr_pattern+1
        sty     var_temp_pattern_pos
        ldy     #$00
        sty     var_extra_A2
        sty     var_extra_A3
        sty     var_extra_A4
        lda     (var_ptr_pattern),y
        sta     var_temp_F2
        iny
update_channel_extra:
        lda     (var_ptr_pattern),y
        iny
        tax
        lda     var_ch_halt,x
        cmp     #$FF
        beq     begin_channel_extra
        lda     var_play_fade_pos,x
        cmp     var_temp_pattern_pos
        bcc     skip_channel_extra
begin_channel_extra:
        lda     (var_ptr_pattern),y
        iny
        sta     var_ch_pattern_ptr_low,x
        lda     (var_ptr_pattern),y
        iny
        sta     var_ch_pattern_ptr_high,x
        lda     #$00
        sta     var_ch_halt,x
        lda     var_temp_pattern_pos
        sta     var_play_fade_pos,x
        dec     var_temp_F2
        bpl     update_channel_extra
        jmp     update_ch_0

track_started:
        and     #$7F
        sta     var_next_track
track_continue:
        lda     var_extra_A2
        bne     update_extra_A2
        lda     var_extra_A3
        bne     update_extra_A3
        lda     var_extra_A4
        bne     update_extra_A4
        lda     var_extra_A5
        beq     update_ch_0
        jmp     update_extra_A5

play_track:
        cmp     var_current_track
        beq     track_started
        ldx     var_current_track
        beq     track_ready
        sta     var_current_track
        and     #$7F
        sta     var_next_track
        lda     #$00
        jmp     track_clear

track_ready:
        sta     var_current_track
        and     #$7F
        sta     var_next_track
        jmp     track_load

jmp_track_none:
        jmp     track_none

jmp_play_fade:
        jmp     play_fade

play:   ldx     var_play_fade
        bmi     jmp_play_fade
        lda     var_next_track
        beq     jmp_track_none
        bpl     track_continue
        cmp     #$81
        bcs     play_track
        lda     #$00
        sta     var_next_track
        sta     var_current_track
track_clear:
        sta     var_play_fade_pos
        lda     #$80
        sta     var_play_fade
        ldx     var_play_fade_speed
        lda     FADE_TABLE_LOW,x
        sta     var_ptr_fade
        lda     FADE_TABLE_HIGH,x
        sta     var_ptr_fade+1
update_ch_0:
        ldx     #$00
        stx     var_current_channel
        lda     var_ch_halt
        cmp     #$FF
        beq     jmp_update_ch_1
        cmp     #$00
        beq     reset_ch_0
        inc     var_ch_envelope_pos
        lda     var_ch_envelope_pos
        sbc     var_ch_envelope_len
        bcc     envelope_continue_ch_0
        lda     var_ch_envelope_select
        bpl     envelope_none_ch_0
        lda     var_ch_envelope_len
        sbc     #$01
        jmp     envelope_finished_ch_0

jmp_update_ch_1:
        jmp     update_ch_1

envelope_none_ch_0:
        lda     #$00
envelope_finished_ch_0:
        sta     var_ch_envelope_pos
envelope_continue_ch_0:
        dec     var_ch_update_timer
        bpl     slide_ch_0
        lda     var_ch_update_speed
        sta     var_ch_update_timer
        lda     var_ch_volume_slide
        beq     @volume_slide_end
        dec     var_ch_volume_slide_timer
        bne     @volume_slide_end
        lda     var_ch_volume_slide_speed
        sta     var_ch_volume_slide_timer
        lda     var_ch_volume
        and     #$1F
        sta     var_temp_F0
        and     #$10
        beq     @volume_slide_end
        lda     var_ch_volume_slide
        bmi     @volume_slide_down
        dec     var_ch_volume_slide
        lda     var_temp_F0
        cmp     #$1F
        beq     @volume_slide_end
        inc     var_ch_volume
        jmp     @volume_slide_end
@volume_slide_down:
        inc     var_ch_volume_slide
        lda     var_temp_F0
        cmp     #$10
        beq     @volume_slide_end
        dec     var_ch_volume
@volume_slide_end:
        dec     var_ch_note_len
        bne     slide_ch_0
        jsr     read_music_command_start
        lda     var_temp_pattern_pos
        sta     var_ch_pattern_pos
        jmp     update_ch_1
slide_ch_0:
        jsr     slide
        jmp     update_ch_1
reset_ch_0:
        jsr     reset_channel
        lda     var_temp_pattern_pos
        sta     var_ch_pattern_pos

update_ch_1:
        inx
        stx     var_current_channel
        lda     var_ch_halt+1
        cmp     #$FF
        beq     jmp_update_ch_2
        cmp     #$00
        beq     reset_ch_1
        inc     var_ch_envelope_pos+1
        lda     var_ch_envelope_pos+1
        sbc     var_ch_envelope_len+1
        bcc     envelope_continue_ch_1
        lda     var_ch_envelope_select+1
        bpl     envelope_none_ch_1
        lda     var_ch_envelope_len+1
        sbc     #$01
        jmp     envelope_finished_ch_1
jmp_update_ch_2:
        jmp     update_ch_2
envelope_none_ch_1:
        lda     #$00
envelope_finished_ch_1:
        sta     var_ch_envelope_pos+1
envelope_continue_ch_1:
        dec     var_ch_update_timer+1
        bpl     slide_ch_1
        lda     var_ch_update_speed+1
        sta     var_ch_update_timer+1
        lda     var_ch_volume_slide+1
        beq     @volume_slide_end
        dec     var_ch_volume_slide_timer+1
        bne     @volume_slide_end
        lda     var_ch_volume_slide_speed+1
        sta     var_ch_volume_slide_timer+1
        lda     var_ch_volume+1
        and     #$1F
        sta     var_temp_F0
        and     #$10
        beq     @volume_slide_end
        lda     var_ch_volume_slide+1
        bmi     @volume_slide_down
        dec     var_ch_volume_slide+1
        lda     var_temp_F0
        cmp     #$1F
        beq     @volume_slide_end
        inc     var_ch_volume+1
        jmp     @volume_slide_end
@volume_slide_down:
        inc     var_ch_volume_slide+1
        lda     var_temp_F0
        cmp     #$10
        beq     @volume_slide_end
        dec     var_ch_volume+1
@volume_slide_end:
        dec     var_ch_note_len+1
        bne     slide_ch_1
        jsr     read_music_command_start
        lda     var_temp_pattern_pos
        sta     var_ch_pattern_pos+1
        jmp     update_ch_2
reset_ch_1:
        jsr     reset_channel
        lda     var_temp_pattern_pos
        sta     var_ch_pattern_pos+1
        jmp     update_ch_2
slide_ch_1:
        jsr     slide

update_ch_2:
        inx
        lda     var_ch_halt+2
        cmp     #$FF
        beq     jmp_update_ch_3
        cmp     #$00
        beq     reset_ch_2
        inc     var_ch_envelope_pos+2
        lda     var_ch_envelope_pos+2
        sbc     var_ch_envelope_len+2
        bcc     envelope_continue_ch_2
        lda     var_ch_envelope_select+2
        bpl     envelope_none_ch_2
        lda     var_ch_envelope_len+2
        sbc     #$01
        jmp     envelope_finished_ch_2
jmp_update_ch_3:
        jmp     update_ch_3
envelope_none_ch_2:
        lda     #$00
envelope_finished_ch_2:
        sta     var_ch_envelope_pos+2
envelope_continue_ch_2:
        dec     var_ch_update_timer+2
        bpl     slide_ch_2
        lda     var_ch_update_speed+2
        sta     var_ch_update_timer+2
        lda     var_ch_volume_slide+2
        beq     @volume_slide_end
        dec     var_ch_volume_slide_timer+2
        bne     @volume_slide_end
        lda     var_ch_volume_slide_speed+2
        sta     var_ch_volume_slide_timer+2
        lda     var_ch_volume+2
        and     #$1F
        sta     var_temp_F0
        and     #$10
        beq     @volume_slide_end
        lda     var_ch_volume_slide+2
        bmi     @volume_slide_down
        dec     var_ch_volume_slide+2
        lda     var_temp_F0
        cmp     #$1F
        beq     @volume_slide_end
        inc     var_ch_volume+2
        jmp     @volume_slide_end
@volume_slide_down:
        inc     var_ch_volume_slide+2
        lda     var_temp_F0
        cmp     #$10
        beq     @volume_slide_end
        dec     var_ch_volume+2
@volume_slide_end:
        dec     var_ch_note_len+2
        bne     slide_ch_2
        jsr     read_music_command_start
        lda     var_temp_pattern_pos
        sta     var_ch_pattern_pos+2
        jmp     update_ch_3
reset_ch_2:
        jsr     reset_channel
        lda     var_temp_pattern_pos
        sta     var_ch_pattern_pos+2
        jmp     update_ch_3
slide_ch_2:
        jsr     slide

update_ch_3:
        inx
        stx     var_current_channel
        lda     var_ch_halt+3
        cmp     #$FF
        beq     jmp_update_ch_4
        cmp     #$00
        beq     reset_ch_3
        inc     var_ch_envelope_pos+3
        lda     var_ch_envelope_pos+3
        sbc     var_ch_envelope_len+3
        bcc     envelope_continue_ch_3
        lda     var_ch_envelope_select+3
        bpl     envelope_none_ch_3
        lda     var_ch_envelope_len+3
        sbc     #$01
        jmp     envelope_finished_ch_3
jmp_update_ch_4:
        jmp     update_ch_4
envelope_none_ch_3:
        lda     #$00
envelope_finished_ch_3:
        sta     var_ch_envelope_pos+3
envelope_continue_ch_3:
        dec     var_ch_update_timer+3
        bpl     update_volume_ch_3
        lda     var_ch_update_speed+3
        sta     var_ch_update_timer+3
        lda     var_ch_volume_slide+3
        beq     @volume_slide_end
        dec     var_ch_volume_slide_timer+3
        bne     @volume_slide_end
        lda     var_ch_volume_slide_speed+3
        sta     var_ch_volume_slide_timer+3
        lda     var_ch_volume+3
        and     #$1F
        sta     var_temp_F0
        and     #$10
        beq     @volume_slide_end
        lda     var_ch_volume_slide+3
        bmi     @volume_slide_down
        dec     var_ch_volume_slide+3
        lda     var_temp_F0
        cmp     #$1F
        beq     @volume_slide_end
        inc     var_ch_volume+3
        jmp     @volume_slide_end
@volume_slide_down:
        inc     var_ch_volume_slide+3
        lda     var_temp_F0
        cmp     #$10
        beq     @volume_slide_end
        dec     var_ch_volume+3
@volume_slide_end:
        dec     var_ch_note_len+3
        bne     update_volume_ch_3
        jsr     read_music_command_start
        lda     var_temp_pattern_pos
        sta     var_ch_pattern_pos+3
        jmp     update_ch_4
reset_ch_3:
        jsr     reset_channel
        lda     var_temp_pattern_pos
        sta     var_ch_pattern_pos+3
        jmp     update_ch_4
update_volume_ch_3:
        jsr     volume_apply

update_ch_4:
        inx
        lda     var_ch_halt+4
        cmp     #$FF
        beq     jmp_update_ch_5
        cmp     #$00
        beq     reset_ch_4
        inc     var_ch_envelope_pos+4
        lda     var_ch_envelope_pos+4
        sbc     var_ch_envelope_len+4
        bcc     envelope_continue_ch_4
        lda     var_ch_envelope_select+4
        bpl     envelope_none_ch_4
        lda     var_ch_envelope_len+4
        sbc     #$01
        jmp     envelope_finished_ch_4
jmp_update_ch_5:
        jmp     update_ch_5
envelope_none_ch_4:
        lda     #$00
envelope_finished_ch_4:
        sta     var_ch_envelope_pos+4
envelope_continue_ch_4:
        dec     var_ch_update_timer+4
        bpl     apply_volume_ch_4
        lda     var_ch_update_speed+4
        sta     var_ch_update_timer+4
        lda     var_ch_volume_slide+4
        beq     @volume_slide_end
        dec     var_ch_volume_slide_timer+4
        bne     @volume_slide_end
        lda     var_ch_volume_slide_speed+4
        sta     var_ch_volume_slide_timer+4
        lda     var_ch_volume+4
        and     #$1F
        sta     var_temp_F0
        and     #$10
        beq     @volume_slide_end
        lda     var_ch_volume_slide+4
        bmi     @volume_slide_down
        dec     var_ch_volume_slide+4
        lda     var_temp_F0
        cmp     #$1F
        beq     @volume_slide_end
        inc     var_ch_volume+4
        jmp     @volume_slide_end
@volume_slide_down:
        inc     var_ch_volume_slide+4
        lda     var_temp_F0
        cmp     #$10
        beq     @volume_slide_end
        dec     var_ch_volume+4
@volume_slide_end:
        dec     var_ch_note_len+4
        bne     apply_volume_ch_4
        jsr     read_music_command_start
        lda     var_temp_pattern_pos
        sta     var_ch_pattern_pos+4
        jmp     update_ch_5
reset_ch_4:
        jsr     reset_channel
        lda     var_temp_pattern_pos
        sta     var_ch_pattern_pos+4
        jmp     update_ch_5
apply_volume_ch_4:
        jsr     volume_apply
update_ch_5:
        inx
        lda     #$02
        sta     var_current_channel
        lda     var_dmc_counter
        cmp     var_dmc_target
        beq     dmc_slide_finished
        bcc     dmc_increase
        bcs     dmc_decrease
dmc_slide_finished:
        lda     var_ch_halt+5
        cmp     #$FF
        beq     @triangle_paused
        cmp     #$00
        beq     triangle_skip
        dec     var_ch_update_timer+5
        bpl     triangle_finish
        lda     var_ch_update_speed+5
        sta     var_ch_update_timer+5
        dec     var_ch_note_len+5
        bne     triangle_finish
        jsr     read_music_command_start
        lda     var_temp_pattern_pos
        sta     var_ch_pattern_pos+5
@triangle_paused:
        lda     var_ch_halt
        and     var_ch_halt+1
        and     var_ch_halt+3
        and     var_ch_halt+5
        cmp     #$FF
        bne     music_skipped
        lda     #$00
        sta     var_next_track
        sta     var_current_track
music_skipped:
        rts

dmc_increase:
        adc     #$04
        sta     var_dmc_counter
        sta     $4011
        jmp     dmc_slide_finished

dmc_decrease:
        sbc     #$04
        sta     var_dmc_counter
        sta     $4011
        jmp     dmc_slide_finished

triangle_finish:
        jsr     slide_triangle
        lda     var_ch_halt
        and     var_ch_halt+1
        and     var_ch_halt+3
        and     var_ch_halt+5
        cmp     #$FF
        bne     music_skipped
        lda     #$00
        sta     var_next_track
        sta     var_current_track
        rts

triangle_skip:
        jsr     reset_channel
        lda     var_temp_pattern_pos
        sta     var_ch_pattern_pos+5
        lda     var_ch_halt
        and     var_ch_halt+1
        and     var_ch_halt+3
        and     var_ch_halt+5
        cmp     #$FF
        bne     music_skipped
        lda     #$00
        sta     var_next_track
        sta     var_current_track
        rts

reset_channel:
        lda     #$00
        sta     var_ch_detune,x
        sta     var_ch_pitch_high,x
        sta     var_ch_pitch_low,x
        sta     var_ch_octave,x
        sta     var_ch_repeat_point_count,x
        sta     var_ch_repeat_point,x
        sta     var_ch_volume_slide_timer,x
        sta     var_ch_volume_slide_speed,x
        sta     var_ch_volume_slide,x
        sta     var_ch_envelope_pos,x
        sta     var_ch_envelope_len,x
        sta     var_ch_repeat,x
        sta     var_ch_slide,x
        sta     var_ch_sweep,x
        sta     var_ch_note_len,x
        sta     var_ch_volume,x
        lda     #$80
        sta     var_ch_envelope_select,x
        lda     var_ch_pattern_ptr_low,x
        sta     var_ptr_pattern
        lda     var_ch_pattern_ptr_high,x
        sta     var_ptr_pattern+1
        ldy     #$00
        lda     (var_ptr_pattern),y
        iny
        and     #$0F
        sta     var_ch_update_speed,x
        sta     var_ch_update_timer,x
        lda     (var_ptr_pattern),y
        iny
        ror     a
        ror     a
        ror     a
        and     #$C0
        sta     var_temp_F0
        lda     (var_ptr_pattern),y
        ora     var_temp_F0
        sta     var_ch_volume,x
        iny
        lda     (var_ptr_pattern),y
        iny
        sta     var_ch_sweep,x
        lda     #$02
        sta     var_ch_halt,x
        bne     read_music_command
read_music_command_start:
        lda     var_ch_pattern_ptr_low,x
        sta     var_ptr_pattern
        lda     var_ch_pattern_ptr_high,x
        sta     var_ptr_pattern+1
        ldy     var_ch_pattern_pos,x
read_music_command:
        lda     (var_ptr_pattern),y
        iny
        cmp     #$F0
        bcs     command_FX
        cmp     #$E0
        bcs     command_EX
        cmp     #$D0
        bcs     command_DX
        cmp     #$C0
        bcs     command_CX
        cmp     #$B0
        bcs     command_BX
        jmp     command_note

command_DX:
        and     #$0F
        bpl     command_DX_EX_common
command_EX:
        and     #$0F
        eor     #$FF
        clc
        adc     #$01
command_DX_EX_common:
        sta     var_ch_volume_slide,x
        lda     (var_ptr_pattern),y
        iny
        sta     var_ch_volume_slide_speed,x
        sta     var_ch_volume_slide_timer,x
        jmp     read_music_command

command_FX:
        stx     var_temp_F6
        eor     #$FF
        asl     a
        tax
        lda     COMMAND_FX_TABLE,x
        sta     var_temp_F0
        lda     COMMAND_FX_TABLE+1,x
        sta     var_temp_F0+1
        ldx     var_temp_F6
        lda     (var_ptr_pattern),y
        iny
        jmp     (var_temp_F0)

command_CX:
        and     #$0F
        sta     var_temp_F0
        lda     var_ch_volume,x
        and     #$10
        beq     command_skip
        lda     (var_ptr_pattern),y
        sta     var_ch_envelope_len,x
        lda     var_ch_envelope_select,x
        and     #$80
        ora     var_temp_F0
        sta     var_ch_envelope_select,x
command_skip:
        iny
        jmp     read_music_command

command_BX:
        and     #$0F
        beq     @do_repeat
        sec
        sbc     #$01
        beq     command_skip
        dec     var_ch_repeat,x
        beq     command_skip
        bpl     @do_repeat
        sta     var_ch_repeat,x
@do_repeat:
        lda     (var_ptr_pattern),y
        dey
        asl     a
        sty     var_temp_pattern_pos
        clc
        adc     var_temp_pattern_pos
        tay
        jmp     read_music_command

note_noise:
        lda     var_temp_F0
        sta     var_ch_pitch_low,x
        ldy     #$03
        jmp     noise_pitch_skip

command_note:
        sta     var_temp_F0
        lda     (var_ptr_pattern),y
        iny
        sty     var_temp_pattern_pos
        sta     var_ch_note_len,x
        lda     #$00
        sta     var_ch_envelope_pos,x
        cpx     #$03
        beq     note_noise
        cpx     #$04
        beq     note_noise
        lda     var_temp_F0
        bne     @load_pitch
        jmp     channel_off
@load_pitch:
        and     #$0F
        asl     a
        tay
        lda     TUNING_TABLE,y
        sta     var_ch_pitch_low,x
        lda     TUNING_TABLE+1,y
        sta     var_ch_pitch_high,x
        lda     var_temp_F0
        lsr     a
        lsr     a
        lsr     a
        lsr     a
        sta     var_ch_octave,x
        cpx     #$05
        beq     sweep_ch_1_override_skip
        cpx     #$01
        beq     sweep_ch_1_override
        ldy     CHANNEL_SELECT,x
        lda     var_ch_sweep,x
        sta     $4001,y
sweep_ch_1_override_skip:
        ldy     var_current_channel
noise_pitch_skip:
        lda     CHANNEL_ON,x
        ora     var_channel_mask
        jsr     channel_mask_apply
        jsr     volume_apply
        lda     var_ch_pitch_low,x
        sta     var_temp_F3
        lda     var_ch_pitch_high,x
        sta     var_temp_F4
load_pitch_finish:
        ldy     var_ch_octave,x
        beq     @octave_ready
@raise_octave:
        lsr     var_temp_F4
        ror     var_temp_F3
        dey
        bne     @raise_octave
@octave_ready:
        cpx     #$01
        beq     freq_ch_1_override
freq_low_apply:
        ldy     CHANNEL_SELECT,x
        lda     var_ch_detune,x
        bmi     @detune_negative
        adc     var_temp_F3
        sta     $4002,y
        lda     #$00
        beq     freq_high_apply
@detune_negative:
        adc     var_temp_F3
        sta     $4002,y
        lda     #$FF
freq_high_apply:
        adc     var_temp_F4
        and     #$07
        ora     #$08
        stx     var_temp_F6
        ldx     var_current_channel
        cmp     var_ch_freq_high,x
        beq     @freq_high_write_skip
        sta     var_ch_freq_high,x
        sta     $4003,y
@freq_high_write_skip:
        ldx     var_temp_F6
        rts

sweep_ch_1_override:
        ldy     #$FF
        cpy     var_ch_halt+2
        bne     sweep_ch_1_override_skip
        lda     var_ch_sweep+1
        sta     $4005
        ldy     #$01
        jmp     noise_pitch_skip

freq_ch_1_override:
        ldy     #$FF
        cpy     var_ch_halt+2
        beq     freq_low_apply
        rts

slide:  lda     var_ch_slide,x
        clc
        bmi     @negative
        adc     var_ch_pitch_low,x
        sta     var_ch_pitch_low,x
        lda     var_ch_pitch_high,x
        adc     #$00
        jmp     slide_apply
@negative:
        adc     var_ch_pitch_low,x
        sta     var_ch_pitch_low,x
        lda     var_ch_pitch_high,x
        adc     #$FF
slide_apply:
        sta     var_ch_pitch_high,x
        lda     var_ch_pitch_low,x
        sta     var_temp_F3
        lda     var_ch_pitch_high,x
        sta     var_temp_F4
        lda     var_ch_sweep,x
        bne     volume_apply
        jsr     load_pitch_finish
volume_apply:
        lda     var_ch_envelope_select,x
        and     #$7F
        bne     apply_envelope
        ldy     CHANNEL_SELECT,x
        lda     var_ch_volume,x
        and     #$10
        asl     a
        ora     var_ch_volume,x
        cpx     #$01
        beq     volume_ch_1_override
        sta     $4000,y
        rts
volume_ch_1_override:
        ldy     #$FF
        cpy     var_ch_halt+2
        bne     @skip
        sta     $4004
@skip:  rts

; A = var_ch_envelope_select,x & $7F ; A != 0
apply_envelope:
        sec
        sbc     #$01
        asl     a
        asl     a
        asl     a
        sta     var_temp_F2
        lda     var_ch_envelope_len,x
        sta     var_temp_F5
        lda     var_ch_envelope_pos,x
        sta     var_temp_F3
; 4-bit divide: F3 / (F5 >> 4) ; note that F5 is premultiplied by 16
        ldy     #$04
        lda     #$00
        sta     var_temp_F4
@divide_loop:
        asl     var_temp_F3
        lda     var_temp_F3
        sec
        sbc     var_temp_F5
        bcc     @divide_carry
        sta     var_temp_F3
@divide_carry:
        rol     var_temp_F4
        dey
        bne     @divide_loop
        lda     var_temp_F4
; divide result: A = F3 / (F5 >> 4)
        lsr     a
        php
        clc
        adc     var_temp_F2
        tay
; this is a curious way to access the ENVELOPE_TABLE, probably the programmer had planned for multiple tables
        lda     #<ENVELOPE_TABLE
        sta     var_temp_F0
        lda     #>ENVELOPE_TABLE
        sta     var_temp_F0+1
        lda     (var_temp_F0),y
        plp
        bcc     @high_nibble
        asl     a
        asl     a
        asl     a
        asl     a
; even frames use the high nibble from the envelope table
@high_nibble:
        sta     var_temp_F3
        lda     var_ch_volume,x
        and     #$0F
        sta     var_temp_F5
; 4-bit multiply: (F3 >> 4) * F5 ; note that F3 is premultiplied by 16
        ldy     #$04
        lda     #$00
@multiply_loop:
        asl     a
        asl     var_temp_F3
        bcc     @multiply_carry
        adc     var_temp_F5
@multiply_carry:
        dey
        bne     @multiply_loop
; multiply result: A = (F3 >> 4) * F5)
        ldy     CHANNEL_SELECT,x
        lsr     a
        lsr     a
        lsr     a
        lsr     a
        sta     var_temp_F4
        lda     var_ch_volume,x
        and     #$C0
        ora     #$30
        ora     var_temp_F4
        cpx     #$01
        beq     volume_ch_1_override
        sta     $4000,y
        rts

slide_triangle:
        lda     var_ch_slide+5
        clc
        bmi     @negative
        adc     var_ch_pitch_low+5
        sta     var_ch_pitch_low+5
        lda     var_ch_pitch_high+5
        adc     #$00
        jmp     @store_high
@negative:
        adc     var_ch_pitch_low+5
        sta     var_ch_pitch_low+5
        lda     var_ch_pitch_high+5
        adc     #$FF
@store_high:
        sta     var_ch_pitch_high+5
        lda     var_ch_pitch_low+5
        sta     var_temp_F3
        lda     var_ch_pitch_high+5
        sta     var_temp_F4
        jsr     load_pitch_finish
        lda     var_ch_volume+5
        and     #$7F
        sta     $4008
        rts

channel_off:
        ldy     var_current_channel
        lda     CHANNEL_OFF,x
        and     var_channel_mask
channel_mask_apply:
        cpx     #$01
        beq     channel_mask_ch_1_override
        sta     var_channel_mask
        sta     $4015
        lda     #$00
        sta     var_ch_freq_high,y
        rts

channel_mask_ch_1_override:
        ldy     #$FF
        cpy     var_ch_halt+2
        bne     @skip
        sta     var_channel_mask
        sta     $4015
        lda     #$00
        sta     var_ch_freq_high+1
@skip:  rts

; pause channel
command_FF:
        lda     #$FF
        sta     var_ch_halt,x
        jmp     channel_off

; set envelope
command_F5:
        cmp     #$00
        beq     @skip
        lda     #$80
@skip:  sta     var_ch_envelope_select,x
        jmp     read_music_command

; set duty
command_FD:
        cpx     #$05
        beq     @skip
        and     #$03
        clc
        ror     a
        ror     a
        ror     a
        sta     var_temp_F0
        lda     var_ch_volume,x
        and     #$1F
        ora     var_temp_F0
@skip:  sta     var_ch_volume,x
        jmp     read_music_command

; set repeat point
command_FC:
        tya
        sta     var_ch_repeat_point,x
        jmp     read_music_command

; use repeat point
command_FB:
        cmp     #$00
        beq     @repeat_point
        inc     var_ch_repeat_point_count,x
        cmp     var_ch_repeat_point_count,x
        bne     @repeat_point
        lda     #$00
        sta     var_ch_repeat_point_count,x
        jmp     read_music_command
@repeat_point:
        ldy     var_ch_repeat_point,x
        jmp     read_music_command

; set channel speed
command_FA:
        and     #$0F
        sta     var_ch_update_speed,x
        sta     var_ch_update_timer,x
; empty
command_FE:
        jmp     read_music_command

; set volume
command_F9:
        cpx     #$05
        beq     @skip
        sta     var_temp_F0
        lda     var_ch_volume,x
        and     #$C0
        ora     var_temp_F0
@skip:  sta     var_ch_volume,x
        jmp     read_music_command

; set detune
command_F8:
        sta     var_ch_detune,x
        jmp     read_music_command

; set slide
command_F7:
        sta     var_ch_slide,x
        jmp     read_music_command

; set sweep
command_F6:
        sta     var_ch_sweep,x
        jmp     read_music_command

; set DMC target
command_F4:
        asl     a
        sta     var_dmc_target
        jmp     read_music_command

; set next track
command_F3:
        ora     #$80
        sta     var_next_track
        lda     #$00
        sta     var_current_track
        rts

; data tables

TUNING_TABLE:
        .word   $06AE,$064E,$05F4,$059E
        .word   $054D,$0501,$04B9,$0475
        .word   $0435,$03F9,$03C0,$038A
; $4015 register flag for channel on
CHANNEL_ON:
        .byte   $01,$02,$02,$08,$08,$04
; $4015 register flag for channel off
CHANNEL_OFF:
        .byte   $0E,$0D,$0D,$07,$07,$0B
; $400X register offset for channels
CHANNEL_SELECT:
        .byte   $00,$04,$04,$0C,$0C,$08
COMMAND_FX_TABLE:
        .addr   command_FF
        .addr   command_FE
        .addr   command_FD
        .addr   command_FC
        .addr   command_FB
        .addr   command_FA
        .addr   command_F9
        .addr   command_F8
        .addr   command_F7
        .addr   command_F6
        .addr   command_F5
        .addr   command_F4
        .addr   command_F3
UNKNOWN_FE0F:
        .byte   $80,$40,$20,$10
FADE_TABLE_LOW:
        .byte   <FADE_PATTERN_0
        .byte   <FADE_PATTERN_1
FADE_TABLE_HIGH:
        .byte   >FADE_PATTERN_0
        .byte   >FADE_PATTERN_1
FADE_PATTERN_0:
        .byte   $09,$08,$07,$06,$05,$04,$03,$02
        .byte   $01,$00,$FF
FADE_PATTERN_1:
        .byte   $09,$81,$08,$81,$07,$81,$06,$81
        .byte   $05,$81,$04,$81,$03,$81,$02,$81
        .byte   $01,$81,$00,$FF
DMC_FADE:
        .byte   $78,$70,$68,$60,$58,$50,$48,$40
        .byte   $38,$30,$28,$20,$18,$10,$08,$00

PADDING_FE46:
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE,$F0,$FE,$D0,$FE,$F0,$FE
        .byte   $D0,$FE
UNKNOWN_FEF0:
        .byte   $4C,$A4,$F6,$4C,$90,$F4,$4C,$78
        .byte   $F4,$FE,$D0,$FE,$F0,$FE,$D0,$FE
        .byte   $4C,$00,$8C,$4C,$51,$8C,$4C,$33
        .byte   $8C,$4C,$BA,$92,$4C,$2A,$8E,$4C
        .byte   $B1,$8C,$4C,$63,$8E,$4C,$92,$8C
        .byte   $4C,$A7,$8E,$4C,$22,$90,$4C,$FE
        .byte   $91,$4C,$2F,$92,$4C,$9C,$92,$4C
        .byte   $A6,$8C,$4C,$D6,$91,$4C,$CC,$83
        .byte   $4C,$C1,$E5,$4C,$D3,$E5,$4C,$98
        .byte   $99
PADDING_FF39:
        .byte   $FE,$D0,$FE,$F0,$FE,$D0,$FE,$F0
        .byte   $FE,$D0,$FE,$F0,$FE,$D0,$FE,$F0
        .byte   $FE,$D0,$FE,$F0,$FE,$D0,$FE,$F0
        .byte   $FE,$D0,$FE,$F0,$FE,$D0,$FE,$F0
        .byte   $FE,$D0,$FE,$F0,$FE,$D0,$FE,$F0
        .byte   $FE,$D0,$FE,$F0,$FE,$D0,$FE,$F0
        .byte   $FE,$D0,$FE,$F0,$FE,$D0,$FE,$F0
        .byte   $FE,$D0,$FE,$F0,$FE,$D0,$FE,$F0
        .byte   $FE,$D0,$FE,$F0,$FE,$D0,$FE,$F0
        .byte   $FE,$D0,$FE,$F0,$FE,$D0,$FE,$F0
        .byte   $FE,$D0,$FE,$F0,$FE,$D0,$FE,$F0
        .byte   $FE,$D0,$FE,$F0,$FE,$D0,$FE,$F0
        .byte   $FE,$D0,$FE,$F0,$FE,$D0,$FE
UNKNOWN_FFA0:
        .byte   $78,$A9,$08,$8D,$00,$20,$D8,$A2
        .byte   $FF,$9A,$4C,$1A,$E0,$48,$8A,$48
        .byte   $98,$48,$4C,$02,$80,$48,$8A,$48
        .byte   $98,$48,$4C,$04,$85
PADDING_FFBD:
        .byte   $FE,$D0,$FE,$F0,$FE,$D0,$FE,$F0
        .byte   $FE,$D0,$FE,$F0,$FE,$D0,$FE,$F0
        .byte   $FE,$D0,$FE,$F0,$FE,$D0,$FE,$F0
        .byte   $FE,$D0,$FE,$F0,$FE,$D0,$FE,$F0
        .byte   $FE,$D0
        .byte   $FE

; 32 bytes deleted to make room for NSF stub
.segment "DELETE"
DELETED_FFE0:
        .byte   $00,$00,$00,$00,$00,$53,$54,$41
        .byte   $52,$54,$52,$4F,$50,$49,$43,$53
        .byte   $00,$00,$FF,$FF,$33,$04,$01,$0A
        .byte   $01,$00,$AD,$FF,$A0,$FF,$B5
        .byte   $FF

; end of file
